bump:
	;a0: EP-structure
	move.l	a0,a6

	;multiplikationstabellen
	move.w	#-320*45,d0
	lea		mul320(pc),a0
	suba.l	#2*45,a0
	move.w	#90-1,d1
make_mul320_tab:
	move.w	d0,(a0)+
	add.w	#320,d0
	dbf		d1,make_mul320_tab


    move.l	176(a6),a0	;multiplikationsfaktor bestimmen
    moveq.l	#1,d0
    jsr		(a0)
    move.l	d0,d6		;d6: multiplikationsfaktor

	move.w	d6,d5
	muls.w	#-96,d5
	lea		mulfak(pc),a0
	suba.l	#96*2,a0
	move.w	#96*2-1,d1
make_mulfak_tab:
	move.w	d5,d4
	asr.w	#7,d4
	move.w	d4,(a0)+
	add.w	d6,d5
	dbf		d1,make_mulfak_tab

	movea.l 172(A6),A4      ;get lightsource
	move.l  #1,D0
	jsr     (a4)
	movea.l	188(a6),a3
	jsr		(a3)
	move.l	a0,a5			;a5: lightadress
                
	move.l	#2,d0
	jsr		(a4)
	jsr		(a3)
	move.l	a0,a4			;a4: bumpmap
    
	move.l	152(a6),a3
	move.l	#320,d0
	move.l	#240,d1
	lea		picname(PC),a0
	clr.l	a1
	jsr		(a3)
    
    cmpa.l	#0,a0
    beq		bump_end 
                
    move.l	a0,a3			;a3: zielbild
    
    movem.l	a3-a5,-(sp)

    move.l	176(a6),a0	;diagonalshift bestimmen
    moveq.l	#2,d0
    jsr		(a0)
    move.l	d0,a2

    ;bumpmap machen
    moveq.l	#0,d5		;pixelnummer
    move.l	#320*239,d7	;loopcounter
    lea		mul320(pc),a0
    lea		mulfak(pc),a1
    move.w	#%11111,d6
make_bumpdreck_loop:

	move.w	(a4)+,d0
	move.w	d0,d1
	lsr.w	#6,d1
	move.w	d1,d2
	lsr.w	#5,d2
	and.w	d6,d0
	and.w	d6,d1
	add.w	d2,d1
	add.w	d1,d0			;d0: helligkeit des aktuellen pixels
	
	move.w	(a4),d1
	move.w	d1,d2
	lsr.w	#6,d2
	move.w	d2,d3
	lsr.w	#5,d3
	and.w	d6,d1
	and.w	d6,d2
	add.w	d3,d2
	add.w	d2,d1			;d1: helligkeit des rechten pixels
	
	move.w	640-2(a4),d2
	move.w	d2,d3
	lsr.w	#6,d3
	move.w	d3,d4
	lsr.w	#5,d4
	and.w	d6,d2
	and.w	d6,d3
	add.w	d4,d3
	add.w	d3,d2			;d2: helligkeit des unteren pixels
	
	move.w	d0,d4			;helligkeit des akt.pixels
	sub.w	a2,d4			;- diagonalshift
	move.w	(a1,d4.w*2),d4	;* multiplikationsfaktor
	
	move.w	d0,d3
	sub.w	d1,d0			;d0: horiz. helligkeitsdifferenz
	add.w	d4,d0
	cmpi.w	#45,d0
	ble		hval_lt_max
	move.w	#45,d0
hval_lt_max:
	cmpi.w	#-45,d0
	bge		hval_ge_min
	move.w	#-45,d0
hval_ge_min:

	sub.w	d2,d3			;d3: vert. helligkeitsdifferenz
	add.w	d4,d3
	cmpi.w	#45,d3
	ble		vval_lt_max
	move.w	#45,d3
vval_lt_max:	
	cmpi.w	#-45,d3
	bge		vval_ge_min
	move.w	#-45,d3
vval_ge_min:
	
	move.w	(a0,d3.w*2),d3	;320 * vdiff
	add.w	d0,d3			;+ hdiff
	
	move.w	d3,d4
	ext.l	d4
	add.l	d5,d4
	bge		ge_zero
min:add.w	#320,d3
	add.l	#320,d4
	blt		min
ge_zero:
max:cmpi.l	#320*239,d4
	blt		lt_max
	sub.w	#320,d3
	sub.l	#320,d4
	bra		max
lt_max:
	
	asl.w	d3
	move.w	d3,(a3)+

	addq.l	#1,d5
	subq.l	#1,d7
	bge		make_bumpdreck_loop
	movem.l	(sp)+,a3-a5	

	;lightsource ber bumpmap legen
	movem.l	a3-a5,-(sp)
	move.l	#320*240,d7
hau_licht_drauf_loop:
	move.w	(a3),d0
	beq		kein_licht
	move.w	(a5,d0.w),(a3)
kein_licht:
	addq.w	#2,a3
	addq.w	#2,a5
	subq.l	#1,d7
	bge 	hau_licht_drauf_loop
	
	movem.l	(sp)+,a3-a5

bump_end:
	rts                
                
picname: dc.b 10,"PUUHMB.XGA"
	EVEN
		ds.w	50
mul320: ds.w    50

		ds.w	100
mulfak: ds.w	100
               