{$L PRG.INC\BLK_EDIT.O}{PROZEDUR ZUM EINFGEN EINES BLOCKES IN EIN BILD}	
PROCEDURE Blked_Paste(dest_x,dest_y:LongInt;blkadr,scradr:Pointer);EXTERNAL;			
{PROZEDUR VERTAUSCHT BILDAUSSCHNITT MIT BLOCKSPEICHER (GLEICH GROSS)}
PROCEDURE Blked_Flip(x,y:LongInt;blkadr,scradr:Pointer);EXTERNAL;			
{$L PRG.INC\BLK_NEG.O}{PROZEDUR ZUM NEGIEREN EINES BILDBEREICHES}
PROCEDURE Blked_Neg(x1,x2,w,h:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\BLK_ANTI.O}{PROZEDUR ZUM ANTIALIASEN EINES BILDBEREICHES}
PROCEDURE Blked_Antia(x1,x2,w,h:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\BLK_H_M.O}{PROZEDUR ZUM HORIZONTALEN SPIEGELN EINES BILDBEREICHES}
PROCEDURE HorizMirr(x1,y1,x2,y2:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\BLK_V_M.O}{PROZEDUR ZUM VERTIKALEN SPIEGELN EINES BILDBEREICHES}
PROCEDURE VertMirr(x1,y1,x2,y2:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\SCALE.O}{PROZEDUR ZUM BERECHNEN EINER BILDSKALIERUNG}
PROCEDURE Calc_ScalePic(new_b,new_h:LongInt);EXTERNAL;
{PROZEDUR ZUM PREVIEW-ZEICHNEN DER BERECHNETEN SKALIERUNG}
PROCEDURE Prev_ScalePic(picadr,scradr:Pointer);EXTERNAL;
{PROZEDUR ZUM ENTGLTIGEN ZEICHNEN DER BERECHNETEN SKALIERUNG}
PROCEDURE Draw_ScalePic(picadr,scradr:Pointer);EXTERNAL;
{$L PRG.INC\GOOD_ROT.O}{PROZEDUR ZUM ROTIEREN DES BILDES}
PROCEDURE Rotation(wkl:LongInt;sintab,costab,pic,scr:Pointer);EXTERNAL;
{$L PRG.INC\PREV_ROT.O}{PROZEDUR ZUM PREVIEW ROTIEREN DES BILDES}
PROCEDURE Pre_Rotation(wkl:LongInt;sintab,costab,pic,scr:Pointer);EXTERNAL;

{BLOCKEDITOR}
PROCEDURE Blk_Edit(blk_adr:Pointer);
VAR
		mx,my		:LongInt;
		omx,omy		:LongInt;
		key			:Char;
		keycode		:LongInt;
		i			:LongInt;
		bx1,by1		:LongInt;
		bx2,by2		:LongInt;
		bw,bh		:LongInt;
		x,y,w,h		:LongInt;
		kf			:LongInt;
		
	PROCEDURE GetXYWH;
	VAR	t			:LongInt;
	BEGIN
		REPEAT Delay(10) UNTIL mb=0;
		omx:=MousePosX;
		omy:=MousePosY;
		x:=omx;
		y:=omy;
		Hide_Mouse;
		RubRect(x,y,omx,omy,scr);
		{Warteschleife}
		REPEAT
			mx:=MousePosX;
			my:=MousePosY;
			IF (mx<>omx) OR (my<>omy) THEN BEGIN
				RubRect(x,y,omx,omy,scr);
				RubRect(x,y,mx,my,scr);
				omx:=mx;
				omy:=my;
			END;
		UNTIL mb<>0;
		
		{Rechteck lschen}
		RubRect(x,y,mx,my,scr);
		
		{evntl.Koordinaten tauschen}
		IF x>mx THEN BEGIN t:=mx;mx:=x;x:=t;END;
		IF y>my THEN BEGIN t:=my;my:=y;y:=t;END;
		
		{Koordinaten gegebenenfalls an Blockgre anpassen}
		IF x<bx1 THEN x:=bx1;
		IF y<by1 THEN y:=by1;
		IF x>bx2 THEN x:=-1;
		IF y>by2 THEN x:=-1;
		IF mx>bx2 THEN mx:=bx2;
		IF my>by2 THEN my:=by2;
		IF mx<bx1 THEN x:=-1;
		IF my<by1 THEN x:=-1;
		
		{Breite und Hhe berechnen}
		w:=mx-x+1;
		h:=my-y+1;
		
		IF mb=2 THEN x:=-1;
	END;
	
	PROCEDURE Draw_WH_Percent;
	BEGIN
		Num_Output(5,225,Trunc(100*w/320),4,3+16,scr);
		Num_Output(5,233,Trunc(100*h/240),4,4+16,scr);
	END;

BEGIN
  SetMouseGrid(1,1);
  WITH par DO IF (blkedmode=BLKSIZE) OR (blkedmode=ROTATE) THEN CASE blkedmode OF
	  BLKSIZE: BEGIN
	  {Wenn Skaliermodus aktiv...}
		Hide_Mouse;
		{Orginale Blockausmae}
		bw:=Blk_GetW(blk_adr);
		bh:=Blk_GetH(blk_adr);
		{Block in sichtbaren Screen und unsichtbaren Pufferscreen zeichnen}
		Blked_Paste(0,0,blk_adr,scr);
		MemDFast(zoomscr,3200);
		Blked_Paste(0,0,blk_adr,zoomscr);
		{Orginalabmessungen}
		w:=319;omx:=319;
		h:=239;omy:=239;
		SetMousePos(160,120);
		REPEAT 
			{Tastendrcke abfangen...}
			key:=#255;keycode:=0;
			FOR i:=1 TO 20 DO IF PressedKey THEN BEGIN
				keycode:=Crawcin;
				key:=Char(keycode);
			END;
			IF (KbShift(-1) AND 2) <> 0 THEN BEGIN
				Draw_WH_Percent;
				VSync;
				Draw_WH_Percent;
			END;
			mx:=MousePosX;
			my:=MousePosY;
			{UNDO}
			IF keycode=6356992 THEN BEGIN
				{Calc_ScalePic(320,240);
				Draw_ScalePic(zoomscr,scr);}
				MemCFast(zoomscr,scr,3200);
				w:=319;h:=239;
				omx:=319;omy:=239;
			END;
			{Pfeil nach oben}
			IF keycode=4718592 THEN Dec(my);
			{Pfeil nach unten}
			IF keycode=5242880 THEN Inc(my);
			{Pfeil nach rechts}
			IF keycode=5046272 THEN Inc(mx);
			{Pfeil nach links}
			IF keycode=4915200 THEN Dec(mx);
			{Wenn Maus bewegt wurde -> Preview der Skalierung}
			IF (mx<>160) OR (my<>120) THEN BEGIN
				w:=w+(mx-160)*((w div 320 )+1);
				h:=h+(my-120)*((h div 240 )+1);
				SetMousePos(160,120);
				IF w<0 THEN w:=0;
				IF h<0 THEN h:=0;
				Calc_ScalePic(w,h);
				Prev_ScalePic(zoomscr,scr);
			END;
			{Druck auf linke Maustaste -> neue Gre bernehmen}
			IF mb=1 THEN BEGIN
				Calc_ScalePic(w,h);
				Draw_ScalePic(zoomscr,scr);
				omx:=w;
				omy:=h;
			END;
		UNTIL (mb=2) OR (key=#13);
		{Neue Ausmae des Blockes berechnen}
		Dec(bw);Dec(bh);
		bx2:=Trunc(omx*bw/320);
		IF bx2>=320 THEN bx2:=319;
		IF bx2<0 THEN bx2:=0;
		by2:=Trunc(omy*bh/240);
		IF by2>=240 THEN by2:=239;
		IF by2<0 THEN by2:=0;
		{richtige Skalierung zeichnen}
		Calc_ScalePic(omx,omy);
		Prev_ScalePic(zoomscr,scr);
		{neuen Block ausschneiden}
		Blk_Cut(0,0,bx2,by2,scr,blk_adr);
		REPEAT UNTIL mb=0;
	END;
  {Wenn Blockrotation aktiv...}
  ROTATE: BEGIN
  		{Block in die Bildmitte (Screen und Pufferscreen) zeichnen}
		Hide_Mouse;
		SetMouseRange(360*3,240);
		bw:=Blk_GetW(blk_adr);
		bh:=Blk_GetH(blk_adr);
		bx1:=160-(bw div 2);
		by1:=120-(bh div 2);
		bx2:=bx1+bw;
		by2:=by1+bh;
		Blked_Paste(bx1,by1,blk_adr,scr);
		MemDFast(zoomscr,3200);
  		Blked_Paste(bx1,by1,blk_adr,zoomscr);
  		MemCFast(scr,buffer,3200);
  		SetMousePos(360,120);x:=80;y:=0;
  		omx:=0;omy:=360;
		Line3(159-x,119-y,159+x,119+y,-1,scr);
		Line3(159,119,159+y,119-x,-1,scr);
  		REPEAT
  			IF omx<>MousePosX THEN BEGIN
	  			Line3(159-x,119-y,159+x,119+y,-1,scr);
	  			Line3(159,119,159+y,119-x,-1,scr);
  				REPEAT
  					omx:=MousePosX;
  					WHILE omx>=720 DO Dec(omx,360);WHILE omx<360 DO Inc(omx,360);
  					SetMousePos(omx,120);
  					Pre_Rotation(omx-360,@sintab,@costab,zoomscr,scr);
				UNTIL omx=MousePosX;
				x:=Round(80*cos(Pi*omx/180));
				y:=Round(80*sin(Pi*omx/180));
  				Line3(159-x,119-y,159+x,119+y,-1,scr);
  				Line3(159,119,159+y,119-x,-1,scr);
			END;
			{Rotation bei linker Maustaste zeichnen}
			IF mb=1 THEN BEGIN
				WHILE omx>=720 DO Dec(omx,360);WHILE omx<360 DO Inc(omx,360);
				SetMousePos(omx,120);
				Rotation(omx-360,@sintab,@costab,zoomscr,scr);				
				MemCFast(scr,buffer,3200);
				x:=Round(80*cos(Pi*omx/180));
				y:=Round(80*sin(Pi*omx/180));
  				Line3(159-x,119-y,159+x,119+y,-1,scr);
  				Line3(159,119,159+y,119-x,-1,scr);
				omy:=omx;
			END;
			{Tasten abfangen}
			WHILE PressedKey DO Crawcin;
  		UNTIL mb=2;
		Line3(159-x,119-y,159+x,119+y,-1,scr);
		Line3(159,119,159+y,119-x,-1,scr);
		{Pre_Rotation(omy-360,@sintab,@costab,zoomscr,scr);}
		MemCFast(buffer,scr,3200);
  		WHILE mb<>0 DO Delay(10);
		{Block aus Ergebnis ausschneiden}
  		SetMousePos(160,120);
  		SetMouseRange(320,240);
  		i:=0;bx1:=0;by1:=0;bx2:=319;by2:=239;
		mx:=MousePosX;my:=MousePosY;
		REPEAT
			omx:=mx;omy:=my;
			Faden(mx,my,scr);
			mx:=MousePosX;my:=MousePosY;
			IF mb=1 THEN BEGIN
				Faden(omx,omy,scr);
				GetXYWH;
				IF x<>-1 THEN BEGIN
					Hide_Mouse;
			  		Blk_Cut(x,y,x+w-1,y+h-1,scr,blk_adr);
			  		i:=1;
			 	END;
				WHILE mb<>0 DO Delay(10);
				Faden(omx,omy,scr);
			END;
			VSync;
			Faden(omx,omy,scr);
		UNTIL (mb=2) OR (i=1);
  		WHILE mb<>0 DO Delay(10);
  	END;
  END ELSE BEGIN
  {Ansonsten...}
	bw:=Blk_GetW(blk_adr);
	bh:=Blk_GetH(blk_adr);
	bx1:=160-(bw div 2);
	by1:=120-(bh div 2);
	bx2:=bx1+bw-1;
	by2:=by1+bh-1;
	Hide_Mouse;
	Blked_Paste(bx1,by1,blk_adr,scr);
	Rectang(bx1-1,by1-1,bx2+1,by2+1,0,1,scr);
	Show_Mouse;
	REPEAT
		mx:=MousePosX;my:=MousePosY;
		
		{Tastendrcke abfangen...}
		key:=#255;keycode:=0;
		FOR i:=1 TO 20 DO IF PressedKey THEN BEGIN
			keycode:=Crawcin;
			key:=Char(keycode);
		END;
		CASE keycode OF
		{UNDO}
			6356992: BEGIN
				Hide_Mouse;
			  	Blked_Flip(bx1,by1,blk_adr,scr);
				Show_Mouse;
			END;
		END;
		
		{linke Maustaste}
		IF mb=1 THEN BEGIN
			Hide_Mouse;
			Blk_Cut(bx1,by1,bx2,by2,scr,blk_adr);
			Show_Mouse;
			CASE blkedmode OF
			{Blockbereich negieren}
			NEGATIV: BEGIN
				Hide_Mouse;
				GetXYWH;
				IF x<>-1 THEN Blked_Neg(x,y,w,h,scr);
				Show_Mouse;
			  END;
			{Blockbereich antialiasen}
			ANTIA: BEGIN
			  	Hide_Mouse;
			  	GetXYWH;
			  	IF (x<>-1) AND (w>2) AND (h>2) THEN BEGIN
			  		Blked_Antia(x,y,w,h,scr);
			  		Delay(100);
			  		WHILE mb=1 DO Blked_Antia(x,y,w,h,scr);
			  	END;
			  	Show_Mouse;
			  END;
			{Block aus Block ausschneiden}
			BLKCUTBLK: BEGIN
				Hide_Mouse;
			  	GetXYWH;
			  	IF x<>-1 THEN BEGIN
			  		Blk_Cut(x,y,x+w-1,y+h-1,scr,blk_adr);
					MemClear(scr,38400);
					bw:=Blk_GetW(blk_adr);
  					bh:=Blk_GetH(blk_adr);
  					bx1:=160-(bw div 2);
  					by1:=120-(bh div 2);
  					bx2:=bx1+bw-1;
  					by2:=by1+bh-1;
					Blked_Paste(bx1,by1,blk_adr,scr);
  					Rectang(bx1-1,by1-1,bx2+1,by2+1,0,1,scr);
			  	END;
			  	Show_Mouse;
			  END;
			{Teil eines Blockes spiegeln}
			MIRR_X: BEGIN
				Hide_Mouse;
				GetXYWH;
				IF x<>-1 THEN BEGIN
					HorizMirr(x,y,x+w-1,y+h-1,scr);
			  	END;
			  	Show_Mouse;
			  END;
			{Teil eines Blockes spiegeln}
			MIRR_Y: BEGIN
				Hide_Mouse;
				GetXYWH;
				IF x<>-1 THEN BEGIN
					VertMirr(x,y,x+w-1,y+h-1,scr);
			  	END;
			  	Show_Mouse;
			  END;
			END;
			REPEAT Delay(10) UNTIL mb=0;
		END;
	UNTIL (key=#13) OR (mb=2);
	Hide_Mouse;
	Blk_Cut(bx1,by1,bx2,by2,scr,blk_adr);
	REPEAT Delay(10) UNTIL mb=0;
  END;
END;