{$L PRG.INC\TRP_SAVE.O}
FUNCTION GenerateTRP(x_res,y_res:LongInt;screen,ziel:Pointer):LongInt;EXTERNAL;
FUNCTION GenerateTRPBLK(blk,ziel:Pointer):LongInt;EXTERNAL;
{$L PRG.INC\TRU_SAVE.O}
FUNCTION GenerateTRU(x_res,y_res:LongInt;screen,ziel:Pointer):LongInt;EXTERNAL;
FUNCTION GenerateTRUBLK(blk,ziel:Pointer):LongInt;EXTERNAL;
{$L PRG.INC\PAL_SAVE.O}
FUNCTION GeneratePAL(palette,ziel:Pointer):LongInt;EXTERNAL;
{$L PRG.INC\G_P_SAVE.O}
FUNCTION GenerateGEMPAL(palette,ziel:Pointer):LongInt;EXTERNAL;

PROCEDURE SaveTRP(fh:LongInt);
VAR	trp_struct	:RECORD
		magic	:LongInt;
		hsize	:Word;
		vsize	:Word;
	END;
	size		:LongInt;
BEGIN
	WITH pic[par.actscr] DO BEGIN
		WITH trp_struct DO BEGIN
			magic:=1414681936;
			hsize:=rez_x;
			vsize:=rez_y;
		END;
		size:=rez_x;
		size:=size*rez_y*2;
		FWrite(fh,8,@trp_struct);
		FWrite(fh,size,adr);
	END;
END;


{PROZEDUR ZUM SICHERN EINES FILES}
PROCEDURE SaveFile(filetyp:Integer;pfad,name:String);
VAR		anz_bytes,fh	:LongInt;
		zielpfad		:String;
		fdir,fname,fext	:String;
BEGIN
	{ANZ_BYTES SPEICHERINHALT ABSPEICHERN}
	{Pfad generieren}
	FSplit(pfad,fdir,fname,fext);
	{fdir: Laufwerk+Pfad}	
	zielpfad:=fdir+name;
	{...zielpfad}
	
	{Speichern}
	fh:=FCreate(zielpfad,0);


	{FILE IM SPEICHER GENERIEREN}
	WITH pic[par.actscr] DO CASE filetyp OF
		XGA:	BEGIN
			MemCFast(adr,buffer,3200);
			anz_bytes:=rez_x*rez_y*2;
			FWrite(fh,anz_bytes,buffer);
		END;
		TRP:	BEGIN
			SaveTRP(fh);
		END;
		TRPBLK:	BEGIN
			anz_bytes:=GenerateTRPBLK(blkbuf,buffer);
			FWrite(fh,anz_bytes,buffer);
		END;
		TRU:	BEGIN
			anz_bytes:=GenerateTRU(rez_x,rez_y,adr,buffer);
			FWrite(fh,anz_bytes,buffer);
		END;
		TRUBLK:	BEGIN
			anz_bytes:=GenerateTRUBLK(blkbuf,buffer); 
			FWrite(fh,anz_bytes,buffer);
		END;
		PAL:	BEGIN
			anz_bytes:=GeneratePAL(pic[par.actscr].paladr,buffer);
			FWrite(fh,anz_bytes,buffer);
		END;
		GEMPAL:	BEGIN
			anz_bytes:=GenerateGEMPAL(pic[par.actscr].paladr,buffer);
			FWrite(fh,anz_bytes,buffer);
		END;
		EPP:	BEGIN
			MemCopy(pic[par.actscr].paladr,buffer,128);
			anz_bytes:=512;
			FWrite(fh,anz_bytes,buffer);
		END;
	END;

	FClose(fh);
END;

