PROCEDURE GetAdresses(slot:Integer);
VAR cnt:Integer;
BEGIN
	WITH epm[slot] DO BEGIN
	  {Strukturen aktualisieren}
	  FOR cnt:=1 TO anzpic DO BEGIN
		  x_resolutions[cnt]:=pic[cnt].rez_x;
		  y_resolutions[cnt]:=pic[cnt].rez_y;
		  pic_adresses[cnt]:=pic[cnt].adr;
		  pal_adresses[cnt]:=pic[cnt].paladr;
	  END;
	  
	  {und bergabestruktur machen}
	  WITH ep_struct DO BEGIN
	{0}		scre_adr:=scr;				{Screenadresse}
	{4}		scrx_adr:=@x_resolutions;	{Zeiger auf X-Auflsungen}
	{8}		scry_adr:=@y_resolutions;	{Zeiger auf Y-Auflsungen}
	{12}	scrn_adr:=@par.actscr;		{Zeiger auf akt.Screenummer}
	{16}	pics_adr:=@pic_adresses;	{Zeiger auf Bildadressen}
	{20}	buff_adr:=buffer;			{Speicherpufferadresse}
	{24}	pald_adr:=@pal_adresses;	{Adresse der Palettenadressen}
	{28}	mcpy_adr:=@MemCopy;			{Adresse der Speichercopyrout.}
	{32}	mclr_adr:=@MemClear;		{Adresse der Speicherlschr.}
	{36}	mflp_adr:=@MemFlip;			{Adresse der Speichertauschr.}
	{40}	setp_adr:=@SetPixel;		{Adresse der Pixelroutine}
	{44}	getp_adr:=@GetPixel;		{Adresse der GetPixelroutine}
	{48}	lin3_adr:=@Line5;			{Adresse der Line3Routine}
	{52}	rubr_adr:=@RubRect;			{Adresse der Gummirechteckr.}
	{56}	circ_adr:=@Circle;			{Adresse der Kreisroutine}
	{60}	fill_adr:=@Floodfill;		{Adresse der Floodfillr.}
	{64}	nbox_adr:=@NormBox;			{Adresse der Normalboxr.}
	{68}	blkc_adr:=@Blk_Cut;			{Adresse der BlkCutroutine}
	{72}	blkp_adr:=@Blk_DPut;		{Adresse der BlkPutroutine}
	{76}	blkw_adr:=@Blk_GetW;		{Adresse der GetBlkWidth-r.}
	{80}	blkh_adr:=@Blk_GetH;		{Adresse der GetBlkHigh-r.}
	{84}	blkr_adr:=@Blk_Restore_BG;	{Adresse der Blkrestorer.}
	{88}	blkf_adr:=@blkflag;			{Zeiger auf Blockflag}
	{92}	fkrz_adr:=@Faden;			{Adresse der Fadenkreuzr.}
	{96}	mshw_adr:=@Show_Mouse;		{Adresse der Show_Mouser.}
	{100}	mhid_adr:=@Hide_Mouse;		{Adresse der Hide_Mouser.}
	{104}	mset_adr:=@SetMousePos;		{Adresse der SetMousePosr.}
	{108}	mcur_adr:=@TakeCursor;		{Adresse der Cursorsetzrout.}
	{112}	mpsx_adr:=@MousePosX;		{Adresse der MousePosXrout.}
	{116}	mpsy_adr:=@MousePosY;		{Adresse der MousePosYrout.}
	{120}	mbut_adr:=@MB;				{Adresse der M(ouse)B(utton)r.}
	{124}	iced_adr:=@Ice_Decrunch_2;	{Adresse der Icedecrunchr.}
	{128}	actc_adr:=@actcol;			{Zeiger auf akt.Zeichenfarbe}
	{132}	tool_adr:=@par.acttool;		{Zeiger auf akt.Werkzeugnummer}
	{136}	styl_adr:=@draw_style;		{Zeiger auf akt.Zeichenmodus}
	{140}	mont_adr:=@mon;				{Zeiger auf Monitortyp}
	{144}   palc_adr:=@par.actpcn;		{Zeiger auf akt.Palettenindex}
	{148}	blck_adr:=@blkbuf;			{Zeiger auf Blockspeicher}
	{152}	mkep_adr:=@MakeNewPicture; 	{Adresse der MakeNewPic-Routine}
	{156}	picm_adr:=@GetFreePicMem;	{Adresse der GetFreePicMem-Routine}
	{160}	clrp_adr:=@ClearPic;		{Adresse der ClearPicRoutine}
	{164}	pshp_adr:=@PushPic;			{Adresse der PushPicRoutine}
	{168}	pllp_adr:=@PullPic;			{Adresse der PullPicRoutine}
	{172}	srcp_par:=@GetPicPop;		{Zeiger auf Rout.zum Ermitteln..}
	{176}	slid_par:=@GetSlider;		{..von eingestellten..}
	{180}	text_par:=@GetTextInput;	{..Modulparametern..}
	{184}	fsel_par:=@GetSelFile;		{..}
	{188}	pica_get:=@GetPicAdress;	{Ermitteln von Bildadressen}
	{192}	pala_get:=@GetPalAdress;	{Ermitteln von Palettenadressen}
	{196}	xres_get:=@GetPicXRes;		{Bildauflsung ermitteln..}
	{200}	yres_get:=@GetPicYRes;		{..}
	{204}	xvie_get:=@GetPicXView;		{Ermitteln des Bildsichtbereiches..}
	{208}	yvie_get:=@GetPicYView;		{..}
	{212}	view_set:=@SetViewPos;		{Setzen des Bildausschnittes}
	{216}	pres_set:=@SetPicRez;		{Setzen der Arbeitsauflsung}
	{220}	ores_set:=@SetPrgRez;		{Setzen der Originalauflsung}
	{224}	scra_set:=@SetScrAdr;		{Setzen der Screenadresse}
	{228}	{im GEM-Teil von EP}		{Fileselektorroutine}
	{232}	user_set:=@SuperOff;			{Schaltet Usermodus ein}
	{236}	supv_set:=@SuperOn;			{Schaltet Supervisormode ein}
	  END;
	END;
END;