{$L PRG.INC\MEMCOPY .O}	{KOPIERFUNKTION IM SPEICHER}
PROCEDURE MemCopy(sourceadr,destadr:Pointer;anz_long:LongInt);EXTERNAL;
{$L PRG.INC\MEMCLEAR.O} {LSCHFUNKTION IM SPEICHER}
PROCEDURE MemClear(adr:Pointer;anz_long:LongInt);EXTERNAL;
{$L PRG.INC\MEMFLIP.O} {TAUSCH VON SPEICHERINHALTEN}
PROCEDURE MemFlip(adr1,adr2:Pointer;anz_long:LongInt);EXTERNAL;
{$L PRG.INC\MEMCFAST.O} {48-BYTE-WEISE KOPIERFUNKTION IM SPEICHER}
PROCEDURE MemCFast(sourceadr,destadr:Pointer;anz_48Bytes:LongInt);EXTERNAL;
{$L PRG.INC\MEMDFAST.O} {48-BYTE-WEISE LSCHFUNKTION IM SPEICHER}
PROCEDURE MemDFast(adr:Pointer;anz_48Bytes:LongInt);EXTERNAL;

{$L PRG.INC\SUPERVIS.O}{SUPERVISORMODUS EIN/AUSSCHALTEN}
PROCEDURE SuperOn;EXTERNAL;
PROCEDURE SuperOff;EXTERNAL;

{$L PRG.INC\PICTURES.O} {PICTUREMANAGEMENT}
PROCEDURE PushVirtualScreen(offset,lineoffset:LongInt;scr,pic:Pointer);EXTERNAL;
PROCEDURE PullVirtualScreen(offset,lineoffset:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE FlipVirtualScreen(offset,lineoffset:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE ResizePicture(orgw,orgh,destw,desth:LongInt;src,dest:Pointer);EXTERNAL;

{MAUSCURSORDATEN LINKEN}
{$L INTERN\KREUZ1.O}
PROCEDURE Kreuz1;EXTERNAL;
{$L INTERN\KREUZ2.O}
PROCEDURE Kreuz2;EXTERNAL;
{$L INTERN\KREUZ3.O}
PROCEDURE Kreuz3;EXTERNAL;
{$L INTERN\KREUZ4.O}
PROCEDURE Kreuz4;EXTERNAL;
{$L INTERN\KREUZ5.O}
PROCEDURE Kreuz5;EXTERNAL;
{$L INTERN\PFEIL1.O}
PROCEDURE Pfeil1Dat;EXTERNAL;
{$L INTERN\QUAD01.O}
PROCEDURE Quad01Dat;EXTERNAL;
{$L INTERN\VERT01.O}
PROCEDURE Vert01Dat;EXTERNAL;
{$L INTERN\TEXTMAUS.O}
PROCEDURE TextCursor;EXTERNAL;

{SINUS UND COSINUSTABELLEN}
{$L PRG.INC\SINTAB.O}
PROCEDURE SinTab;EXTERNAL;
{$L PRG.INC\COSTAB.O}
PROCEDURE CosTab;EXTERNAL;

{PALETTEN LINKEN}
{$L INTERN\PALETTE.O}
PROCEDURE PalDat;EXTERNAL;

{$L PRG.INC\PAL_EDIT.O} {PALETTENEDITIERFUNKTIONEN}
FUNCTION Get_R(col:LongInt):Word;EXTERNAL;
FUNCTION Get_G(col:LongInt):Word;EXTERNAL;
FUNCTION Get_B(col:LongInt):Word;EXTERNAL;
FUNCTION Set_R(r,col:LongInt):LongInt;EXTERNAL;
FUNCTION Set_G(g,col:LongInt):LongInt;EXTERNAL;
FUNCTION Set_B(b,col:LongInt):LongInt;EXTERNAL;
PROCEDURE DrawPEOrgPic(opx,opy,xsize:LongInt;orgpic,scradr:Pointer);EXTERNAL;
PROCEDURE Draw_L_Red(x,y:LongInt;scradr:Pointer);EXTERNAL;
PROCEDURE Draw_L_Green(x,y:LongInt;scradr:Pointer);EXTERNAL;
PROCEDURE Draw_L_Blue(x,y:LongInt;scradr:Pointer);EXTERNAL;
PROCEDURE Draw_L_Black(x,y:LongInt;scradr:Pointer);EXTERNAL;

{PACKER}
{$L PRG.INC\SENTRY2.O}{PROZEDUR ZUM SENTRY-ENTPACKEN VON BILDERN}
PROCEDURE Sentry210(length:LongInt;adr:Pointer);EXTERNAL;
{$L PRG.INC\ICE_UNP2.O}{PROZEDUR ZUM ICE-ENTPACKEN VON BILDERN}
PROCEDURE Ice_Decrunch_2(adr:Pointer);EXTERNAL;

{$L PRG.INC\PALETTE.O} {RGB-WERT AUS PALETTE ERMITTELN}
FUNCTION SetColor(num:LongInt;paladr:Pointer):LongInt;EXTERNAL;
PROCEDURE DrawPalette(scradr,paladr:Pointer);EXTERNAL;
PROCEDURE DrawPalActCol(actcol:LongInt;scradr:Pointer);EXTERNAL;
PROCEDURE MarkPalCol(markcol,actpcn:LongInt;scradr:Pointer);EXTERNAL;
PROCEDURE SetNewRGB(num,newcol:LongInt;paladr:Pointer);EXTERNAL;
FUNCTION  PalSearch(color:LongInt;paladr:Pointer):LongInt;EXTERNAL;

{ZEICHENFUNKTIONEN}
{$L PRG.INC\PIXEL.O} {ZUM SETZEN EINES PIXELS}
PROCEDURE SetPixel(x,y,x_rez,col:LongInt;scradr:Pointer);EXTERNAL;
{ZUM ERMITTELN EINER PIXELFARBE}
FUNCTION GetPixel(x,y,x_rez:LongInt;scradr:Pointer):LongInt;EXTERNAL;
{$L PRG.INC\LINE3.O} {ZUM ZEICHNEN EINER LINIE}
PROCEDURE Line3(x1,y1,x2,y2,col:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\LINE4.O} {ZUM ZEICHNEN EINER LINIE}
PROCEDURE Line4(x1,y1,x2,y2,col:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\LINE5.O} {ZUM ZEICHNEN EINER STYLE-LINIE}
PROCEDURE Line5(x1,y1,x2,y2,col,style:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\RUBRECT.O}{ZUM RUBBERBOX-ZEICHNEN}
PROCEDURE RubRect(x1,y1,x2,y2:LongInt;scr:Pointer);EXTERNAL;
{$L PRG.INC\CIRC.O} {ZUM ZEICHNEN EINES KREISES}
PROCEDURE Circle(x1,y1,r,col,style:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\FILL.O} {ZUM FLLEN EINER FLCHE}
PROCEDURE FloodFill(x1,y1,col,mode:LongInt;scradr,stackadr:Pointer);EXTERNAL;
{$L PRG.INC\BOX.O} {ZUM ZEICHNEN EINES AUSGEFLLTEN RECHTECKES}
PROCEDURE NormBox(col,x1,y1,x2,y2:LongInt;scradr:Pointer);EXTERNAL;
{ZUM ZEICHNEN EINES AUSGEFLLTEN STYLE-RECHTECKES}
PROCEDURE DrawBox(col,x1,y1,x2,y2,style:LongInt;scradr:Pointer);EXTERNAL;
{$L PRG.INC\NUM_OUT.O} {ZUM ZEICHNEN EINER ZAHL}
PROCEDURE Num_OutPut(x,y,num,anznum,zeichen:LongInt;scradr:Pointer);EXTERNAL;

{TEXTFUNKTIONEN}
{$L INTERN\SYS_FONT.O}
PROCEDURE Sys_Font;EXTERNAL;
{$L PRG.INC\TEXT.O}{PROZEDUR ZUM ZEICHNEN EINES ZEICHENS}
PROCEDURE DrawChar(x,y,char,color:LongInt;fnt,scr:Pointer);EXTERNAL;
{PROZEDUR ZUM WIEDERHERSTELLEN DES HINTERGRUNDES}
PROCEDURE ClrChar(x,y,xrez:LongInt;pic,scr:Pointer);EXTERNAL;

{BLOCKFUNKTIONEN}
{$L PRG.INC\BLK_CUT.O} {ZUM AUSSCHNEIDEN EINES BLOCKES}
PROCEDURE Blk_Cut(x1,y1,x2,y2:LongInt;quelle,ziel:Pointer);EXTERNAL;
{LIEFERT BREITE DES BLOCKES}
FUNCTION Blk_GetW(blkadr:Pointer):Word;EXTERNAL;
{LIEFERT HHE DES BLOCKES}
FUNCTION Blk_GetH(blkadr:Pointer):Word;EXTERNAL;
{$L PRG.INC\BLK_PUT.O} {ZUM EINFGEN EINES BLOCKES}
PROCEDURE Blk_DPut(x,y:LongInt;blkbuf,zielscr:Pointer);EXTERNAL;		
{ZUM BEWEGEN EINES BLOCKES}
PROCEDURE Blk_DMov(xo,yo,xn,yn:LongInt;blkbuf,zielscr,actscr:Pointer);EXTERNAL;
{ZUM SETZEN DER PARAMETERFARBE FR EINIGE EINFGEMODI}
PROCEDURE Blk_Col(col:Word);EXTERNAL;
{ZUM deckenden Einfgen eines Blockes}
{$L PRG.INC\BLK_ORG.O} {ZUM WIEDERHERSTELLEN DES HINTERGRUNDES}
PROCEDURE Blk_Restore_Bg(mx,my:LongInt;blkbuf,scr,picadr:Pointer);EXTERNAL;

{$L PRG.INC\BUTTONS.O} {BUTTON-FUNKTIONEN}
PROCEDURE DrawButton(x,y,state:LongInt;butadr,scradr:Pointer);EXTERNAL;

{$L PRG.INC\FADEN.O} {ZEICHNET FADENKREUZ}
PROCEDURE Faden(x,y:LongInt;scradr:Pointer);EXTERNAL;

{BUTTONDATEN}
{$L BUTTONS\B_ROT.O}
PROCEDURE RedButton;EXTERNAL;
{$L BUTTONS\B_GRUEN.O}
PROCEDURE GreenButton;EXTERNAL;
{$L BUTTONS\B_BLAU.O}
PROCEDURE BlueButton;EXTERNAL;
{$L BUTTONS\B_WEISS.O}
PROCEDURE WhiteButton;EXTERNAL;
{$L BUTTONS\B_BLACK.O}
PROCEDURE BlackButton;EXTERNAL;
{$L BUTTONS\B_BLOCK.O}
PROCEDURE B_Block_Dat;EXTERNAL;
{$L BUTTONS\B_BOX.O}
PROCEDURE B_Box_Dat;EXTERNAL;
{$L BUTTONS\B_CIRCLE.O}
PROCEDURE B_Circle_Dat;EXTERNAL;
{$L BUTTONS\B_CUT.O}
PROCEDURE B_Cut_Dat;EXTERNAL;
{$L BUTTONS\B_DRAW.O}
PROCEDURE B_Draw_Dat;EXTERNAL;
{$L BUTTONS\B_FILL.O}
PROCEDURE B_Fill_Dat;EXTERNAL;
{$L BUTTONS\B_LINE.O}
PROCEDURE B_Line_Dat;EXTERNAL;
{$L BUTTONS\B_PALETT.O}
PROCEDURE B_Palett_Dat;EXTERNAL;
{$L BUTTONS\B_POLY.O}
PROCEDURE B_Poly_Dat;EXTERNAL;
{$L BUTTONS\B_RECT.O}
PROCEDURE B_Rect_Dat;EXTERNAL;
{$L BUTTONS\B_TEXT.O}
PROCEDURE B_Text_Dat;EXTERNAL;
{$L BUTTONS\B_ZOOM.O}
PROCEDURE B_Zoom_Dat;EXTERNAL;
{$L BUTTONS\B_RUNTER.O}
PROCEDURE B_Runter_Dat;EXTERNAL;
{$L BUTTONS\B_HOCH.O}
PROCEDURE B_Hoch_Dat;EXTERNAL;
{$L BUTTONS\B_LINKS.O}
PROCEDURE B_Links_Dat;EXTERNAL;
{$L BUTTONS\B_RECHTS.O}
PROCEDURE B_Rechts_Dat;EXTERNAL;
{$L BUTTONS\B_PLUS.O}
PROCEDURE B_Plus_Dat;EXTERNAL;
{$L BUTTONS\B_MINUS.O}
PROCEDURE B_Minus_Dat;EXTERNAL;
{$L BUTTONS\B_GRID.O}
PROCEDURE B_Grid_Dat;EXTERNAL;
{$L BUTTONS\B_3x3.O}
PROCEDURE B_3x3_Dat;EXTERNAL;
{$L BUTTONS\B_5x5.O}
PROCEDURE B_5x5_Dat;EXTERNAL;
{$L BUTTONS\B_7x7.O}
PROCEDURE B_7x7_Dat;EXTERNAL;
{$L BUTTONS\B_9x9.O}
PROCEDURE B_9x9_Dat;EXTERNAL;


{$L PRG.INC\NEO_ZOOM.O}
PROCEDURE DrawNeoZoom(x,y,magn,grid,typ,picxsize:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE NeoMove(x,y,xres,yres:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE NeoPicDraw(x,y,xres,yres:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE NeoPicFlip(x,y,xres,yres:LongInt;pic,scr:Pointer);EXTERNAL;
PROCEDURE NeoPicSave(x,y,xres,yres:LongInt;pic,scr:Pointer);EXTERNAL;

{$L PRG.INC\MAGXCOOK.O}	{CHECKS OUT THE COOKIE JAR FOR 'MagX'}
FUNCTION MagiCCheck:LongInt;EXTERNAL;

{$L PRG.INC\KEY_TST2.O}
FUNCTION GetKbState:LongInt;EXTERNAL;

{$L PRG.INC\RESOLUT.O}
PROCEDURE Set_Help_VGA;EXTERNAL;
PROCEDURE Set_Help_RGB;EXTERNAL;
PROCEDURE Set_Hi_RGB(xres,yres:LongInt);EXTERNAL;
PROCEDURE Set_Back_Hi_RGB;EXTERNAL;
