
{Neochrome Zoom}
PROCEDURE NeoChromeZoom;
VAR		but		:Array[0..30] OF RECORD
			x,y,w,h,state,typ:Integer;adr:Pointer;
			END;				{button data}
		cnt		:Integer;		{counter}
		dx,dy	:LongInt;		{differences}
		czf		:Integer;		{CrackZoomflag}
		blond	:LongInt;		{Dummy}
		i		:Integer;
		r,g,b	:Integer;		{aktuelle RGB-Werte}
		osup	:LongInt;		{Supervisoradr.}
		
CONST	ANZ_B	=24;

	{FUNKTION ZUM ERMITTELN DES BUTTONS AN DER POSITION P(X;Y)}
	FUNCTION WhichB(mx,my:LongInt):LongInt;
	VAR		i:LongInt;
	BEGIN
		{Default-Wert}
		WhichB:=-1;
		FOR i:=0 TO ANZ_B DO WITH but[i] DO BEGIN
			IF (mx>=x) AND (my>y) AND (mx<x+w) AND (my<=y+h) THEN WhichB:=i;
		END;
	END;
	
	PROCEDURE DrawActColors;
	BEGIN
		DrawPalette(zoomscr,paladr);
		NormBox(SetColor(par.actpcn,paladr),281,201,296,230,zoomscr);	
		NormBox(actcol,297,201,312,230,zoomscr);	
	END;

		
	PROCEDURE Draw_NeoScreen;
	VAR		cnt:Integer;
	BEGIN

		WITH pic[par.actscr] DO BEGIN
			NeoPicDraw(ppx,ppy,rez_x,rez_y,adr,zoomscr);
			NeoPicDraw(ppx,ppy,rez_x,rez_y,adr,scr);
		END;
		{unterer Bildteil}
		NormBox(14828,0,159,319,239,zoomscr);
		Draw_3D_Rect(0,159,319,239,zoomscr);
		
		{Zoom}
		Draw_3D_Rect(49+63+1,169+63+1,49-1,169-1,zoomscr);
		WITH but[0] DO BEGIN x:=5;y:=170;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Draw_Dat;END;
		WITH but[1] DO BEGIN x:=5;y:=178;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Line_Dat;END;
		WITH but[2] DO BEGIN x:=5;y:=186;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Poly_Dat;END;
		WITH but[3] DO BEGIN x:=5;y:=194;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Box_Dat;END;
		WITH but[4] DO BEGIN x:=5;y:=202;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Rect_Dat;END;
		WITH but[5] DO BEGIN x:=5;y:=5;w:=0;h:=0;typ:=0;END;{just shit}
		WITH but[6] DO BEGIN x:=5;y:=210;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Circle_Dat;END;
		WITH but[7] DO BEGIN x:=5;y:=218;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Fill_Dat;END;
		WITH but[8] DO BEGIN  x:=220;y:=200;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Plus_Dat;END;	
		WITH but[9] DO BEGIN  x:=236;y:=200;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Plus_Dat;END;
		WITH but[10] DO BEGIN x:=252;y:=200;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Plus_Dat;END;
		WITH but[11] DO BEGIN x:=220;y:=225;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Minus_Dat;END;
		WITH but[12] DO BEGIN x:=236;y:=225;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Minus_Dat;END;
		WITH but[13] DO BEGIN x:=252;y:=225;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Minus_Dat;END;
		WITH but[14] DO BEGIN x:=137+20;y:=212;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Links_Dat;END;
		WITH but[15] DO BEGIN x:=153+20;y:=212;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Rechts_Dat;END;
		WITH but[16] DO BEGIN x:=145+20;y:=204;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Hoch_Dat;END;
		WITH but[17] DO BEGIN x:=145+20;y:=220;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Runter_Dat;END;
		WITH but[18] DO BEGIN x:=118;y:=195;w:=16;h:=8;state:=0;typ:=1;adr:=@B_3x3_Dat;END;
		WITH but[19] DO BEGIN x:=118;y:=203;w:=16;h:=8;state:=0;typ:=1;adr:=@B_5x5_Dat;END;
		WITH but[20] DO BEGIN x:=118;y:=211;w:=16;h:=8;state:=0;typ:=1;adr:=@B_7x7_Dat;END;
		WITH but[21] DO BEGIN x:=118;y:=219;w:=16;h:=8;state:=0;typ:=1;adr:=@B_9x9_Dat;END;
		WITH but[22] DO BEGIN x:=118;y:=227;w:=16;h:=8;state:=0;typ:=1;adr:=@B_Grid_Dat;END;
		{Palette}
		WITH but[23] DO BEGIN x:=119;y:=169;w:=194;h:=22;typ:=2;END;
		{Zoom}
		WITH but[24] DO BEGIN x:=49;y:=169;w:=63;h:=63;typ:=2;END;
		
		{Buttonstati festlegen}
		IF par.zoomgrid=1 THEN but[22].state:=1;

		CASE par.zoommagn OF
			3: BEGIN but[18].state:=1;czsize:=63;END;
			5: BEGIN but[19].state:=1;czsize:=55;END;
			7: BEGIN but[20].state:=1;czsize:=63;END;
			9: BEGIN but[21].state:=1;czsize:=63;END;
		END;
		
		but[neotool].state:=1;

		{Buttons}
		FOR cnt:=0 TO 22 DO WITH but[cnt] DO IF typ=1 THEN DrawButton(x,y,state,adr,zoomscr);
		
		{Palette zeichnen}
		NormBox(0,119,169,313,191,zoomscr);
		Draw_3D_Rect(119,169,313,191,zoomscr);
		px:=119;py:=168;
		DrawPalette(zoomscr,paladr);
		MarkPalCol(65535,par.actpcn,zoomscr);
		
		{RGB}
		NormBox(22528,221,208,235,223,zoomscr);NormBox(0,221+4,208+5,235-4,223-6,zoomscr);
		r:=Get_R(SetColor(par.actpcn,paladr));Num_OutPut(221+4,208+5,r,2,0,zoomscr);
		NormBox(480,237,208,251,223,zoomscr);NormBox(0,237+4,208+5,251-4,223-6,zoomscr);
		g:=Get_G(SetColor(par.actpcn,paladr));Num_OutPut(237+4,208+5,g,2,0,zoomscr);
		NormBox(10,253,208,267,223,zoomscr);NormBox(0,253+4,208+5,267-4,223-6,zoomscr);
		b:=Get_B(SetColor(par.actpcn,paladr));Num_OutPut(253+4,208+5,b,2,0,zoomscr);
		
		{aktuelle Farbe}
		Draw_3D_Rect(280,200,313,231,zoomscr);
		DrawActColors;
		
		{Koordinaten}
{		Num_OutPut(0,228,MousePosX,3,1,zoomscr);
		Num_OutPut(0,234,MousePosY,3,2,zoomscr);}

		{Zoom erstma schwarz machen}
		NormBox(0,49+63,169+63,49,169,zoomscr);
	END;


BEGIN
	WITH pic[par.actscr] DO BEGIN
		IF ppx>rez_x-320 THEN ppx:=rez_x-320;
		IF ppy>rez_y-158 THEN ppy:=rez_y-158;
	END;
	{Supervisormode}
	osup:=Super(NIL);
	{Screen aufbauen}
	Draw_NeoScreen;
	MouseReset;
	SetScrAdr(zoomscr);
	SetMouseScreenAdr(zoomscr);
	Show_Mouse;
	{Usermode}
	Super(Pointer(osup));
	czx:=20;czy:=50;czf:=0;
	REPEAT
		VSync;
		IF MousePosY<158 THEN BEGIN
			{DrawNeoZoom(MousePosX,MousePosY,par.zoommagn,par.zoomgrid,0,Pointer(LongInt(scr)+ppy*640),zoomscr);}
			WITH pic[par.actscr] DO DrawNeoZoom(MousePosX,MousePosY,par.zoommagn,par.zoomgrid,0,320,scr,zoomscr);
			IF czf=1 THEN BEGIN
				czf:=0;TakeCursor(mousecurs[actmc]);SetActPoint(7,7);
				Hide_Mouse;
				RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
				Show_Mouse;
			END;				
		END ELSE IF czf=0 THEN BEGIN
			Hide_Mouse;
			RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
			TakeCursor(@Pfeil1Dat);SetActPoint(0,0);
			{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
			WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
			czf:=1;Show_Mouse;
		END;	
		key:=#255;
		keycode:=0;i:=99;
		WHILE PressedKey DO BEGIN
			keycode:=Cnecin;
			key:=Char(keycode);
		END;
		
		IF keycode<>0 THEN BEGIN
			blond:=1;
			CASE Upcase(key) OF
				{$I FKT.INC\RGB_MODI.I}
				'D': i:=0;		{Draw}
				'L': i:=1;		{Line}
				'P': i:=2;		{Poly}
				'B': i:=3;		{Box}
				'R': i:=4;		{Rect}
				'C': i:=6;		{Circ}
				'F': i:=7;		{Fill}
			    {Colorgrabbing}
			    'G': BEGIN
			  		VSync;Hide_Mouse;
			  		IF MousePosY<158 THEN BEGIN
			  			actcol:=GetPixel(MousePosX,MousePosY,X_REZ,zoomscr);
			  		END ELSE IF WhichB(MousePosX,MousePosY)=24 THEN BEGIN
			  		    actcol:=GetPixel(GetDegasX(MousePosX),GetDegasY(MousePosY),X_REZ,scr);
			  		END;
			  		DrawActColors;
			  		Show_Mouse;
			  	END;
			    '.': BEGIN
					  Hide_Mouse;
				  	  MarkPalCol(0,par.actpcn,zoomscr);
				  	  Inc(par.actpcn);
				  	  IF par.actpcn>127 THEN par.actpcn:=0;
				      MarkPalCol(65535,par.actpcn,zoomscr);
				      actcol:=SetColor(par.actpcn,paladr);
					  DrawActColors;Show_Mouse;
			    END;
			    ',': BEGIN
					  Hide_Mouse;
				  	  MarkPalCol(0,par.actpcn,zoomscr);
				  	  Dec(par.actpcn);
				  	  IF par.actpcn<0 THEN par.actpcn:=127;
				      MarkPalCol(65535,par.actpcn,zoomscr);
				      actcol:=SetColor(par.actpcn,paladr);
					  DrawActColors;Show_Mouse;
			    END;
			    '-': BEGIN
				      actcol:=SetColor(par.actpcn,paladr);
					  Hide_Mouse;DrawActColors;Show_Mouse;
			    END;
			    '*': BEGIN
				      IF palflag=0 THEN palflag:=1 ELSE palflag:=0;
				      {Palettenadresse setzen}
					  IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
			 		  			   ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
					  VSync;
					  Hide_Mouse;
					  DrawPalette(zoomscr,paladr);
					  DrawActColors;Show_Mouse;
			    END;
			    '#': BEGIN
   				   	dummy:=FCreate('c:\neozoom.xga',0);
				   	Fwrite(dummy,153600,PhysBase);
				   	Fclose(dummy);
			    END;
			END;
			IF (UpCase(key)>='4') AND (UpCase(key)<='9') THEN BEGIN
				VSync;
				Hide_Mouse;
				DrawActColors;
				Show_Mouse;
			END;
		END;
		{'+' -> Increase zoommagnify}
	  	IF keycode=5111851 THEN BEGIN
	 		CASE par.zoommagn OF
	 			3: keycode:=3932160; {->5:1}
	 			5: keycode:=3997696; {->7:1}
	 			7: keycode:=4063232; {->9:1}
	 			9: keycode:=4063232; {->9:1}
	 		END;
	  	END;
		{'-' -> Decrease zoommagnify}
	  	IF keycode=4849709 THEN BEGIN
	 		CASE par.zoommagn OF
	 			3: keycode:=3866624; {->3:1}
	 			5: keycode:=3866624; {->3:1}
	 			7: keycode:=3932160; {->5:1}
	 			9: keycode:=3997696; {->7:1}
	 		END;
	  	END;
		IF keycode=3866624 THEN i:=18;	{F1}
		IF keycode=3932160 THEN i:=19;	{F2}
		IF keycode=3997696 THEN i:=20;	{F3}
		IF keycode=4063232 THEN i:=21;	{F4}
		IF keycode=4718592 THEN i:=16;	{hoch}
		IF keycode=5242880 THEN i:=17;	{runter}
		IF keycode=5046272 THEN i:=15;	{rechts}
		IF keycode=4915200 THEN i:=14;	{links}
		IF keycode=6422528 THEN Help(4,Pointer(Longint(buffer)+1024),zoomscr);
		IF keycode=6356992 THEN BEGIN 	{Undo}
			Hide_Mouse;
			WITH pic[par.actscr] DO
			NeoPicFlip(ppx,ppy,rez_x,rez_y,adr,scr);
			MemCopy(scr,zoomscr,160*158);
			{Wenn Crackart Mode}
			IF czf=1 THEN BEGIN
				RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
				{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
				WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
			END;
			Show_Mouse;
		END;
		{IF keycode=2097156 THEN BEGIN	
			MemCFast(scr,pic[par.actscr].adr,3200);
			MemDFast(scr,3200);
			Hide_Mouse;
			MemCopy(Pointer(LongInt(scr)+640*ppy),zoomscr,25280);
			}{Wenn Crackart Mode}{
			IF czf=1 THEN BEGIN
				RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
				WITH pic[par.actscr] DO DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
			END;
			Show_Mouse;
		END;}
		IF mb=2 THEN BEGIN
		  {Bildbereich verschieben}
		  IF MousePosY<158 THEN BEGIN
			omx:=MousePosX;
			omy:=MousePosY;
			Hide_Mouse;
			WITH pic[par.actscr] DO
			NeoPicSave(ppx,ppy,rez_x,rez_y,adr,scr);
			SetMousePos(ppx,ppy);
			WITH pic[par.actscr] DO
			SetMouseRange(rez_x-319,rez_y-158);
			MemClear(zoomscr,160*158);
			WHILE mb=2 DO BEGIN
				ppx:=MousePosX;ppy:=MousePosY;
				WITH pic[par.actscr] DO
				NeoMove(ppx,ppy,rez_x,rez_y,adr,zoomscr);
			END;
			WITH pic[par.actscr] DO BEGIN
				NeoPicDraw(ppx,ppy,rez_x,rez_y,adr,zoomscr);
				NeoPicDraw(ppx,ppy,rez_x,rez_y,adr,scr);
			END;
			SetMouseRange(320,240);
			SetMousePos(omx,omy);
			Show_Mouse;
   		  END ELSE key:=#27;
		END;
		
		IF (mb=1) OR (key<>#255) THEN BEGIN
			IF (MousePosY<158) AND (key=#255) THEN BEGIN 
				{Edit}
				{Mausbereich auf Arbeitsflche begrenzen}
				SetMouseRange(320,158);
				{Bild erstma sichern (fr Undo)}
				Hide_Mouse;
				WITH pic[par.actscr] DO
				NeoPicSave(ppx,ppy,rez_x,rez_y,adr,zoomscr);
				CASE neotool OF 
					0: DrawFkt(1);
					1: LineFkt(1);
					2: PolyFkt(1);
					3: BoxFkt(1);
					4: RectFkt(1);
					6: CircFkt(1);
					7: FillFkt(1);
				END;
				{Mausbereichsbegrenzung wieder aufheben}
				SetMouseRange(320,240);
				Show_Mouse;
			END ELSE BEGIN
				IF key=#255 THEN i:=WhichB(MousePosX,MousePosY);

				{Werkzeug whlen}
				IF (i>=0) AND (i<=7) THEN BEGIN
					IF i<>neotool THEN BEGIN
						but[neotool].state:=0;
						but[i].state:=1;
						VSync;Hide_Mouse;
						WITH but[neotool] DO DrawButton(x,y,0,adr,zoomscr);
						WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);
						Show_Mouse;
						neotool:=i;
						REPEAT Delay(30) UNTIL mb=0;
					END;
				END;
				
				{RGB-Modifikation}
				{Rot+}
				IF i=8 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(221+4,208+5,r,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF r<63 THEN Inc(r);
						actcol:=Set_R(r,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(221+4,208+5,r,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				{Grn+}
				IF i=9 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(237+4,208+5,g,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF g<63 THEN Inc(g);
						actcol:=Set_G(g,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(237+4,208+5,g,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				{Blau+}
				IF i=10 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(253+4,208+5,b,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF b<63 THEN Inc(b);
						actcol:=Set_B(b,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(253+4,208+5,b,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				{Rot-}
				IF i=11 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(221+4,208+5,r,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF r>0 THEN Dec(r);
						actcol:=Set_R(r,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(221+4,208+5,r,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				{Grn-}
				IF i=12 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(237+4,208+5,g,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF g>0 THEN Dec(g);
						actcol:=Set_G(g,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(237+4,208+5,g,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				{Blau-}
				IF i=13 THEN BEGIN
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,1,adr,zoomscr);Show_Mouse;
					REPEAT
						IF mb<>3 THEN BEGIN VSync;VSync;VSync;VSync;END;
						Hide_Mouse;
						{alten Wert lschen}
						Num_OutPut(253+4,208+5,b,2,0,zoomscr);
						{..und erhhen -> neuer Wert}
						IF b>0 THEN Dec(b);
						actcol:=Set_B(b,SetColor(par.actpcn,paladr));
						SetNewRGB(par.actpcn,actcol,paladr);
						Num_OutPut(253+4,208+5,b,2,0,zoomscr);DrawActColors;Show_Mouse;VSync;
					UNTIL mb=0;
					Hide_Mouse;WITH but[i] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				END;
				
				{Grid-Flag}
				IF i=22 THEN BEGIN
					Hide_Mouse;
					IF par.zoomgrid=0 THEN BEGIN
						par.zoomgrid:=1;WITH but[22] DO DrawButton(x,y,1,adr,zoomscr);
					END ELSE BEGIN
						par.zoomgrid:=0;WITH but[22] DO DrawButton(x,y,0,adr,zoomscr);
					END;
					{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
					WITH pic[par.actscr] DO DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
					Show_Mouse;
					REPEAT Delay(10) UNTIL mb=0;
				END;
				
				{Zoom-Cursor}
				IF (i>=14) AND (i<=17) AND (MousePosY>=158) THEN REPEAT 
				  IF key=#255 THEN BEGIN
				  	cnt:=WhichB(MousePosX,MousePosY);
				  	IF (cnt>=14) AND (cnt<=17) THEN i:=cnt;
				  	blond:=0;
				  END ELSE blond:=czsize div (2*par.zoommagn);
				  CASE i OF
					{links}
					14: BEGIN
						Hide_Mouse;FOR cnt:=14 TO 17 DO IF cnt=i THEN WITH but[cnt] DO DrawButton(x,y,1,adr,zoomscr) ELSE WITH but[cnt] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
						VSync;RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Dec(czx,mb+blond);IF czx<0 THEN czx:=0;
						RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Hide_Mouse;
						{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
						WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
						Show_Mouse;
					END;
					{rechts}
					15: BEGIN
						Hide_Mouse;FOR cnt:=14 TO 17 DO IF cnt=i THEN WITH but[cnt] DO DrawButton(x,y,1,adr,zoomscr) ELSE WITH but[cnt] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
						VSync;RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Inc(czx,mb+blond);IF czx>320-(czsize div par.zoommagn) THEN czx:=320-(czsize div par.zoommagn);
						RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Hide_Mouse;
						{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
						WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
						Show_Mouse;
					END;
					{hoch}
					16: BEGIN
						Hide_Mouse;FOR cnt:=14 TO 17 DO IF cnt=i THEN WITH but[cnt] DO DrawButton(x,y,1,adr,zoomscr) ELSE WITH but[cnt] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
						VSync;RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Dec(czy,mb+blond);IF czy<0 THEN czy:=0;
						RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Hide_Mouse;
						{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
						WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
						Show_Mouse;
					END;
					{runter}
					17: BEGIN
						Hide_Mouse;FOR cnt:=14 TO 17 DO IF cnt=i THEN WITH but[cnt] DO DrawButton(x,y,1,adr,zoomscr) ELSE WITH but[cnt] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
						VSync;RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Inc(czy,mb+blond);IF czy>158-(czsize div par.zoommagn) THEN czy:=158-(czsize div par.zoommagn);
						RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						Hide_Mouse;
						{DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,Pointer(LongInt(scr)+ppy*640),zoomscr);}
						WITH pic[par.actscr] DO DrawNeoZoom(czx,czy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
						Show_Mouse;					
					END;
				  END;
				  {alles mal neu zeichnen}
				  Hide_Mouse;FOR cnt:=14 TO 17 DO WITH but[cnt] DO DrawButton(x,y,0,adr,zoomscr);Show_Mouse;
				UNTIL (mb=0) OR (key<>#255);
				
				{Wenn neue Zoomauflsung angewhlt...}
				IF (i>=18) AND (i<=21) THEN BEGIN
					CASE par.zoommagn OF
						3: cnt:=18;
						5: cnt:=19;
						7: cnt:=20;
						9: cnt:=21;
					END;
					{wenn alt nicht neu...}
					IF cnt<>i THEN BEGIN
						mx:=MousePosX;my:=MousePosY;
						Hide_Mouse;
						NormBox(0,49+63,169+63,49,169,zoomscr);
						{..alten deselektieren..}
						but[cnt].state:=0;WITH but[cnt] DO DrawButton(x,y,state,adr,zoomscr);
						{...und neuen selektieren}
						but[i].state:=1;WITH but[i] DO DrawButton(x,y,state,adr,zoomscr);
						Show_Mouse;
						{Zoomauflsung setzen}
						IF my>=158 THEN RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
						CASE i OF
							18: BEGIN par.zoommagn:=3;czsize:=63;END;
							19: BEGIN par.zoommagn:=5;czsize:=55;END;
							20: BEGIN par.zoommagn:=7;czsize:=63;END;
							21: BEGIN par.zoommagn:=9;czsize:=63;END;
						END;
						IF czx>320-(czsize div par.zoommagn) THEN czx:=320-(czsize div par.zoommagn);
						IF czy>158-(czsize div par.zoommagn) THEN czy:=158-(czsize div par.zoommagn);
						Hide_Mouse;
						WITH pic[par.actscr] DO DrawNeoZoom(czx+ppx,czy+ppy,par.zoommagn,par.zoomgrid,1,320,scr,zoomscr);
						Show_Mouse;
						IF my>=158 THEN RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
					END;
					{a bisserl warten}
					REPEAT Delay(10) UNTIL mb=0;
				END;
				
				{Linksklick auf Palette -> neue akt.Farbe whlen}
				IF i=23 THEN WITH par DO BEGIN
					{angeklickte Farbe ermitteln}
					blond:=Trunc((MousePosX-px)/6);
			 		IF blond>31 THEN blond:=31;
			 		IF blond<0 THEN blond:=0;
			 		blond:=blond+Trunc((MousePosY-py)/6)*32;
					IF blond>127 THEN Dec(blond,32);
					IF blond<0 THEN blond:=0;
		 			Hide_Mouse;
					MarkPalCol(0,actpcn,zoomscr);
		 			actpcn:=blond;
					{neue Farbe markieren}
					MarkPalCol(65535,actpcn,zoomscr);
		 			actcol:=SetColor(actpcn,paladr);
		 			{Aktuelle Farbe neben Palette zeichnen}
		 			Show_Mouse;
		 			VSync;Hide_Mouse;
		 			DrawActColors;
					{alte RGB-Werte lschen}
					Num_OutPut(221+4,208+5,r,2,0,zoomscr);
					Num_OutPut(237+4,208+5,g,2,0,zoomscr);
					Num_OutPut(253+4,208+5,b,2,0,zoomscr);
					{neue RGB-Werte}
		 			r:=Get_R(actcol);
		 			g:=Get_G(actcol);
		 			b:=Get_B(actcol);
					Num_OutPut(221+4,208+5,r,2,0,zoomscr);
					Num_OutPut(237+4,208+5,g,2,0,zoomscr);
					Num_OutPut(253+4,208+5,b,2,0,zoomscr);
					Show_Mouse;
				END;
				
				IF i=24 THEN WITH but[24] DO BEGIN
					{Mausbereich auf Arbeitsflche begrenzen}
					IF par.zoommagn=5 THEN BEGIN
						SetMouseMin(x+5,y+5);
						SetMouseRange(x+w-3,y+h-3);
					END ELSE BEGIN
						SetMouseMin(x+1,y+1);
						SetMouseRange(x+w+1,y+h+1);
					END;
					{Bild erstma sichern (fr Undo)}
					RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
					WITH pic[par.actscr] DO
					NeoPicSave(ppx,ppy,rez_x,rez_y,adr,scr);
					{WITH pic[par.actscr] DO
					NeoPicDraw(ppx,ppy,rez_x,rez_y,adr,zoomscr);}
					RubRect(czx,czy,czx+(czsize div par.zoommagn)-1,czy+(czsize div par.zoommagn)-1,zoomscr);
					CASE neotool OF 
						0: DrawFkt(2);
						1: LineFkt(2);
						2: PolyFkt(2);
						3: BoxFkt(2);
						4: RectFkt(2);
						6: CircFkt(2);
						7: FillFkt(2);
					END;
					REPEAT UNTIL mb=0;
					{Mausbereichsbegrenzung wieder aufheben}
					SetMouseMin(0,0);
					SetMouseRange(320,240);
				END;
				
			END;
		END;
	{raus gehts mit Escape oder Return}
	UNTIL (key=#27) OR (key=#13);
	WITH pic[par.actscr] DO NeoPicSave(ppx,ppy,rez_x,rez_y,adr,scr);
END; 