{PROZEDUR LEGT NEUES BILD IM SPEICHER AN}
FUNCTION MakeNewPicture(xsize,ysize:LongInt;picname:String;datadr:Pointer):Pointer;
VAR		i		:Integer;
		offset	:LongInt;
		size	:LongInt;
		memadr	:Pointer;
		pfd,nam,ext	:String;
BEGIN
	{Null = Speicher reicht nicht.}
	MakeNewPicture:=NIL;
	
	IF xsize<320 THEN xsize:=320;
	IF ysize<240 THEN ysize:=240;
	
	IF GetFreePicMem>(xsize*ysize*2+512+4) THEN BEGIN

{!!!}	{Adressoffset fr neues Bild ermitteln}
{!!!	offset:=0;
 !!!	IF anzpic>0 THEN FOR i:=1 TO anzpic DO WITH pic[i] DO BEGIN
 !!!		}{Bildgre=x*y*2+Palette}{	
 !!!		offset:=rez_x*rez_y*2+offset+512+4;
 !!!	END;}
	
		{Anzahl der Bilder im Speicher hochzhlen}
		Inc(anzpic);
	
		{Speicherblock fr neues Bild holen}
		IF datadr=NIL THEN memadr:=Malloc(xsize*ysize*2+512+4) ELSE
		memadr:=datadr;
		
		{Adresse der neuen Palette}
		pic[anzpic].paladr:=memadr;

		{Standartpalette setzen}
		IF datadr=NIL THEN MemCopy(@paldat,pic[anzpic].paladr,128);
		
		{Adresse des neuen Bildes}
		pic[anzpic].adr:=Pointer(LongInt(memadr)+512);
			
		{Bildparameter setzen}
		FSplit(picname,pfd,nam,ext);
		WITH pic[anzpic] DO BEGIN
			IF anzpic>0 THEN pfad:=pic[par.actscr].pfad
			ELSE pfad:='';
			name:=nam;
			palpfad:=pfad;
			palname:=nam;
			palflag:=0;
			flag:=0;{1}
			rez_x:=xsize;
			rez_y:=ysize;
			xpos:=0;
			ypos:=0;
			filetype:=XGA;
			palftype:=EPP;
		END;
		
		{Bild lschen}
		IF datadr=NIL THEN MemClear(pic[anzpic].adr,xsize*ysize div 2);
	
		MakeNewPicture:=pic[anzpic].adr;
	
	END;
END;	
	
	
	
{FUNKTION ERMITTELT NOCH ZUR VERFGUNG STEHENDEN BILDSPEICHER}
FUNCTION GetFreePicMem:LongInt;
VAR		i			:Integer;
		anz_bytes	:LongInt;
BEGIN
	{anz_bytes:=picmemsize;
	IF anzpic>0 THEN FOR i:=1 TO anzpic DO anz_bytes:=anz_bytes - (2*pic[i].rez_y*pic[i].rez_x) - 512;
	GetFreePicMem:=anz_bytes;}

	GetFreePicMem:=LongInt(Malloc(-1))-16;
END;


{PROZEDUR ZUM LOESCHEN EINES BILDES AUS DEM SPEICHER}
PROCEDURE ClearPic(picnum:LongInt);
VAR		anz_longs	:LongInt;
		i			:Integer;
		picsize		:LongInt;
		clrpsize	:LongInt;
BEGIN
	IF picnum<=anzpic THEN BEGIN

		{clrpsize:=pic[picnum].rez_x*pic[picnum].rez_y*2+512;

		anz_longs:=0;
		}{Anzahl der zu verschiebenden Bytes berechnen (wenn Bild inmitten anderer)}{
		FOR i:=(picnum+1) TO anzpic DO BEGIN
			picsize:=pic[i].rez_x*pic[i].rez_y*2;
			anz_longs:=picsize+512+anz_longs;	
		END;

		}{Speicher nach vorn kopieren}{
		MemCopy(pic[picnum+1].paladr,pic[picnum].paladr,anz_longs div 4 +4);

		}{Adressen modifizieren}{
		FOR i:=picnum+1 TO anzpic DO BEGIN
			pic[i].adr:=Pointer(LongInt(pic[i].adr)-clrpsize);
			pic[i].paladr:=Pointer(LongInt(pic[i].paladr)-clrpsize);
		END;}
		
		MFree(pic[picnum].paladr);
	
	
	END;
	
	Dec(anzpic);
	
END;


PROCEDURE Shit(d0,d1,d2:LongInt;a0,a1:Pointer);
VAR	strptr	:^String;
BEGIN
	Writeln(d0);
	Writeln(d1);
	Writeln(d2);
	Writeln(LongInt(a0));
	Writeln(LongInt(a1));
	
	
	strptr:=a1;
	Writeln(strptr^);
END;



PROCEDURE PushPic(picnum:Integer;scradr:Pointer);
VAR		offset		:LongInt;
		lineoffset	:LongInt;
BEGIN
	WITH pic[picnum] DO BEGIN
		offset:=(rez_x*ypos + xpos) * 2;
		lineoffset:=(rez_x-320) * 2;
		PushVirtualScreen(offset,lineoffset,scradr,adr);
	END;
END;


PROCEDURE PullPic(picnum:Integer;scradr:Pointer);
VAR		offset		:LongInt;
		lineoffset	:LongInt;
BEGIN
	WITH pic[picnum] DO BEGIN
		offset:=(rez_x*ypos + xpos) * 2;
		lineoffset:=(rez_x-320) * 2;
		PullVirtualScreen(offset,lineoffset,adr,scradr);
	END;
END;


PROCEDURE FlipPic(picnum:Integer;scradr:Pointer);
VAR		offset		:LongInt;
		lineoffset	:LongInt;
BEGIN
	WITH pic[picnum] DO BEGIN
		offset:=(rez_x*ypos + xpos) * 2;
		lineoffset:=(rez_x-320) * 2;
		FlipVirtualScreen(offset,lineoffset,adr,scradr);
	END;
END;


PROCEDURE Config_Picture(newxsize,newysize:LongInt;newname:String);
VAR	newpicadr:Pointer;
	needed_mem:LongInt;
BEGIN
	WITH pic[par.actscr] DO IF (newxsize<>rez_x) OR (newysize<>rez_y) THEN BEGIN
		needed_mem:=newxsize*newysize*2+(512+4);
		{Neues Bild im Speicher anlegen}
		newpicadr:=Malloc(needed_mem);
		MemCopy(paladr,newpicadr,128);
		ResizePicture(rez_x,rez_y,newxsize,newysize,adr,Pointer(LongInt(newpicadr)+512));
		MFree(paladr);
		{Adressen auf neue Werte setzen}
		paladr:=newpicadr;
		adr:=Pointer(LongInt(newpicadr)+512);
	END;
	{Bildstruktur updaten}
	WITH pic[par.actscr] DO BEGIN
		name:=newname;
		rez_x:=newxsize;
		rez_y:=newysize;
		xpos:=0;ypos:=0;
	END;
END;


