{$L PRG.INC\REALZOOM.O} {REALTIME-ZOOM}
PROCEDURE R_Draw_Zoom9(mx,my,dx,dy,gridflag:LongInt;scradr,bufadr:Pointer);EXTERNAL;
PROCEDURE R_Draw_Zoom7(mx,my,dx,dy,gridflag:LongInt;scradr,bufadr:Pointer);EXTERNAL;
PROCEDURE R_Draw_Zoom5(mx,my,dx,dy,gridflag:LongInt;scradr,bufadr:Pointer);EXTERNAL;
PROCEDURE R_Draw_Zoom3(mx,my,dx,dy,gridflag:LongInt;scradr,bufadr:Pointer);EXTERNAL;

{ZEICHNET UND VERWALTET REALTIMELUPE}
PROCEDURE RealTimeZoom(rtx,rty:LongInt);
VAR		a,b{,c}	:LongInt;
		romx,romy:LongInt;

{rtx und rty sind die Koordinaten des zu zeichnenden Bereiches}
{rmx und rmy sind die Koordinaten vom letzten Zeichnen}
{romx und romy sind die 'Arbeits'-Koordinaten}
{a und b sind die Positionen des Cursors}

BEGIN
  {ist beim aktuellen Tool berhaupt ein RT-Zoom mglich?...}
  IF ((par.acttool=BLKPUT) AND (key<>#27)) 
  OR ((par.acttool=ZOOM)   AND (key<>#27)) THEN BEGIN END ELSE
  {...wenn ja, dann berprfen, ob sich die Position verndert hat} 
  IF (rtx<>rmx) OR (rty<>rmy) THEN BEGIN
	{Wenn Realtime-Zoom aktiv}
	{IF (rmx=MousePosX) AND (rmy=MousePosY) THEN c:=0 ELSE c:=1;}
	
	romx:=rtx;romy:=rty;
	
	{Realtime-Zoom mit 3-facher Vergrerung}
	IF (par.rt_flag=1) AND (par.zoommagn=3) THEN BEGIN
		{rmx:=MousePosX;rmy:=MousePosY;}
		{romx:=rtx;romy:=rty;}
		a:=17;b:=17;
		IF romx<17 THEN BEGIN
			romx:=17;a:=rtx;IF a<0 THEN a:=0;END;
		IF romx>302 THEN BEGIN
			romx:=302;a:=rtx-285;IF a>34 THEN a:=34;END;
		IF romy<17 THEN BEGIN
			romy:=17;b:=rty;IF b<0 THEN b:=0;END;
		IF romy>222 THEN BEGIN
			romy:=222;b:=rty-205;IF b>34 THEN b:=34;END;
			
		IF ((rz_flag=1) AND (rtx<160)) OR ((rz_flag=2) AND (rtx>159)) THEN BEGIN
			Hide_Mouse;
			CASE rz_flag OF
				{oben, links -> oberen Bildteil restaurieren}
				1: MemCFast(zoomscr,scr,1600);
				{unten, rechts -> unteren Bildteil restaurieren}
				2: MemCFast(Pointer(LongInt(zoomscr)+76800),Pointer(LongInt(scr)+76800),1600);
			END;
			IF snapgrid=1 THEN Show_Mouse;
			IF rz_flag=1 THEN rz_flag:=2 ELSE rz_flag:=1;
		END;
		
		CASE rz_flag OF
		1: BEGIN
			R_Draw_Zoom3(romx-17,romy-17,10,10,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(9+3*a,9+3*b,12+3*a,12+3*b,65535,scr);
			Draw_3D_Rect(9,9,115,115,scr);
		  END;
		2: BEGIN
			R_Draw_Zoom3(romx-17,romy-17,205,125,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(204+3*a,124+3*b,207+3*a,127+3*b,65535,scr);
			Draw_3D_Rect(204,124,310,230,scr);
		  END;
		END;
	END;
	
	{Realtimezoom mit 5-facher Vergrerung}
	IF (par.rt_flag=1) AND (par.zoommagn=5) THEN BEGIN
		{rmx:=MousePosX;rmy:=MousePosY;}
		{romx:=rmx;romy:=rmy;}
		a:=10;b:=10;
		IF romx<10 THEN BEGIN
			romx:=10;a:=rtx;IF a<0 THEN a:=0;END;
		IF romx>309 THEN BEGIN
			romx:=309;a:=rtx-299;IF a>21 THEN a:=21;END;
		IF romy<10 THEN BEGIN
			romy:=10;b:=rty;IF b<0 THEN b:=0;END;
		IF romy>229 THEN BEGIN
			romy:=229;b:=rty-219;IF b>20 THEN b:=20;END;
			
		IF ((rz_flag=1) AND (rtx<160)) OR ((rz_flag=2) AND (rtx>159)) THEN BEGIN
			Hide_Mouse;
			CASE rz_flag OF
				{oben, links -> oberen Bildteil restaurieren}
				1: MemCFast(zoomscr,scr,1600);
				{unten, rechts -> unteren Bildteil restaurieren}
				2: MemCFast(Pointer(LongInt(zoomscr)+76800),Pointer(LongInt(scr)+76800),1600);
			END;
			IF snapgrid=1 THEN Show_Mouse;
			IF rz_flag=1 THEN rz_flag:=2 ELSE rz_flag:=1;
		END;
		IF rz_flag=1 THEN BEGIN
			R_Draw_Zoom5(romx-10,romy-10,10,10,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(9+5*a,9+5*b,14+5*a,14+5*b,65535,scr);
			Draw_3D_Rect(9,9,115,115,scr);
		END;
		IF rz_flag=2 THEN BEGIN
			R_Draw_Zoom5(romx-10,romy-10,205,125,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(204+5*a,124+5*b,209+5*a,129+5*b,65535,scr);
			Draw_3D_Rect(204,124,310,230,scr);
		END;
	END;
	
	
	{Realtimezoom mit 7-facher Vergrerung}
	IF (par.rt_flag=1) AND (par.zoommagn=7) THEN BEGIN
		{rmx:=MousePosX;rmy:=MousePosY;
		romx:=rmx;romy:=rmy;}
		a:=7;b:=7;
		IF romx<7 THEN BEGIN
			romx:=7;a:=rtx;IF a<0 THEN a:=0;END;
		IF romx>X_REZ-8 THEN BEGIN
			romx:=X_REZ-8;a:=rtx-X_REZ+15;IF a>15 THEN a:=15;END;
		IF romy<7 THEN BEGIN
			romy:=7;b:=rty;IF b<0 THEN b:=0;END;
		IF romy>Y_REZ-8 THEN BEGIN
			romy:=Y_REZ-8;b:=rty-Y_REZ+15;IF b>15 THEN b:=15;END;
			
		IF ((rz_flag=1) AND (rtx<160)) OR ((rz_flag=2) AND (rtx>159)) THEN BEGIN
			Hide_Mouse;
			CASE rz_flag OF
				{oben, links -> oberen Bildteil restaurieren}
				1: MemCFast(zoomscr,scr,1600);
				{unten, rechts -> unteren Bildteil restaurieren}
				2: MemCFast(Pointer(LongInt(zoomscr)+76800),Pointer(LongInt(scr)+76800),1600);
			END;
			IF snapgrid=1 THEN Show_Mouse;
			IF rz_flag=1 THEN rz_flag:=2 ELSE rz_flag:=1;
		END;
		IF rz_flag=1 THEN BEGIN
			R_Draw_Zoom7(romx-7,romy-7,10,10,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(9+7*a,9+7*b,16+7*a,16+7*b,65535,scr);
			Draw_3D_Rect(9,9,115,115,scr);
		END;
		IF rz_flag=2 THEN BEGIN
			R_Draw_Zoom7(romx-7,romy-7,205,125,par.zoomgrid,zoomscr,scr);
			{IF c=0 THEN VSync;}
			RectFast(204+7*a,124+7*b,211+7*a,131+7*b,65535,scr);
			Draw_3D_Rect(204,124,310,230,scr);
		END;
	END;

	{Realtimezoom mit 9-facher Vergrerung}
	IF (par.rt_flag=1) AND (par.zoommagn=9) THEN BEGIN
		{rmx:=MousePosX;rmy:=MousePosY;
		romx:=rmx;romy:=rmy;}
		a:=5;b:=5;
		IF romx<5 THEN BEGIN
			romx:=5;a:=rtx;IF a<0 THEN a:=0;END;
		IF romx>X_REZ-6 THEN BEGIN
			romx:=X_REZ-6;a:=rtx-X_REZ+11;IF a>11 THEN a:=11;END;
		IF romy<5 THEN BEGIN
			romy:=5;b:=rty;IF b<0 THEN b:=0;END;
		IF romy>Y_REZ-6 THEN BEGIN
			romy:=Y_REZ-6;b:=rty-Y_REZ+11;IF b>11 THEN b:=11;END;
			
		IF ((rz_flag=1) AND (rtx<160)) OR ((rz_flag=2) AND (rtx>159)) THEN BEGIN
			Hide_Mouse;
			CASE rz_flag OF
				1: MemCFast(zoomscr,scr,1600);
				2: MemCFast(Pointer(LongInt(zoomscr)+76800),Pointer(LongInt(scr)+76800),1600);
			END;
			IF snapgrid=1 THEN Show_Mouse;
			IF rz_flag=1 THEN rz_flag:=2 ELSE rz_flag:=1;
		END;
		IF rz_flag=1 THEN BEGIN
			RectFast(10,10,10+104,10+104,0,scr);
			RectFast(11,11,9+104,9+104,0,scr);
			RectFast(12,12,8+104,8+104,0,scr);
			R_Draw_Zoom9(romx-5,romy-5,13,13,par.zoomgrid,zoomscr,scr);
			RectFast(9+3+9*a,9+3+9*b,16+5+9*a,16+5+9*b,65535,scr);
			Draw_3D_Rect(9,9,115,115,scr);
		END;
		IF rz_flag=2 THEN BEGIN
			RectFast(205,125,205+104,125+104,0,scr);
			RectFast(206,126,204+104,124+104,0,scr);
			RectFast(207,127,203+104,123+104,0,scr);
			R_Draw_Zoom9(romx-5,romy-5,208,128,par.zoomgrid,zoomscr,scr);
			RectFast(204+3+9*a,124+3+9*b,211+5+9*a,131+5+9*b,65535,scr);
			Draw_3D_Rect(204,124,310,230,scr);
		END;
	END;

  END;
  rmx:=rtx;rmy:=rty;	
END;

{PROZEDUR SCHALTET DEN REALTIMEZOOM AUS}
PROCEDURE RealTimeOff;
BEGIN
	{Wenn Realtime-Lupe aktiv->Bild wiederherstellen}
	IF par.rt_flag=1 THEN BEGIN
		{Bild restaurieren}
		Hide_Mouse;
		{RT-Zoom-Positionen unterscheiden (nur Bildteil restaurieren)}
		CASE rz_flag OF
			{oben, links -> oberen Bildteil restaurieren}
			1: MemCFast(zoomscr,scr,1600);
			{unten, rechts -> unteren Bildteil restaurieren}
			2: MemCFast(Pointer(LongInt(zoomscr)+76800),Pointer(LongInt(scr)+76800),1600);
		END;
		IF snapgrid=1 THEN Show_Mouse;
	END;
END;

{PROZEDUR SCHALTET DEN REALTIMEZOOM EIN}
PROCEDURE RealTimeOn;
BEGIN
	{Wenn Realtime-Lupe aktiv->Bild speichern}
	Hide_Mouse;
	IF par.rt_flag=1 THEN BEGIN
		{Bild sichern}
		{RT-Zoom-Positionen unterscheiden (nur Bildteil restaurieren)}
		{CASE rz_flag OF
			oben, links -> oberen Bildteil restaurieren
			1: BEGIN
				MemCFast(scr,zoomscr,1600);
			END;
			unten, rechts -> unteren Bildteil restaurieren
			2: BEGIN
				MemCFast(Pointer(LongInt(scr)+76800),Pointer(LongInt(zoomscr)+76800),1600);
			END;
		END;}
		MemCFast(scr,zoomscr,3200);
		
		{MemCopy(scr,zoomscr,38400);}
		{Vergrerung zeichnen}
		rmx:=-1;rmy:=-1;
		RealTimeZoom(MousePosX,MousePosY);
	END;
	IF snapgrid=1 THEN Show_Mouse;
END;