PROCEDURE Copy_Picture;
VAR		x,y,w,h,result:Integer;
		old_tree:AESTreePtr;
		quelle,ziel:Integer;
BEGIN
	old_tree:=obj_tree;
	obj_tree:=GetRSCAdr(R_TREE,COPYFORM);
	{Dialog zeichnen}
	Form_Center(obj_tree,x,y,w,h);
	Form_Dial(FMD_START,x,y,w,h,x,y,w,h);
	Objc_Draw(obj_tree,0,30,x,y,w,h);
	result:=Form_Do(obj_tree,0);
	Form_Dial(FMD_FINISH,x,y,w,h,x,y,w,h);
	{Exit-Button deselektieren}
	Set_Obj_State(obj_tree,result,NORMAL);

	{Quelle und Ziel bestimmen}	
	quelle:=1;ziel:=1;
	IF Get_Obj_State(obj_tree,CF_Q1)=SELECTED THEN quelle:=1;
	IF Get_Obj_State(obj_tree,CF_Q2)=SELECTED THEN quelle:=2;
	IF Get_Obj_State(obj_tree,CF_Q3)=SELECTED THEN quelle:=3;
	IF Get_Obj_State(obj_tree,CF_Z1)=SELECTED THEN ziel:=1;
	IF Get_Obj_State(obj_tree,CF_Z2)=SELECTED THEN ziel:=2;
	IF Get_Obj_State(obj_tree,CF_Z3)=SELECTED THEN ziel:=3;

	{Kopieren}
	IF (result=CF_COPY) AND (quelle<>ziel) THEN BEGIN
		{Bild kopieren}
		IF 	(Get_Obj_State(obj_tree,CF_BILD)=SELECTED) OR
			(Get_Obj_State(obj_tree,CF_ALLES)=SELECTED) THEN BEGIN
			MemCopy(pic[quelle].adr,pic[ziel].adr,38400);
		END;
		{Palette kopieren}
		IF 	(Get_Obj_State(obj_tree,CF_PALETTE)=SELECTED) OR
			(Get_Obj_State(obj_tree,CF_ALLES)=SELECTED) THEN BEGIN
			MemCopy(pic[quelle].paladr,pic[ziel].paladr,128);
		END;
	END;
	
	{Tauschen}
	IF (result=CF_FLIP) AND (quelle<>ziel) THEN BEGIN
		{Bild tauschen}
		IF 	(Get_Obj_State(obj_tree,CF_BILD)=SELECTED) OR
			(Get_Obj_State(obj_tree,CF_ALLES)=SELECTED) THEN BEGIN
			MemFlip(pic[quelle].adr,pic[ziel].adr,38400);
		END;
		{Palette tauschen}
		IF 	(Get_Obj_State(obj_tree,CF_PALETTE)=SELECTED) OR
			(Get_Obj_State(obj_tree,CF_ALLES)=SELECTED) THEN BEGIN
			MemFlip(pic[quelle].paladr,pic[ziel].paladr,128);
		END;
	END;
	
	obj_tree:=old_tree;
END;
