{ZUM ANLEGEN KONFIGURIEREN EINES BILDES}
PROCEDURE Info_Picture;
VAR		x,y,w,h,result	:Integer;
		p_xsize,p_ysize	:LongInt;
		p_name			:String;
		needed_mem,f	:LongInt;
		old_tree		:AESTreePtr;
		s				:String;
BEGIN
	old_tree:=obj_tree;
	obj_tree:=GetRSCAdr(R_TREE,INFO_PIC);
	
	{Ausgangswerte in Dialogbox eintragen}
	Str(GetFreePicMem,s);
	SetPText(obj_tree,INFOPIC_AVAIL-1,'AVAILABLE MEMORY:'); {Igitt!!}
	SetPText(obj_tree,INFOPIC_AVAIL,s);
	Str(pic[par.actscr].rez_x,s);
	SetPText(obj_tree,INFOPIC_XSIZE,s);
	Str(pic[par.actscr].rez_y,s);
	SetPText(obj_tree,INFOPIC_YSIZE,s);
	WITH pic[par.actscr] DO Str(rez_x*rez_y*2+512+4,s);
	SetPText(obj_tree,INFOPIC_NEED,s);
	{Namensfeld}
	SetPText(obj_tree,INFOPIC_NAME,pic[par.actscr].name);
	
	{Dialog zeichnen}
	Form_Center(obj_tree,x,y,w,h);
	Form_Dial(FMD_START,x,y,w,h,x,y,w,h);
	Objc_Draw(obj_tree,0,30,x,y,w,h);

	{Dialogloop}
	REPEAT
	
		result:=Form_Do(obj_tree,0);
		{Exit-Button deselektieren}
		Set_Obj_State(obj_tree,result,NORMAL);
		Objc_Draw(obj_tree,result,0,x,y,w,h);
		
		GetPText(obj_tree,INFOPIC_XSIZE,s);
		Val(s,p_xsize,f);
		GetPText(obj_tree,INFOPIC_YSIZE,s);
		Val(s,p_ysize,f);
		
		needed_mem:=p_xsize*p_ysize*2+512+4;
		Str(needed_mem,s);
		SetPText(obj_tree,INFOPIC_NEED,s);
		Objc_Draw(obj_tree,INFOPIC_NEED,0,x,y,w,h);

		{Ist Anlegen des Bildes speichermig mglich? Nein->neue Eingaben}
		IF (needed_mem>GetFreePicMem) AND (result<>INFOPIC_ABBRUCH) THEN BEGIN
			Form_Alert(1,PICMEMALERT);
			Form_Alert(1,PICMEMALERT2);
			result:=INFOPIC_CALC;
		END;
		
		{Ist Bild grer als 320*240 ?}
		IF ((p_xsize<320) OR (p_ysize<240)) AND (result<>INFOPIC_ABBRUCH) THEN BEGIN
			Form_Alert(1,PICSIZEALERT);
			result:=INFOPIC_CALC;
		END;
		
	UNTIL (result=INFOPIC_OK) OR (result=INFOPIC_ABBRUCH);
	
	{Dialog schlieen}
	Form_Dial(FMD_FINISH,x,y,w,h,x,y,w,h);

	{Wenn OK angeklickt -> neues Bild anlegen}
	IF result=INFOPIC_OK THEN BEGIN
		IF GetFreePicMem>(p_xsize*p_ysize*2+512+4) THEN BEGIN
			GetPText(obj_tree,INFOPIC_NAME,p_name);
			Config_Picture(p_xsize,p_ysize,p_name);
			{Bildbutton mit neuem Bildnamen malen}
			obj_tree:=GetRSCAdr(R_TREE,PICNUM);
			SetPText(obj_tree,par.actscr,p_name);
			Redraw_Obj(obj_tree,win[CHOOSEPIC].handle,par.actscr);
		END;
	END;

	SetPicNumSliders;

	obj_tree:=old_tree;
END;
