{PROZEDUR ZUM INITIALISIEREN EINES MODULES UND MODULDIALOGES}
PROCEDURE EPM_Init(slotnum:Integer);
VAR	h,xpos	:LongInt;
	cnt		:Integer;
	s		:String;
	min,max	:LongInt;
	nam,ext	:String;
	{PROZEDUR SETZT Y-POSITION EINES OBJEKTES REL.ZUM VATEROBJEKT}
	PROCEDURE Set_Y_Pos(obj,y_pos:Integer);
	BEGIN obj_tree^[obj].ob_y:=y_pos;END;
BEGIN

	{Reset dialog}
	FOR cnt:=0 TO 50 DO Unhide_Obj(cnt);
	Hide_Obj(MODSET_HIDDEN);

	h:=0;
	WITH epm[slotnum] DO BEGIN
		
		{Modulname in Fenstertitel}
		WindSetTitle(win[MODSETWIN].handle,name,win[MODSETWIN].buffer);
		Hide_Obj(MODSET_MODNAME-1);
		Inc(h,8);
		
{		SetPText(obj_tree,MODSET_MODNAME,name);
		Inc(h,32);}
		
		{Bildwahlpopups}
		Set_Y_Pos(MODSET_PICBOX1,h);
		Set_Y_Pos(MODSET_PICBOX2,h);
		Set_Y_Pos(MODSET_HIDDEN,h);
		
		IF anzpicpop=0 THEN BEGIN
			Inc(obj_tree^[MODSET_PICBOX1].ob_flags,HIDETREE);
			Inc(obj_tree^[MODSET_PICBOX2].ob_flags,HIDETREE);
		END ELSE Inc(h,40);
			
		IF anzpicpop=1 THEN BEGIN	
			Hide_Obj(MODSET_PICBOX2);
			Unhide_Obj(MODSET_HIDDEN);
			SetPText(obj_tree,MODSET_PICTXT1,picpop[1].title);
			SetPText(obj_tree,MODSET_PICPOP1,pic[1].name);
		END;
		
		IF anzpicpop=2 THEN BEGIN
			SetPText(obj_tree,MODSET_PICTXT1,picpop[1].title);
			SetPText(obj_tree,MODSET_PICPOP1,pic[picpop[1].actpic].name);
			SetPText(obj_tree,MODSET_PICTXT2,picpop[2].title);
			SetPText(obj_tree,MODSET_PICPOP2,pic[picpop[2].actpic].name);
		END;
		
		{Parameterslider}
		FOR cnt:=1 TO anzslider DO BEGIN
			Set_Y_Pos(MODSET_SLDBOX1+cnt*7-7,h);
			SetPText(obj_tree,MODSET_SLDTXT1+cnt*7-7,slider[cnt].name);		
			Str(slider[cnt].num,s);
			SetPText(obj_tree,MODSET_SLDNUM1+cnt*7-7,s);		
			min:=slider[cnt].min;
			max:=slider[cnt].max;
			IF slider[cnt].num<slider[cnt].min THEN xpos:=slider[cnt].min;
			IF slider[cnt].num>slider[cnt].max THEN xpos:=slider[cnt].max;
			xpos:=(144*(slider[cnt].num-min)) div (max-min);
			obj_tree^[MODSET_SLIDER1+cnt*7-7].ob_x:=xpos;
			Inc(h,40);			
		END;
		IF anzslider<4 THEN FOR cnt:=anzslider+1 TO 4 DO BEGIN
			Hide_Obj(MODSET_SLDBOX1+cnt*7-7);
			Hide_Obj(MODSET_SLDNUM1+cnt*7-7);
		END;
		
		{Texteingabefelder}
		FOR cnt:=1 TO anztext DO BEGIN
			Set_Y_Pos(MODSET_TXTBOX1+cnt*3-3,h);
			SetPText(obj_tree,MODSET_TXTTXT1+cnt*3-3,textin[cnt].head);		
			SetPText(obj_tree,MODSET_TXT1+cnt*3-3,textin[cnt].input);
			Inc(h,40);			
		END;
		IF anztext<2 THEN FOR cnt:=anztext+1 TO 2 DO BEGIN
			Hide_Obj(MODSET_TXTBOX1+cnt*3-3);
			Hide_Obj(MODSET_TXT1+cnt*3-3);
		END;
		
		{Dateiauswahl}
		IF filesel=1 THEN BEGIN
			Set_Y_Pos(MODSET_FILEBOX,h);
			SetPText(obj_tree,MODSET_FILETXT,fileselhead);
			SetPText(obj_tree,MODSET_FILETYPE,fileseltype);
			FSplit(fileselfile,s,nam,ext);
			SetPText(obj_tree,MODSET_FILENAME,nam+ext);
			Inc(h,40);
			{Wenn Datei aufgewhlt werden soll, OK-Button erstma sperren}
		END ELSE Hide_Obj(MODSET_FILEBOX);
		
		{Entscheidungsbuttons}
		Set_Y_Pos(MODSET_OK,h);
		Set_Y_Pos(MODSET_CANCEL,h);
		Inc(h,24);
				
		obj_tree^[0].ob_height:=h;
	END;
END;




PROCEDURE HoldButton(obj:Integer);
VAR	x,y,w,h		:Integer;
	mx,my,mb,kb	:Integer;
BEGIN
	{Get objectkoordinates}
	Objc_Offset(obj_tree,obj,x,y);
	Dec(x,2);Dec(y,2);
	w:=obj_tree^[obj].ob_width+4;
	h:=obj_tree^[obj].ob_height+4;
	{Select Object}
	Inc(obj_tree^[obj].ob_state,SELECTED);
	{Draw selected Object}
	objc_draw(obj_tree,obj,1,x,y,w,h);
	{Wait until no mousebutton is pressed}
	Evnt_Button(0,3,0,mx,my,mb,kb);
	{Deselect Object..}
	Dec(obj_tree^[obj].ob_state,SELECTED);
	objc_draw(obj_tree,obj,1,x,y,w,h);
END;


{FUNKTION ERSETZT DIE BESCHEUERTE AES-FUNKTION FORM_KEYBD}
FUNCTION KeyBd_Handle(obj_tree:AESTreePtr;actobj,keycode:Integer):Integer;
VAR	key		:Integer;
	cnt		:Integer;
	newobj	:Integer;
	dumm	:Integer;
BEGIN
	{Wichtigen Teil des Tastaturcodes 'herausfiltern'}
	key:=keycode div 256;
	newobj:=actobj;
	CASE key OF
		{Cursor nach oben}
		72: BEGIN
			{Objektstruktur nach sichtbarem Editobjekt absuchen}
			cnt:=actobj;
			REPEAT
				Dec(cnt);
				IF ((obj_tree^[cnt].ob_flags AND EDITABLE)<>0) AND ((obj_tree^[cnt].ob_flags AND HIDETREE)=0) THEN newobj:=cnt;
			UNTIL (cnt=0) OR (newobj<>actobj);
			IF cnt=0 THEN newobj:=-1;
			{newobj: neues Editobjekt oder -1, wenn keines vorhanden}
		END;
		{Cursor nach unten}
		80: BEGIN
			{Objektstruktur nach sichtbarem Editobjekt absuchen}
			cnt:=actobj;
			REPEAT
				Inc(cnt);
				IF ((obj_tree^[cnt].ob_flags AND EDITABLE)<>0) AND ((obj_tree^[cnt].ob_flags AND HIDETREE)=0) THEN newobj:=cnt;
			UNTIL (cnt=50) OR (newobj<>actobj);
			IF cnt=50 THEN newobj:=-1;
			{newobj: neues Editobjekt oder -1, wenn keines vorhanden}
		END;
		{TAB -> nchstes Feld}
		15: BEGIN
			{Objektstruktur nach sichtbarem Editobjekt absuchen}
			cnt:=actobj;
			REPEAT
				Inc(cnt);
				IF ((obj_tree^[cnt].ob_flags AND EDITABLE)<>0) AND ((obj_tree^[cnt].ob_flags AND HIDETREE)=0) THEN newobj:=cnt;
			UNTIL (cnt=50) OR (newobj<>actobj);
			IF cnt=50 THEN newobj:=-1;
			{newobj: neues Editobjekt oder -1, wenn keines vorhanden}
		END;
		{RETURN -> nix}
		28: BEGIN
			{Objektstruktur nach normalen Defaultobjekt absuchen}
			cnt:=0;
			REPEAT
				Inc(cnt);
				IF ((obj_tree^[cnt].ob_flags AND DEFAULT)<>0) AND ((obj_tree^[cnt].ob_state AND DISABLED)=0) THEN newobj:=cnt;
			UNTIL (cnt=50) OR (newobj<>actobj);
			IF cnt=50 THEN newobj:=-1;
			{newobj: Defaultobjekt oder -1, wenn keines vorhanden}
		END;
	END;
	KeyBd_Handle:=newobj;
	{Resultat: neues Editobjekt oder Defaultobjekt bei RETURN}
END;



{PROZEDUR FR FREIE MODULEINSTELLUNGEN}
PROCEDURE Module_0815_Settings(slotnum:Integer);
VAR		x,y,w,h		:Integer;	{Dialog position and size}
		result		:Integer;	{Mouseclick-result}
		mx,my,mb,kb	:Integer;	{Mousestates}
		dx,dy,dw,dh	:Integer;	{Dummies}
		bx,by,bw,bh	:Integer;	{Boarders}
		actobj		:Integer;	{Actual Edit-Object}
		dumm,err	:Integer;	{Dummy}
		keycode		:Integer;	{16Bit Keycode (evnt_multi)}
		pos			:Integer;	{Cursorpos.in editobj.}
		win_eventbuf:Array_8;	{Dummy}
		event		:Integer;	{Result of Evnt_Multi}
		edobj		:Integer;	{New editobject}
		obj_tree	:AESTreePtr;{Zeiger auf Objektbaum}
		s			:String;	{Dummy}	
		pfd,nam		:String;	{For filehandling}
		fileresult	:Integer;	{Pressed Fileselectorbutton}
		kbflag		:Integer;	{1...handle Editobjects}
		return		:Integer;	{return-Flag}
		winnum		:Integer;	{window number}

	{PROZEDUR ZUM VERSCHIEBEN EINES HORIZ. SLIDERS AN MAUSPOSITION}
	PROCEDURE MoveHSliderObj(obj,mx:Integer);
	VAR	ax,ay			:Integer;
		ox,oy,ow,oh		:Integer;
		nx,ny,nw,nh		:Integer;
		newxpos			:Integer;
		value			:LongInt;
		sldnum			:Integer;
		min,max			:LongInt;
	BEGIN
		WITH epm[slotnum] DO BEGIN
			{Get absolute pos. of the sizer-fatherobject}
			Objc_Offset(obj_tree,obj,ax,ay);
			{Get old koordinates of sizer-object}
			ox:=obj_tree^[obj+1].ob_x+ax;
			oy:=obj_tree^[obj+1].ob_y+ay;
			ow:=obj_tree^[obj+1].ob_width;
			oh:=obj_tree^[obj+1].ob_height;
			{Restore old sizerobject-background}
			Objc_Draw(obj_tree,obj,0,ox,oy,ow,oh);
			{Calculate new relative sizerobject-position}
			newxpos:=mx-ax-(ow div 2);
			{Check object boarders}
			IF newxpos<0 THEN newxpos:=0;
			IF newxpos>obj_tree^[obj].ob_width-15 THEN newxpos:=obj_tree^[obj].ob_width-16;
			{Get new koordinates of the sizer-object}
			nx:=newxpos;
			ny:=obj_tree^[obj+1].ob_y;
			nw:=obj_tree^[obj+1].ob_width;
			nh:=obj_tree^[obj+1].ob_height;
			{Draw sliderobj. on new position}
			obj_tree^[obj+1].ob_x:=nx;
			Objc_Draw(obj_tree,obj+1,1,nx+ax,ny+ay,nw,nh);
			sldnum:=(obj-6) div 7;
			min:=slider[sldnum].min;
			max:=slider[sldnum].max;
			value:=(nx*(max-min)) div 144 + min;
			slider[sldnum].num:=value;
			Str(value,s);
			SetPText(obj_tree,obj+2,s);
			DrawObj(obj_tree,obj+2);
			IF actobj=obj+2 THEN BEGIN
				pos:=Length(s)-1;
				Objc_Edit(obj_tree,obj+2,0,pos,EDINIT);
			END;
		END;
	END;	
	
	{PROZEDUR SETZT SLIDER AUF BESTIMMTEN WERT}
	PROCEDURE SetSliderValue(obj,value:LongInt);
	VAR		xpos	:LongInt;
			sldnum	:Integer;
			ax,ay	:Integer;
			min,max	:LongInt;
	BEGIN
		sldnum:=(obj-6) div 7;
		IF value<epm[slotnum].slider[sldnum].min THEN
			value:=epm[slotnum].slider[sldnum].min;
		IF value>epm[slotnum].slider[sldnum].max THEN
			value:=epm[slotnum].slider[sldnum].max;
		epm[slotnum].slider[sldnum].num:=value;
		min:=epm[slotnum].slider[sldnum].min;
		max:=epm[slotnum].slider[sldnum].max;
		xpos:=((144*(value-min)) div (max-min));

		{Restore old sliderbackground}
		Objc_Offset(obj_tree,obj+1,ax,ay);
		obj_tree^[obj+1].ob_x:=xpos;
		Objc_Draw(obj_tree,obj,1,ax,ay,16,16);

		{Draw new slider}
		DrawObj(obj_tree,obj+1);

	END;
	
	
	PROCEDURE Load_Modsettings(slotnum:Integer);
	VAR s,pfd,nam,dummy:String;
		fh:Text;
		cnt,bla:Integer;
	BEGIN
		WITH epm[slotnum] DO BEGIN
			FSplit(epmname,dummy,nam,dummy);
			FSplit(epmpath,pfd,dummy,dummy);
			s:=pfd+nam+'.INF';
			Assign(fh,s);
			Reset(fh);
			IF IORESULT=0 THEN BEGIN
				ReadLn(fh,s);	{Titelzeile}
				ReadLn(fh,cnt);
				FOR cnt:=1 TO 2 DO BEGIN
					Readln(fh,bla);
					IF bla<=anzpic THEN picpop[cnt].actpic:=bla;
				END;
				ReadLn(fh,cnt);
				FOR cnt:=1 TO 4 DO WITH slider[cnt] DO BEGIN
					Readln(fh,bla);
					IF bla<min THEN bla:=min;
					IF bla>max THEN bla:=max;
					num:=bla;
				END;
				ReadLn(fh,cnt);
				FOR cnt:=1 TO 2 DO Readln(fh,textin[cnt].input);
				ReadLn(fh,cnt);
				Readln(fh,fileselfile);
			END;
		END;	
	END;
	

	PROCEDURE Save_Modsettings(slotnum:Integer);
	VAR	s,pfd,nam,dummy:String;
		fh:Text;
		cnt:Integer;
	BEGIN
		WITH epm[slotnum] DO BEGIN
			FSplit(epmname,dummy,nam,dummy);
			FSplit(epmpath,pfd,dummy,dummy);
			s:=pfd+nam+'.INF';
			Assign(fh,s);
			Rewrite(fh);
			Writeln(fh,'ESCAPE PAINT MODULE PARAMETERS');
			Writeln(fh,2);
			FOR cnt:=1 TO 2 DO Writeln(fh,picpop[cnt].actpic);
			Writeln(fh,4);
			FOR cnt:=1 TO 4 DO Writeln(fh,slider[cnt].num);
			Writeln(fh,2);
			FOR cnt:=1 TO 2 DO Writeln(fh,textin[cnt].input);
			Writeln(fh,1);
			Writeln(fh,fileselfile);
			Close(fh);
		END;
	END;

BEGIN

	return:=0;
	
	{Get formular-adress}
	obj_tree:=GetRSCAdr(R_TREE,MOD_SET);

	{Load Parameters}
	Load_Modsettings(slotnum);

	{Initialize module}
	EPM_Init(slotnum);

	{Set first actual editobject or clear kb-flag}
	actobj:=0;
	IF epm[slotnum].anztext>0 THEN actobj:=MODSET_TXT1;
	IF epm[slotnum].anzslider>0 THEN actobj:=MODSET_SLDNUM1;
	IF actobj=0 THEN kbflag:=0 ELSE kbflag:=1;
	edobj:=actobj;
		
	{Draw Dialog}
	WinCalcWH(MODSETWIN);
	WITH win[MODSETWIN] DO Wind_Set(handle,WF_CURRXYWH,x,y,w,h);
	obj_tree:=GetRSCAdr(R_TREE,MOD_SET);
	Wind_Get(win[MODSETWIN].handle,WF_WORKXYWH,dx,dy,dw,dh);
	MoveObjects(MODSETWIN,dx,dy);
	WITH win[MODSETWIN] DO wind_open(handle,x,y,w,h);
	
	win[MODSETWIN].stat:=1;

	{Get formular-adress}
	obj_tree:=GetRSCAdr(R_TREE,MOD_SET);

	{Activate cursor}
	IF actobj<>0 THEN BEGIN
		GetPText(obj_tree,actobj,s);
		pos:=Length(s);
		IF kbflag=1 THEN Objc_Edit(obj_tree,actobj,20480,pos,EDINIT);
	END;
	
	result:=0;
	event:=0;
	REPEAT

		event:=Evnt_Multi( (MU_KEYBD OR MU_BUTTON OR MU_MESAG),
							1,1,3,0,0,0,0,0,0,0,0,0,0,win_eventbuf,0,0,
							mx,my,mb,dumm,keycode,dumm);
		
		{Keyboard input?}
		IF (event AND MU_KEYBD)<>0 THEN BEGIN
			edobj:=Keybd_Handle(obj_tree,actobj,keycode);
			{Handle input-characters}
			IF (edobj>0) AND (edobj<>MODSET_OK) THEN BEGIN
				IF (kbflag=1) AND (edobj<>actobj) THEN BEGIN
					Objc_Draw(obj_tree,actobj,MAX_DEPTH,x,y,w,h);
					actobj:=edobj;
					Objc_Edit(obj_tree,actobj,keycode,pos,EDINIT);
				END ELSE BEGIN
					{Test textfield}
					GetPText(obj_tree,actobj,s);
					Val(s,dumm,err);
					{If '-' pressed and textfield=number -> neg. value}
					IF ((keycode AND 255) = 45) AND (err=0) THEN BEGIN
						dumm:=-dumm;
						{test borders}
						IF (dumm>-1000) AND (dumm<10000) THEN BEGIN
							Str(dumm,s);
							SetPText(obj_tree,actobj,s);
							DrawObj(obj_tree,actobj);
							Objc_Edit(obj_tree,actobj,keycode,pos,EDINIT);
						END;
					{...else normal edit...}
					END ELSE Objc_Edit(obj_tree,actobj,keycode,pos,EDCHAR);
				END;
				
				{Set sliders if act.textfield = Slidervalue}
				IF ((actobj-1) div 7 <5) AND (actobj>-1) THEN BEGIN
					GetPText(obj_tree,actobj,s);
					Val(s,dumm,err);
					IF err=0 THEN SetSliderValue(actobj-2,dumm);
				END;
			END;
		END;
		
		{Mouseevents}
		IF (event AND MU_BUTTON)<>0 THEN BEGIN
			
			{Which object?}
			obj_tree:=GetRSCAdr(R_TREE,MOD_SET);
			result:=objc_find(obj_tree,0,MAX_DEPTH,mx,my);
			
			{Ignore bad clicks}
			IF result=-1 THEN result:=0;
			IF (obj_tree^[result].ob_state AND DISABLED)<>0 THEN result:=0;
			
			{Select button and wait...} 
			IF ((obj_tree^[result].ob_flags AND SELECTABLE)<>0) THEN HoldButton(result);
			
			{Select act. edit-obj}
			IF ((obj_tree^[result].ob_flags AND EDITABLE)<>0) AND (result<>actobj) THEN BEGIN
				IF actobj<>0 THEN Objc_Edit(obj_tree,actobj,keycode,pos,EDEND);
				Objc_Draw(obj_tree,actobj,MAX_DEPTH,x,y,w,h);
				actobj:=result;
				IF actobj<>0 THEN Objc_Edit(obj_tree,actobj,keycode,pos,EDINIT);
				Evnt_Button(0,3,0,mx,my,mb,kb);
			END;

			{Sliderbox? -> Set sliderposition} 
			IF (result=13) OR (result=20) OR (result=27) OR (result=34) THEN BEGIN
				MoveHSliderObj(result,mx);
				Evnt_Button(0,3,0,mx,my,mb,kb);
			END;
		
			{Slider? -> Move it!}
			IF (result=14) OR (result=21) OR (result=28) OR (result=35) THEN BEGIN
				{Originalkoordinates..}
				Objc_Offset(obj_tree,result,dx,dy);
				dw:=obj_tree^[result].ob_width;
				dh:=obj_tree^[result].ob_height;
			
				{Boarderkoordinates (Sliderbox)}
				Objc_Offset(obj_tree,result-1,bx,by);
				bw:=obj_tree^[result-1].ob_width;
				bh:=obj_tree^[result-1].ob_height;
				
				{Rubberbox}
				Graf_Dragbox(dw,dh,dx,dy,bx,by,bw,bh,dx,dy);
				
				{Set Slider on new position}
				MoveHSliderObj(result-1,dx+8);
			END;
			
			{Left Sliderarrows}
			IF (result=11) OR (result=18) OR (result=25) OR (result=32) THEN BEGIN
				{Select arrow}
				obj_tree^[result].ob_state:=SELECTED;
				DrawObj(obj_tree,result);

				{Move slider while the mousebutton is pressed}
				dumm:=(result-4) div 7;
				WITH epm[slotnum] DO REPEAT			
					IF slider[dumm].num>slider[dumm].min 
					THEN SetSliderValue(result+2,slider[dumm].num-1);
					Str(slider[dumm].num,s);
					SetPText(obj_tree,result+4,s);
					DrawObj(obj_tree,result+4);
					IF actobj=result+4 THEN BEGIN
						pos:=Length(s)-1;
						Objc_Edit(obj_tree,result+4,0,pos,EDINIT);
					END;
					Delay(50);
					Evnt_Button(0,0,0,mx,my,mb,kb);
					Evnt_Button(0,0,0,mx,my,mb,kb);
				UNTIL mb=0;

				{Deselect arrow}
				obj_tree^[result].ob_state:=NORMAL;
				DrawObj(obj_tree,result);
			END;
	

			{Right Sliderarrows}
			IF (result=12) OR (result=19) OR (result=26) OR (result=33) THEN BEGIN
				{Select arrow}
				obj_tree^[result].ob_state:=SELECTED;
				DrawObj(obj_tree,result);

				{Move slider while the mousebutton is pressed}
				dumm:=(result-5) div 7;
				WITH epm[slotnum] DO REPEAT			
					IF slider[dumm].num<slider[dumm].max 
					THEN SetSliderValue(result+1,slider[dumm].num+1);
					Str(slider[dumm].num,s);
					SetPText(obj_tree,result+3,s);
					DrawObj(obj_tree,result+3);
					IF actobj=result+3 THEN BEGIN
						pos:=Length(s)-1;
						Objc_Edit(obj_tree,result+3,0,pos,EDINIT);
					END;
					Delay(50);
					Evnt_Button(0,0,0,mx,my,mb,kb);
					Evnt_Button(0,0,0,mx,my,mb,kb);
				UNTIL mb=0;	

				{Deselect arrow}
				obj_tree^[result].ob_state:=NORMAL;
				DrawObj(obj_tree,result);
			END;
			
			
			{Picture Popup?}
			IF ((result=MODSET_PICPOP1) OR (result=MODSET_PICPOP2)) AND (anzpic>0) THEN BEGIN

				{Config and draw Popup}
				Objc_Offset(obj_tree,result,bx,by);
				Wind_Update(BEG_UPDATE);
				obj_tree:=GetRSCAdr(R_TREE,PICPOPUP);
				FOR dumm:=1 TO anzpic DO SetPText(obj_tree,dumm,pic[dumm].name);
				obj_tree^[0].ob_height:=anzpic*16-8;
				Form_Center(obj_tree,dx,dy,dw,dh);
				IF dy>by THEN dy:=by;
				IF (dy+dh)<by THEN dy:=by-dh+16;
				obj_tree^[0].ob_x:=bx;dx:=bx;
				obj_tree^[0].ob_y:=dy;

				{Draw Popup}
				Dec(dx,3);Dec(dy,3);Inc(dw,6);Inc(dh,6);
				Form_Dial(FMD_START,dx,dy,dw,dh,dx,dy,dw,dh);
				Objc_Draw(obj_tree,0,1,dx,dy,dw,dh);
				dumm:=1;
				
				REPEAT
					IF dumm>0 THEN BEGIN
						Inc(obj_tree^[dumm].ob_state,SELECTED);
						Objc_Draw(obj_tree,dumm,0,dx,dy,dw,dh);
					END;
					REPEAT
						Evnt_Button(0,0,0,mx,my,mb,kb);
						err:=Objc_Find(obj_tree,0,MAX_DEPTH,mx,my);
					UNTIL ((dumm<>err) AND (err>0)) OR (mb<>0);

					IF dumm>0 THEN BEGIN
						Dec(obj_tree^[dumm].ob_state,SELECTED);
						Objc_Draw(obj_tree,dumm,0,dx,dy,dw,dh);
					END;

					IF mb=0 THEN dumm:=err;
				UNTIL mb=1;
				
				{Reaktion...}
				IF (dumm<1) OR (dumm>anzpic) THEN dumm:=1;
				obj_tree:=GetRSCAdr(R_TREE,MOD_SET);
				SetPText(obj_tree,result,pic[dumm].name);
				epm[slotnum].picpop[(result-2) div 3].actpic:=dumm;
				
				{Bildschirmbereich freigeben}
				Form_Dial(FMD_FINISH,dx,dy,dw,dh,dx,dy,dw,dh);
				Wind_Update(END_UPDATE);
			END;
						
			
			{Fileselector ?}
			IF result=MODSET_FILECHSE THEN BEGIN
				Wind_Update(BEG_UPDATE);
				pfd:='';nam:='';
				FSel_ExInput(pfd,nam,fileresult,'Load '+epm[slotnum].fileseltype);
				Wind_Update(END_UPDATE);
				IF fileresult=1 THEN BEGIN
					SetPText(obj_tree,MODSET_FILENAME,nam);
					s:=pfd;
					FSplit(s,pfd,s,s);
					epm[slotnum].fileselfile:=pfd+nam;
				END;
				Redraw_Obj(obj_tree,win[MODSETWIN].handle,MODSET_FILENAME-3);
			END;
			
		END;

		IF (event AND MU_MESAG)<>0 THEN CASE win_eventbuf[0] OF
			{FENSTER VERSCHIEBEN}
				WM_MOVED: BEGIN
					winnum:=GetWinNum(win_eventbuf[3]);
					IF winnum>0 THEN WITH win[winnum] DO BEGIN
						Wind_Get(handle,WF_CURRXYWH,x,y,w,h);
						x:=win_eventbuf[4];
						y:=win_eventbuf[5];
						Wind_Set(handle,WF_CURRXYWH,x,y,w,h);
						Wind_Get(win_eventbuf[3],WF_WORKXYWH,dx,dy,dw,dh);
						obj_tree:=GetRSCAdr(R_TREE,win[winnum].dialog);
						obj_tree^[0].ob_x:=dx;
						obj_tree^[0].ob_y:=dy;
					END;
				END;
			{FENSTER NEUZEICHNEN}
				WM_REDRAW: BEGIN
					winnum:=GetWinNum(win_eventbuf[3]);
					RedrawForm(win_eventbuf[3],win_eventbuf[4],win_eventbuf[5],
						win_eventbuf[6],win_eventbuf[7],0);
{					IF winnum>0 THEN BEGIN
						IF win[winnum].stat=1 THEN BEGIN
							obj_tree:=GetRSCAdr(R_TREE,win[winnum].dialog);
							IF actobj<>0 THEN Objc_Edit(obj_tree,actobj,0,pos,EDEND);
							RedrawForm(win_eventbuf[3],win_eventbuf[4],
							win_eventbuf[5],win_eventbuf[6],win_eventbuf[7],0);
							obj_tree:=GetRSCAdr(R_TREE,MOD_SET);
							IF actobj<>0 THEN Objc_Edit(obj_tree,actobj,0,pos,EDINIT);
						END;
					END;}
				END;
		END;
		
		{Wenn OK gedrckt -> Parameter bernehmen und Flag setzen}
		IF (result=MODSET_OK) OR (edobj=MODSET_OK) THEN BEGIN
			WITH epm[slotnum] DO BEGIN
				GetPText(obj_tree,MODSET_TXT1,textin[1].input);
				GetPText(obj_tree,MODSET_TXT2,textin[2].input);
				GetPText(obj_tree,MODSET_TXT1,textin[1].input);
			END;
			Graf_Mouse(BUSYBEE,NIL);
			Call_Module(slotnum);
			PicWinUpdate;
			Graf_Mouse(ARROW,NIL);
			result:=-1;edobj:=-1;
			return:=1;
		END;

					
	UNTIL (((event AND MU_MESAG)<>0) AND (win_eventbuf[0]=WM_CLOSED)) OR
		   (result=MODSET_CANCEL);
		   
	IF return=1 THEN Save_Modsettings(slotnum);

{	HideWinForm(win[MODSETWIN].handle);
	win[MODSETWIN].stat:=0;}
	
	wind_close(win[MODSETWIN].handle);
	win[MODSETWIN].stat:=0;

	{Wait_Win;}

END;
