{PROZEDUR BERECHNET NTIGE FENSTERABMESSUNGEN FR DIALOGBOX}
PROCEDURE WinCalcWH(winnum:Integer);
VAR		fw,fh		:Integer;		{Dialogabmessungen}
		mist		:Integer;		{Dummy}
BEGIN
	WITH win[winnum] DO BEGIN
		obj_tree:=getrscadr(R_TREE,dialog);
		fw:=obj_tree^[0].ob_width;
		fh:=obj_tree^[0].ob_height;
		Wind_Calc(WC_BORDER,cont,mist,mist,fw,fh,mist,mist,w,h);
	END;
END;


{FUNKTION ZUM ERMITTELN DER FENSTERNUMMER AUS DEM HANDLE DES FENSTERS}
FUNCTION GetWinNum(winhandle:Integer):Integer;
VAR		i			:Integer;			{Index}
BEGIN
	GetWinNum:=0;
	FOR i:=1 TO ANZWIN DO IF winhandle=win[i].handle THEN GetWinNum:=i;
END;


{FUNKTION ZUM ERMITTELN DES TOP-WINDOWS}
FUNCTION GetTopWin:Integer;
VAR		winhandle	:Integer;			{Handle des getoppten Fensters}
		dummy		:Integer;
BEGIN
	Wind_Get(0,WF_TOP,winhandle,dummy,dummy,dummy);
	GetTopWin:=winhandle;
END;


{FUNKTION ZUM ZEICHNEN EINES DIALOGES IM FENSTER}
{RESULTAT: 0 BEI FEHLER}
FUNCTION DrawWinForm(winnum:Integer):Integer;
VAR		wx,wy,ww,wh	:Integer;		{Koordinaten des Fensters}
		fx,fy,fw,fh	:Integer;		{Koordinaten des Dialoges}
		i			:Integer;		{Objektindex}
		buf			:Array_8;		{Dummy-Buffer}
		flag		:Integer;		{Error-Flag}
BEGIN
	Wind_Update(BEG_UPDATE);
	{Wind_Update(BEG_MCTRL);}
	{MouseOff;}
	WITH win[winnum] DO BEGIN
		{obj_tree:=getrscadr(R_TREE,dialog);}
		Wind_Calc(WC_WORK,cont,x,y,w,h,fx,fy,fw,fh);
		MoveObjects(winnum,fx,fy+v_pos);
		{obj_tree^[0].ob_x:=fx;
		obj_tree^[0].ob_y:=fy;}
		{Fenster zeichnen}
		Graf_GrowBox(x+Trunc(w/2),y+Trunc(h/2),0,0,x,y,w,h);
		flag:=Wind_Open(handle,x,y,w,h);
		IF flag<>0 THEN BEGIN
			Form_Dial(FMD_START, x, y, w, h, x, y, w, h);
			obj_tree:=getrscadr(R_TREE,menu);
			Menu_ICheck(obj_tree,win[winnum].menubar,1);
		END;
		Wind_Update(END_UPDATE);
		{Wind_Update(END_MCTRL);}
		{MouseOn;}
	END;
	DrawWinForm:=flag;
END;


{PROZEDUR ZUM LSCHEN EINES DIALOGES MIT FENSTER}
PROCEDURE HideWinForm(winhandle:Integer);
VAR		wx,wy,ww,wh	:Integer;		{Koordinaten des Fensters}
		fx,fy,fw,fh	:Integer;		{Koordinaten des Dialoges}
		i			:Integer;		{Objektindex}
		winnum		:Integer;		{Fensternummer}
BEGIN
	{Ermitteln der Window-Nummer des dazugehrigen Handles}
	winnum:=GetWinNum(winhandle);
	Wind_Update(BEG_UPDATE);
	MouseOff;
	IF winnum>0 THEN WITH win[winnum] DO BEGIN
		Wind_Close(handle);
		Form_Dial(FMD_FINISH,x,y,w,h,x,y,w,h);
		Graf_ShrinkBox(x+Trunc(w/2),y+Trunc(h/2),0,0,x,y,w,h);
	END;
	MouseOn;
	obj_tree:=getrscadr(R_TREE,menu);
	Menu_ICheck(obj_tree,win[winnum].menubar,0);
	Wind_Update(END_UPDATE);
END;


{PROZEDUR ZEICHNET TEIL EINES FENSTERS NEU (-> WM_REDRAW)}
PROCEDURE RedrawForm(winhandle,cx,cy,cw,ch,objnum:Integer);
TYPE	Rect	=RECORD x,y,w,h:Integer END;
VAR		dirty	:Rect;
		f,r 	:Rect;
       	i		:Integer;
       	x,y,w,h	:Integer;
       	wx,wy,ww,wh:Integer;
       	winnum	:Integer;
       	pxyarray:ARRAY_4;
    {ZEICHNET EINEN BEREICH EINES DIALOGES NEU}
	PROCEDURE Draw_Teil(winnum,cx,cy,cw,ch:Integer);
	BEGIN
		obj_tree:=getrscadr(R_TREE,win[winnum].dialog);
		Objc_Draw(obj_tree, objnum, MAX_DEPTH,cx,cy,cw,ch);
	END;
	{PROZEDUR BERECHNET SCHNITTFLCHE ZWEIER RECHTECKE}
    PROCEDURE RectIntersect(r1:Rect;VAR r2:Rect);
    VAR x, y, w, h : Integer;
    	{FUNKTION ERMITTELT KLEINERE ZAHL VON A UND B}
    	FUNCTION Min(a,b:Integer):Integer;
       	BEGIN
           	IF a < b THEN Min:=a ELSE Min:=b;
        END;
        {FUNKTION ERMITTELT GRERE ZAHL VON A UND B}
		FUNCTION Max(a,b:Integer):Integer;
		BEGIN
			IF a>b THEN Max:=a ELSE Max:=b;
        END;
    BEGIN
      	{Schnittflche errechnen}
        x:=Max(r1.x,r2.x);
        y:=Max(r1.y,r2.y);
        w:=Min(r1.x+r1.w,r2.x+r2.w)-x;
        h:=Min(r1.y+r1.h,r2.y+r2.h)-y;
        r2.x:=x;
        r2.y:=y;
        r2.w:=w;
        r2.h:=h;
    END;
BEGIN
	{Fensternummer ermitteln}
	winnum:=GetWinNum(winhandle);
	IF winnum>0 THEN BEGIN
		{Vorbereitungen}
	    Wind_Get( 0, WF_WORKXYWH,f.x,f.y,f.w,f.h);
	    {neu zu zeichnender Bereich: dirty}
	    dirty.x:=cx;dirty.y:=cy;dirty.w:=cw;dirty.h:=ch;
	    {Berechnung der Schnittflche mit dem Bildschirm}
	    RectIntersect(f,dirty);
	    {ermitteln der Fensterkoordinaten}
	    IF winnum>0 THEN Wind_Get(win[winnum].handle,WF_FIRSTXYWH,r.x,r.y,r.w,r.h);
	    {der Reihe nach zeichnen der Teile}
	    WHILE (r.w>0) AND (r.h>0) DO BEGIN
	        {Schnittflche von Rechteck und Fenster}
	        RectIntersect(dirty,r);
	        IF (r.w>0) AND (r.h>0) THEN BEGIN
	            pxyarray[0]:=r.x;
	            pxyarray[1]:=r.y;
	            pxyarray[2]:=r.x+r.w-1;
	            pxyarray[3]:=r.y+r.h-1;
	            Vs_Clip(ghandle,1,pxyarray);
	            Draw_Teil(winnum,r.x,r.y,r.w,r.h);
	            Vs_Clip(ghandle,0,pxyarray);
	        END;
	        {nchstes Fenster}
	        Wind_Get(win[winnum].handle,WF_NEXTXYWH,r.x,r.y,r.w,r.h);
	    END;
	END ELSE BEGIN
	
		GotoXY(3,3);Write('ShittT!');
	END;
END;


{PROZEDUR ZEICHNET GENAU 1 OBJEKT NEU}
PROCEDURE Redraw_Obj(obj_tree:AESTreePtr;winhandle,objnum:Integer);
VAR		x,y,w,h:Integer;
BEGIN
	objc_offset(obj_tree,objnum,x,y);
	w:=obj_tree^[objnum].ob_width;
	h:=obj_tree^[objnum].ob_height;
	{3D-Elemente sollen mitgezeichnet werden -> Clipbereich vergrssern}
	Dec(x,2);Dec(y,2);Inc(w,4);Inc(h,4);
	Wind_Get(winhandle,WF_WORKXYWH,dx,dy,dw,dh);
	IF (x+w)>(dx+dw) THEN w:=dx-x+dw;
	IF (y+h)>(dy+dh) THEN h:=dy-y+dh;
	IF x<dx THEN x:=dx;
	IF y<dy THEN y:=dy{+2};
	{Wenn Topwindow angeklickt -> schnelle Variante}
	{IF GetTopWin=winhandle THEN BEGIN
		Objc_Draw(obj_tree, objnum, MAX_DEPTH,x-2,y-2,w+4,h+4);}
	{ansonsten langsame, aber 'ordentliche' Variante}
	{END ELSE BEGIN}
		RedrawForm(winhandle,x-2,y-2,w+4,h+4,objnum);
	{END;}	
END;


{PROZEDUR SELEKTIERT UND ZEICHNET FENSTEROBJEKT}
PROCEDURE Select(winnum,objnum:Integer);
VAR		obj_tree:AESTreePtr;
BEGIN
	obj_tree:=GetRSCAdr(R_TREE,win[winnum].dialog);
	Set_Obj_State(obj_tree,objnum,SELECTED);
	IF win[winnum].stat=1 THEN Redraw_Obj(obj_tree,win[winnum].handle,objnum);
END;


{PROZEDUR DESELEKTIERT UND ZEICHNET FENSTEROBJEKT}
PROCEDURE Deselect(winnum,objnum:Integer);
VAR		obj_tree:AESTreePtr;
BEGIN
	obj_tree:=GetRSCAdr(R_TREE,win[winnum].dialog);
	Set_Obj_State(obj_tree,objnum,NORMAL);
	IF win[winnum].stat=1 THEN Redraw_Obj(obj_tree,win[winnum].handle,objnum);
END;


{PROZEDUR SELEKTIERT UND ZEICHNET PANELOBJEKT}
PROCEDURE PanSelect(treenum,objnum:Integer);
VAR		obj_tree:AESTreePtr;
BEGIN
	obj_tree:=GetRSCAdr(R_TREE,treenum);
	Set_Obj_State(obj_tree,objnum,SELECTED);
	IF (win[PANEL].stat=1) AND (treenum=win[PANEL].dialog) THEN Redraw_Obj(obj_tree,win[PANEL].handle,objnum);
END;


{PROZEDUR DESELEKTIERT UND ZEICHNET PANELOBJEKT}
PROCEDURE PanDeselect(treenum,objnum:Integer);
VAR		obj_tree:AESTreePtr;
BEGIN
	obj_tree:=GetRSCAdr(R_TREE,treenum);
	Set_Obj_State(obj_tree,objnum,NORMAL);
	IF (win[PANEL].stat=1) AND (treenum=win[PANEL].dialog) THEN Redraw_Obj(obj_tree,win[PANEL].handle,objnum);
END;



{PROZEDUR ZUM AKTUALISIEREN DES BILDSCHIRMES (NACH FILESELEKTOR)}
PROCEDURE Wait_Win;
VAR		i:Integer;
BEGIN
	win_event:=0;FOR i:=0 TO 7 DO win_eventbuf[i]:=0;
	REPEAT
		win_event:=Evnt_Multi( (MU_KEYBD OR MU_MESAG OR MU_BUTTON OR MU_TIMER),
								3,0,0,0,0,0,0,0,0,0,0,0,0,win_eventbuf,0,0,
								mx,my,mb,key,keycode,anz_clic);
		IF win_eventbuf[0]=WM_REDRAW THEN BEGIN
			IF win[GetWinNum(win_eventbuf[3])].stat=1 THEN
			RedrawForm(win_eventbuf[3],win_eventbuf[4],
	  				   win_eventbuf[5],win_eventbuf[6],win_eventbuf[7],0);
	  	END;
	UNTIL ((win_event AND (MU_MESAG))=0) AND (mb=0);
END;


{PROZEDUR AKTUALISIERT SLIDER DES BILDWAHLFENSTERS}
PROCEDURE SetPicNumSliders;
VAR		position	:LongInt;
		size		:LongInt;
		wx,wy,ww,wh	:Integer;
		real_height	:LongInt;
		difference	:LongInt;
BEGIN
	real_height:=24*anzpic;
	Wind_Get(win[CHOOSEPIC].handle,WF_WORKXYWH,wx,wy,ww,wh);
	IF real_height>wh THEN BEGIN
		size:=LongInt(wh)*1000 div real_height;
		{size:=(size*1000) div real_height}
	END ELSE size:=1000;
	difference:=real_height-wh;
	IF (real_height>wh) THEN BEGIN
		position:=-1000*win[CHOOSEPIC].v_pos div difference;
		IF position>1000 THEN position:=1000;
		IF position<0 THEN position:=0;
	END ELSE position:=0;

	{Slider setzen}
	size:=1000;position:=0;
	Wind_Set(win[CHOOSEPIC].handle,WF_VSLSIZE,size,0,0,0);
	Wind_Set(win[CHOOSEPIC].handle,WF_VSLIDE,position,0,0,0);
END;

{PROZEDUR AKTUALISIERT SLIDER DES MODULFENSTERS}
PROCEDURE SetModuleSliders;
VAR		position	:LongInt;
		size		:LongInt;
		wx,wy,ww,wh	:Integer;
		real_height	:LongInt;
		difference	:LongInt;
BEGIN
	real_height:=24*anzpic;
	Wind_Get(win[MODWIN].handle,WF_WORKXYWH,wx,wy,ww,wh);
	IF real_height>wh THEN BEGIN
		size:=LongInt(wh)*1000 div real_height;
		{size:=(size*1000) div real_height}
	END ELSE size:=1000;
	difference:=real_height-wh;
	IF (real_height>wh) THEN BEGIN
		position:=-1000*win[MODWIN].v_pos div difference;
		IF position>1000 THEN position:=1000;
		IF position<0 THEN position:=0;
	END ELSE position:=0;

	{Slider setzen}
	size:=1000;position:=0;
	Wind_Set(win[MODWIN].handle,WF_VSLSIZE,size,0,0,0);
	Wind_Set(win[MODWIN].handle,WF_VSLIDE,position,0,0,0);
END;


{PROCEDURE UPDATES THE PICTURE-WINDOW}
PROCEDURE PicWinUpdate;
VAR	cnt			:Integer;
	o_obj_tree	:AESTreePtr;
BEGIN
	{save old obj-tree-pointer}
	o_obj_tree:=obj_tree;
	
	{set new obj-tree-adress (Picturewindow)}
	obj_tree:=GetRSCAdr(R_TREE,PICNUM);
	
	FOR cnt:=1 TO anzpic DO BEGIN
		{test buttonstate (selection)}
		IF cnt=par.actscr THEN obj_tree^[cnt].ob_state:=SELECTED
						  ELSE obj_tree^[cnt].ob_state:=NORMAL;
		
		{test buttonconf.}
		IF (obj_tree^[cnt].ob_flags AND HIDETREE)<>0 THEN BEGIN
			SetPText(obj_tree,cnt,pic[cnt].name);
			Unhide_Obj(cnt);
			Redraw_Obj(GetRSCAdr(R_TREE,PICNUM),win[CHOOSEPIC].handle,cnt);
		END;
	
	END;
	{restore old obj-tree-pointer}
	obj_tree:=o_obj_tree;
END;
