;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ANTIALIASEN EINES BILDBEREICHES

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export blked_antia



TEXT


blked_antia:
	move.l	4(sp), d3
	;d0:	x-Position	(linke obere Ecke des Rechteckes)
	;d1:	y-Position	(	"	"		"	"		"	)
	;d2:	Breite
	;d3:	Hhe
	;a0:	Screen
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse bestimmen
	adda.l	d1, a0
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d2, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;x- und y-Zhler
	;Hhe als y-Counter

	subq.l	#3, d3
blk_anti_y_loop:
	;erste Spalte berspringen
	addq.l	#2, a0
	;Breite als x-Counter
	move.l	d2, d4
	subq.l	#3, d4
blk_anti_x_loop:

	clr.l	d1
	;Rot
	clr.w	d5
	move.w	(a0), d6
	and.w	#%1111100000000000, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	1280(a0), d6
	and.w	#%1111100000000000, d6
	bset	#11, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	638(a0), d6
	and.w	#%1111100000000000, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	642(a0), d6
	and.w	#%1111100000000000, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	2(a0), d6
	and.w	#%1111100000000000, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	1282(a0), d6
	and.w	#%1111100000000000, d6
	bset	#11, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	1278(a0), d6
	and.w	#%1111100000000000, d6
	bset	#11, d6
	lsr.w	#5, d6
	add.w	d6, d5
	move.w	640(a0), d6
	and.w	#%1111100000000000, d6
	lsr.w	#5, d6
	mulu.w	#9, d6
	add.w	d6, d5
	lsl.w	#1, d5
	and.w	#%1111100000000000, d5
	add.w	d5, d1

	;Grn
	clr.w	d5
	move.w	(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	1280(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	638(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	642(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	2(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	1282(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	1278(a0), d6
	and.w	#%0000011111100000, d6
	add.w	d6, d5
	move.w	640(a0), d6
	and.w	#%0000011111100000, d6
	mulu.w	#9, d6
	add.w	d6, d5
	lsr.w	#4, d5
	and.w	#%0000011111100000, d5
	add.w	d5, d1
	
	;Blau
	clr.w	d5
	move.w	(a0), d6
	and.w	#%0000000000011111, d6
	add.w	d6, d5
	move.w	1280(a0), d6
	and.w	#%0000000000011111, d6
	bset	#0, d6
	add.w	d6, d5
	move.w	638(a0), d6
	and.w	#%0000000000011111, d6
	add.w	d6, d5
	move.w	642(a0), d6
	and.w	#%0000000000011111, d6
	add.w	d6, d5
	move.w	2(a0), d6
	and.w	#%0000000000011111, d6
	add.w	d6, d5
	move.w	1282(a0), d6
	and.w	#%0000000000011111, d6
	bset	#0, d6
	add.w	d6, d5
	move.w	1278(a0), d6
	and.w	#%0000000000011111, d6
	bset	#0, d6
	add.w	d6, d5
	move.w	640(a0), d6
	and.w	#%0000000000011111, d6
	mulu.w	#9, d6
	add.w	d6, d5
	lsr.w	#4, d5
	and.w	#%0000000000011111, d6
	add.w	d5, d1
	
	move.w	d1, 640(a0)
	addq.l	#2, a0

	dbf		d4, blk_anti_x_loop
	;letzte Spalte berspringen
	addq.l	#2, a0
	;Lineoffset
	adda.l	d0, a0
	dbf		d3, blk_anti_y_loop


rts


END