;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM NEGIEREN EINES BILDBEREICHES

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export blked_neg


TEXT


;NEGIERT EINEN BILDBEREICH
blked_neg:
	move.l	4(sp), d3
	;d0:	x-Position	(linke obere Ecke des Rechteckes)
	;d1:	y-Position	(	"	"		"	"		"	)
	;d2:	Breite
	;d3:	Hhe
	;a0:	Screen
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse bestimmen
	adda.l	d1, a0
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d2, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d3
blk_neg_y_loop:
	;Breite als x-Counter
	move.l	d2, d4
	subq.l	#1, d4
blk_neg_x_loop:

	not.w	(a0)+

	dbf		d4, blk_neg_x_loop
	adda.l	d0, a0
	dbf		d3, blk_neg_y_loop
rts	


END