export circle

;INCLUDE "XOR_MKRO.INC"
INCLUDE "NEWPIXEL.INC"


;ZUM ZEICHNEN EINES KREISES
circle:
	;d0:	x-Koordinate des Mittelpunktes
	;d1:	y-Koordinate des Mittelpunktes
	;d2:	Radius
	move.l	4(sp), d3
	move.l	8(sp), d4
	;d3:	Farbe
	;d4:	Zeichenmodus
	;a0:	Bildschirmanfangsadresse
		
    movea.l A0,A1
    moveq   #1,D5
    add.w   D2,D5           ; D5 = Radius+1
    mulu    D2,D5           ; D5 = "Radiusquadrat"
    moveq   #0,D6           ;     D6 = X-Diff
							; nun D2 = Y-Diff
    move.w  D0,-(SP)
    move.w  D1,-(SP)

circle_loop:    
	move.w  2(SP),D0
    move.w  (SP),D1
    movea.l A1,A0
    add.w   D6,D0
    sub.w   D2,D1
    ;bsr     cplot           ;
    setpix	d0, d1, d3, d4, a0
    move.w  2(SP),D0
    move.w  (SP),D1
    movea.l A1,A0
    add.w   D2,D1
    add.w   D6,D0
    ;bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    movea.l A1,A0
    move.w  2(SP),D0
    move.w  (SP),D1
    add.w   D2,D1
    sub.w   D6,D0
    ;bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    movea.l A1,A0
    move.w  (SP),D1
    move.w  2(SP),D0
    sub.w   D6,D0
    sub.w   D2,D1
;    bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    movea.l A1,A0
    move.w  2(SP),D0
    move.w  (SP),D1
    add.w   D2,D0
    sub.w   D6,D1
    ;bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    move.w  (SP),D1
    move.w  2(SP),D0
    movea.l A1,A0
    add.w   D2,D0
    add.w   D6,D1
    ;bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    movea.l A1,A0
    move.w  2(SP),D0
    move.w  (SP),D1
    add.w   D6,D1
    sub.w   D2,D0
    ;bsr.s   cplot           ;
    setpix	d0, d1, d3, d4, a0
    movea.l A1,A0
    move.w  (SP),D1
    move.w  2(SP),D0
    sub.w   D2,D0
    sub.w   D6,D1
    ;bsr.s   cplot
    setpix	d0, d1, d3, d4, a0
    addq.w  #1,D6
    move.w  D6,-(SP)
    mulu    D6,D6
    move.w  D2,D7
    mulu    D7,D7
    add.l   D6,D7           ; D7 = XD^2 + YD^2
    move.w  (SP)+,D6
    cmp.l   D7,D5
    bge.s   circle_ycon
    subq.w  #1,D2
circle_ycon:    
	cmp.w   D2,D6
    ble     circle_loop
    addq.l  #4,SP
rts

cplot:          
	;d0:	x
	;d1:	y
	;d3:	Farbe
	;a0:	Screen
	movem.l	d0-d3/a0, -(sp)
	
	;Prfen, ob Pixel im Bildbereich
	cmpi.l	#0, d0
	blt		put_abbruch
	cmpi.l	#319, d0
	bgt		put_abbruch
	cmpi.l	#0, d1
	blt		put_abbruch
	cmpi.l	#239, d1
	bgt		put_abbruch
	;Pixeladresse berechnen
	lsl.l	d0
	mulu.w	#640,d1
	add.l	d1, d0
	adda.l	d0, a0
	;Pixel setzen
	cmpi.l	#-1, d3
	bgt		no_xor_c
	;MAKE_XOR a0, d3
no_xor_c:
	move.w	d3, (a0)
put_abbruch:
	movem.l	(sp)+, d0-d3/a0
rts
