******************************************  ******************
** PIXELWEISE ROTATION MIT ANTIALIASING **  ** by NO/Escape **
**     LANGSAM ABER GUTES ERGEBNIS      **  ** 07'96        **
******************************************  ******************

export rotation

TEXT

rotation:
	move.l	4(sp), a2
	move.l	8(sp), a3
	;d0:	Winkel
	;a0:	Sintab
	;a1:	Costab
	;a2:	Quellbild
	;a3:	Zielbild
	
	;push registers
	movem.l	d0-d7/a0-a6, -(sp)
	
	;get cos and sin
	move.l	d0, d4
	move.l	(a0,d4.l*4), d0		;sinus (nich putt machen...fr spter)
	move.l	(a1,d4.l*4), d1		;cosin

	;Anfangspixel berechnen (x=2*(-160+1) ; y=2*(-120+1))
	;umgestellte Rotationsformeln:
	;x=y'sina + x'cosa
	;y=y'cosa - x'sina
	
	move.l	#-320, d2			;x'
	move.l	#-240, d3			;y'
	
	;Werte in Abhngigkeit vom Winkel n bissl Modifizieren ;-)
	cmpi.l	#90, d4
	bne		wkl_ne_90
	addq.l	#1, d2
wkl_ne_90:
	cmpi.l	#180, d4
	bne		wkl_ne_180
	addq.l	#1, d2
	addq.l	#1, d3
wkl_ne_180:
	cmpi.l	#270, d4
	bne		wkl_ne_270
	addq.l	#1, d3
wkl_ne_270:
	
	;erstes x berechnen (so richtig mit Rotation und so....)
	move.l	d2, d4
	muls.l	d1, d4				;x'cosa
	move.l	d3, d5
	muls.l	d0, d5				;y'sina
	add.l	d5, d4
	movea.l	d4, a4
	;a4:	x=y'sina + x'cosa
	
	;erstes y berechnen
	muls.l	d0, d2				;x'sina
	muls.l	d1, d3				;y'cosa
	sub.l	d2, d3
	movea.l	d3, a5
	;a5:	y=y'cosa - x'sina
	
	;y-loop
	move.l	#240-1, d2
rot_y_loop:

	;x und y wiederherstellen
	move.l	a4, d4
	move.l	a5, d5

	;x-loop
	move.l	#320-1, d3
rot_x_loop:

	;d4:	x
	;d5:	y

	move.l	d3, -(sp)

*******************

	;Es werden 4 Pixel berechnet und der Durchschnitt gezeichnet (1Pixel)
	
	;Pixel 1 (x,y)
	move.l	d4, d6
	move.l	d5, d7
	bsr		rot_calc_pixel
	move.w	a0, -(sp)

	;Pixel 2 (x+1,y)
	move.l	d4, d6
	move.l	d5, d7		
	add.l	d1, d6
	sub.l	d0, d7
	bsr		rot_calc_pixel
	move.w	a0, -(sp)

	;Pixel 3 (x, y+1)
	move.l	d4, d6
	move.l	d5, d7
	add.l	d0, d6
	add.l	d1, d7
	bsr		rot_calc_pixel
	move.w	a0, -(sp)

	;Pixel 4 (x+1, y+1)
	move.l	d4, d6
	move.l	d5, d7
	add.l	d1, d6
	sub.l	d0, d7
	add.l	d0, d6
	add.l	d1, d7
	bsr		rot_calc_pixel
	move.w	a0, -(sp)
		

********************* MA ZEISCHNEN ********************

	;Stack: 4 Words (Farbwerte)
	;a3:	aktuelle Punktadresse (Zielpixel)
	;benutzte Register: a0(r),a1(g),d3(b),d6,d7
	
	clr.l	a0
	clr.l	a1
	clr.l	d3
	
	REPT 4
	
	move.w	(sp)+, d6
	;rot
	move.w	d6, d7
	andi.l	#%1111100000000000, d7
	add.l	d7, a0
	;grn
	move.w	d6, d7
	andi.l	#%11111100000, d7
	add.w	d7, a1
	;blau
	move.w	d6, d7
	andi.l	#%11111, d7
	add.w	d7, d3
	
	ENDM
	
	move.l	a0, d6
	lsr.l	#2, d6
	andi.l	#%1111100000000000, d6
	move.l	a1, d7
	lsr.l	#2, d7
	andi.l	#%11111100000, d7
	lsr.l	#2, d3	
	;andi.l	#%11111, d3
	
	add.l	d3, d6
	add.l	d7, d6
	
	;Pixel zeichnen
	move.w	d6, (a3)+
	

*********************
	
	move.l	(sp)+, d3
	
	;x' um 2 erhhen... x=x+2*cosa ; y=y-2*sina
	add.l	d1, d4
	add.l	d1, d4
	sub.l	d0, d5
	sub.l	d0, d5

	dbf		d3, rot_x_loop

	;y um 2 erhhen... x=x+sina ; y=y+cosa
	adda.l	d0, a4
	adda.l	d0, a4
	adda.l	d1, a5
	adda.l	d1, a5

	dbf		d2, rot_y_loop

	;pull registers
	movem.l	(sp)+, d0-d7/a0-a6

rts


;ROUTINE ZUM TESTEN UND BERECHNEN EINER PIXELFARBE FR ROTATION
rot_calc_pixel:
	;d6:	x
	;d7:	y

	;Koordinaten berechnen
	asr.l	#8, d6
	add.l	#2*160, d6
	asr.l	#1, d6
	asr.l	#8, d7
	add.l	#2*120, d7
	asr.l	#1, d7
	clr.l	a6				;drawflag	(0..draw)
	;testen...
	cmpi.l	#0, d6			;x<0 ?
	bge		rot_x_ge_0
	addq.l	#1, a6			;drawflag++
rot_x_ge_0:
	cmpi.l	#0, d7			;y<0 ?
	bge		rot_y_ge_0
	addq.l	#1, a6			;drawflag++
rot_y_ge_0:
	cmpi.l	#320, d6		;x>319 ?
	blt		rot_x_lt_320
	addq.l	#1, a6			;drawflag++
rot_x_lt_320:
	cmpi.l	#240, d7		;y>239 ?
	blt		rot_y_lt_240
	addq.l	#1, a6			;drawflag++
rot_y_lt_240:

	
	;Wenn a6 immer noch 0 ist, wird die Pixelfarbe genommen, sonst schwarz
	;Nu berechnen woh ma de Bildadresse
	clr.l	a0
	tst.l	a6
	bne		rot_black_pixel
	mulu.l	#320, d7		;y*lineoffset + x
	add.l	d6, d7
	move.w	(a2, d7.l*2), a0
rot_black_pixel:
	
	;a0:	resultat:	Pixelfarbe oder 0 (schwarz)
rts

