;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ZEICHNEN EINER LINIE

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export line4

line4:
	move.l	4(sp), d3
	move.l	8(sp), d4
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;d4:	Farbe
	;a0:	Bildschirmadresse
	move.l	d4, a1					;Backup

	;DX UND DY ERMITTELN
	move.l	d2, d4
	sub.l	d0, d4
	;d4:	dx
	move.l	d3, d5
	sub.l	d1, d5
	;d5:	dy
	
	;FALLUNTERSCHEIDUNGEN

	;DX < 0 ?
	
	cmpi.l	#0, d4
	blt		dx_kleiner_null

dx_groesser_null:
	move.l	#1, d6
	bra		dx_ok

dx_kleiner_null:
	neg.l	d4
	move.l	#-1, d6
	
dx_ok:

	;DY < 0 ?
	
	cmpi.l	#0, d5
	blt		dy_kleiner_null
	
dy_groesser_null:
	move.l	#1, d7
	bra		dy_ok
	
dy_kleiner_null:
	neg.l	d5
	move.l	#-1, d7
	
dy_ok:

	;DY = 0 ?
	
	cmpi.l	#0, d5
	beq		dy_gleich_null
	
dy_ungleich_null:
	move.l	#0, a2
	bra		dy0_ok
	
dy_gleich_null:
	move.l	#-1, a2
	
dy0_ok:

	;HAUPTSCHLEIFE
	
main_lineloop:

	;PIXEL SETZEN
	movem.l	d0-d1/a0, -(sp)
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	move.w	a1, (a0)
	movem.l	(sp)+, d0-d1/a0
	
	;BEDINGUNG UM SCHLEIFE ZU VERLASSEN: X=X_END UND Y=Y_END
	cmp.l	d0, d2
	bne		x_ungleich
	cmp.l	d1, d3
	beq		line_end
x_ungleich:
	
	;FALLUNTERSCHEIDUNG
	cmpa.l	#0, a2
	bge		e_groesser_null
	
e_kleiner_null:
	add.l	d6, d0
	adda.l	d5, a2
	bra		e_ok
	
e_groesser_null:
	add.l	d7, d1
	suba.l	d4, a2

e_ok:

	bra main_lineloop
	
line_end:
	
rts		
