export mod_start_type1
export reloc_prg
export jump


TEXT


;RELOZIIERT PROGRAMM IM SPEICHER
reloc_prg:
                movem.l D0-A6,-(SP)
                movea.l A0,A6
                lea     -256+28(A6),A5  ;Keine Base-Page einrichten
                move.l  A6,(A5)+        ;PRG-Start

                movea.l A5,A4
                clr.l   (A5)+
                move.l  A6,(A5)+        ;TEXT-Adr

                move.l  2(A6),D0
                move.l  D0,(A5)+        ;TEXT-Len
                lea     0(A6,D0.l),A0
                move.l  A0,(A5)+        ;DATA-Start
                move.l  6(A6),D0
                move.l  D0,(A5)+        ;DATA-Len
                adda.l  D0,A0
                move.l  A0,(A5)+        ;BSS-Start
                move.l  10(A6),(A5)+    ;BSS-Len
                adda.l  10(A6),A0
                move.l  A0,(A4)         ;Free-RAM-End

                lea     -256+28(A6),A0

reloc:          movea.l 2(A6),A0        ;text segment
                adda.l  6(A6),A0        ;+ data segment
                adda.l  14(A6),A0       ;+ symbol table
                lea     28(A0),A0       ;+ header
                adda.l  A6,A0           ;+ start of program
;                                        a0 now points to relocation table
                lea     28(A6),A6       ;a6 points to program
                move.l  A6,D0           ;d0 points to TEXT (BASEADRESSE)
                tst.l   (A0)            ;zero 1st relocation?
                beq.s   done_reloc

                moveq   #0,D1
                adda.l  (A0)+,A6        ;+ 1st Offset
relocate:       add.l   D0,(A6)         ;relocate it
add_no_reloc:   move.b  (A0)+,D1        ;next byte
                beq.s   done_reloc      ;zero is end
                cmp.b   #1,D1           ;1 is add 254, but
                bne.s   not1            ;don't relocate
                lea     254(A6),A6
                bra.s   add_no_reloc
not1:           adda.l  D1,A6           ;+ offset
                bra.s   relocate

done_reloc:
                movem.l (SP)+,D0-A6
rts









;ROUTINE ZUM AUFRUFEN EINES PROGRAMMODULES
mod_start_type1:
;	illegal
;	nop
	;a0:	Adresse der Programmstruktur
	;a1:	Moduladresse
	;Register pushen
	movem.l	d1-d7/a0-a6,-(sp)
	;Modulroutine aufrufen
	jsr		(a1)  ;28
	;Register pullen
	movem.l	(sp)+, d1-d7/a0-a6
rts

jump:
	;a0:	EP-struct
	;a1:	Adresse der Routine
	movem.l	d0-a6,-(sp)
	
	jsr 	28(a1)
	
	
	movem.l	(sp)+,d0-a6
rts


BSS

old_stack: ds.l	1

END