;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM SETZEN UND AUFRAGEN VON EINZELNEN PIXELN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


export setpixel
export getpixel

TEXT

;ZUM SETZEN EINES PIXELS
setpixel:
	;d0:	x-Koordinate
	;d1:	y-Koordinate
	;d2:	x-Auflsung
	;4(sp): Farbe
	;a0:	Screenadresse
	move.l	4(sp), d3
	;lsl.l	d2
	;lsl.l	d0
	;mulu.w	d2, d1
	;add.l	d0, d1
	;adda.l	d1, a0
	;move.w	d3, (a0)
	
	mulu.l	d2, d1				;y*x_rez
	add.l	d0, d1				;+x
	cmpi.l	#-1, d3
	beq		negative
	move.w	d3, (a0,d1.l*2)		;set pixel
	bra		pix_end
negative:
	not.w	(a0,d1.l*2)			;negative pixel
pix_end:
rts


;ZUM ERMITTELN EINER PIXELFARBE
getpixel:
	;d0:	x-Koordinate
	;d1:	y-Koordinate
	;d2:	x-Auflsung
	;a0:	Screenadresse
	;lsl.l	d2
	;lsl.l	d0
	;mulu.w	d2, d1
	;add.l	d0, d1
	;adda.l	d1, a0
	;clr.l	d0
	;move.w	(a0), d0 
	
	mulu.w	d2, d1
	add.l	d0, d1
	clr.l	d0
	move.w	(a0,d1.l*2), d0
rts

END