;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM ZEICHNEN EINER REALTIME-LUPE

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


export r_draw_zoom9
export r_draw_zoom7
export r_draw_zoom5
export r_draw_zoom3

text


;ZUM ZEICHNEN EINER REALTIME-LUPE MIT 9-FACHER VERGRERUNG
r_draw_zoom9:
	;d0:	x-Position der Maus
	;d1:	y-Position der Maus
	;d2:	x-Position der Lupe
	;4(sp): y-Position der Lupe
	;8(sp): Gridflag
	;a0:	Bildadresse
	;a1:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d6
	
	;Adresse des Mauscursors berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	;move.l	a0, a1
	adda.l	d1, a0
	;a0:	Adresse des Mauscursors
	
	;Adresse der linken, oberen Ecke der Lupe berechnen
	mulu.w	#640, d3
	lsl.l	d2
	add.l	d2, d3
	adda.l	d3, a1
	;a1:	Adresse der linken, oberen Ecke
	
	move.l	#10, d3
r_d_z9_loop1:
	
	move.l	#10, d4
r_d_z9_loop2:

	
	move.l	#7, d5
	cmpi.l	#1, d6
	beq		r_d_z9_loop3
	move.l	#8, d5
r_d_z9_loop3:
	move.w	(a0), (a1)
	move.w	(a0), 640(a1)
	move.w	(a0), 1280(a1)
	move.w	(a0), 1920(a1)
	move.w	(a0), 2560(a1)
	move.w	(a0), 3200(a1)
	move.w	(a0), 3840(a1)
	move.w	(a0), 4480(a1)
	cmpi.l	#1, d6
	beq		line9_black
	move.w	(a0), 5120(a1)
	bra		line9_colored
line9_black:
	move.w	#0, 5120(a1)
line9_colored:
	addq.l	#2, a1
	
	dbf		d5, r_d_z9_loop3

	cmpi.l	#0, d6
	beq		no_black_column9

	move.w	#0, (a1)
	move.w	#0, 640(a1)
	move.w	#0, 1280(a1)
	move.w	#0, 1920(a1)
	move.w	#0, 2560(a1)
	move.w	#0, 3200(a1)
	move.w	#0, 3840(a1)
	move.w	#0, 4480(a1)
	move.w	#0, 5120(a1)
	addq.l	#2, a1
	
no_black_column9:

	addq.l	#2, a0
	dbf		d4, r_d_z9_loop2
	
	adda.l	#8*640, a1
	adda.l	#442, a1
	adda.l	#618, a0
	dbf		d3, r_d_z9_loop1

rts




;ZUM ZEICHNEN EINER REALTIME-LUPE MIT 7-FACHER VERGRERUNG
r_draw_zoom7:
	;d0:	x-Position der Maus
	;d1:	y-Position der Maus
	;d2:	x-Position der Lupe
	;4(sp): y-Position der Lupe
	;8(sp): Gridflag
	;a0:	Bildadresse
	;a1:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d6
	
	;Adresse des Mauscursors berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	;move.l	a0, a1
	adda.l	d1, a0
	;a1:	Adresse des Mauscursors
	
	;Adresse der linken, oberen Ecke der Lupe berechnen
	mulu.w	#640, d3
	lsl.l	d2
	add.l	d2, d3
	adda.l	d3, a1
	;a0:	Adresse der linken, oberen Ecke
	
	move.l	#14, d3
r_d_z7_loop1:
	
	move.l	#14, d4
r_d_z7_loop2:

	
	move.l	#5, d5
	cmpi.l	#1, d6
	beq		r_d_z7_loop3
	move.l	#6, d5
r_d_z7_loop3:
	move.w	(a0), (a1)
	move.w	(a0), 640(a1)
	move.w	(a0), 1280(a1)
	move.w	(a0), 1920(a1)
	move.w	(a0), 2560(a1)
	move.w	(a0), 3200(a1)
	cmpi.l	#1, d6
	beq		line7_black
	move.w	(a0), 3840(a1)
	bra		line7_colored
line7_black:
	move.w	#0, 3840(a1)
line7_colored:
	addq.l	#2, a1
	
	dbf		d5, r_d_z7_loop3

	cmpi.l	#0, d6
	beq		no_black_column7

	move.w	#0, (a1)
	move.w	#0, 640(a1)
	move.w	#0, 1280(a1)
	move.w	#0, 1920(a1)
	move.w	#0, 2560(a1)
	move.w	#0, 3200(a1)
	move.w	#0, 3840(a1)
	addq.l	#2, a1
	
no_black_column7:

	addq.l	#2, a0
	dbf		d4, r_d_z7_loop2
	
	adda.l	#6*640, a1
	adda.l	#430, a1
	adda.l	#610, a0
	dbf		d3, r_d_z7_loop1

rts




;ZUM ZEICHNEN EINER REALTIME-LUPE MIT 5-FACHER VERGRERUNG
r_draw_zoom5:
	;d0:	x-Position der Maus
	;d1:	y-Position der Maus
	;d2:	x-Position der Lupe
	;4(sp): y-Position der Lupe
	;8(sp): Gridflag
	;a0:	Bildadresse
	;a1:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d6
	
	;Adresse des Mauscursors berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	;move.l	a0, a1
	adda.l	d1, a0
	;a1:	Adresse des Mauscursors
	
	;Adresse der linken, oberen Ecke der Lupe berechnen
	mulu.w	#640, d3
	lsl.l	d2
	add.l	d2, d3
	adda.l	d3, a1
	;a0:	Adresse der linken, oberen Ecke
	
	move.l	#20, d3
r_d_z5_loop1:
	
	move.l	#20, d4
r_d_z5_loop2:

	
	move.l	#3, d5
	cmpi.l	#1, d6
	beq		r_d_z5_loop3
	move.l	#4, d5
r_d_z5_loop3:
	move.w	(a0), (a1)
	move.w	(a0), 640(a1)
	move.w	(a0), 1280(a1)
	move.w	(a0), 1920(a1)
	cmpi.l	#1, d6
	beq		line5_black
	move.w	(a0), 2560(a1)
	bra		line5_colored
line5_black:
	move.w	#0, 2560(a1)
line5_colored:
	addq.l	#2, a1
	
	dbf		d5, r_d_z5_loop3

	cmpi.l	#0, d6
	beq		no_black_column5

	move.w	#0, (a1)
	move.w	#0, 640(a1)
	move.w	#0, 1280(a1)
	move.w	#0, 1920(a1)
	move.w	#0, 2560(a1)
	addq.l	#2, a1
	
no_black_column5:

	addq.l	#2, a0
	dbf		d4, r_d_z5_loop2
	
	adda.l	#2560, a1
	adda.l	#430, a1
	adda.l	#598, a0
	dbf		d3, r_d_z5_loop1

rts



;ZUM ZEICHNEN EINER REALTIME-LUPE MIT 3-FACHER VERGRERUNG
r_draw_zoom3:
	;d0:	x-Position der Maus
	;d1:	y-Position der Maus
	;d2:	x-Position der Lupe
	;4(sp): y-Position der Lupe
	;8(sp): Gridflag
	;a0:	Bildadresse
	;a1:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d6
	
	cmpi.l	#1, d6
	beq		r_3_raster
	
	;REALTIME-3-ZOOM OHNE RASTER

	;Adresse des Mauscursors berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	;move.l	a0, a1
	adda.l	d1, a0
	;a1:	Adresse des Mauscursors
	
	;Adresse der linken, oberen Ecke der Lupe berechnen
	mulu.w	#640, d3
	lsl.l	d2
	add.l	d2, d3
	adda.l	d3, a1
	;a0:	Adresse der linken, oberen Ecke
	
	move.l	#34, d3
r_d_z3_loop1:
	
	move.l	#34, d4
r_d_z3_loop2:

	
	move.l	#2, d5
r_d_z3_loop3:
	move.w	(a0), (a1)
	move.w	(a0), 640(a1)
	move.w	(a0), 1280(a1)
	addq.l	#2, a1
	
	dbf		d5, r_d_z3_loop3

	addq.l	#2, a0
	dbf		d4, r_d_z3_loop2
	
	adda.l	#1280, a1
	adda.l	#430, a1
	adda.l	#570, a0
	dbf		d3, r_d_z3_loop1
	
	bra		r_3_end	
	

	;REALTIME-3-ZOOM MIT RASTER

r_3_raster:

	;Adresse des Mauscursors berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	;move.l	a0, a1
	adda.l	d1, a0
	;a1:	Adresse des Mauscursors
	
	;Adresse der linken, oberen Ecke der Lupe berechnen
	mulu.w	#640, d3
	lsl.l	d2
	add.l	d2, d3
	adda.l	d3, a1
	;a0:	Adresse der linken, oberen Ecke
	
	move.l	#34, d3
r_dr_z3_loop1:
	
	move.l	#34, d4
r_dr_z3_loop2:

	
	move.l	#1, d5
r_dr_z3_loop3:
	move.w	(a0), (a1)
	move.w	(a0), 640(a1)
	move.w	#0, 1280(a1)
	addq.l	#2, a1
	
	dbf		d5, r_dr_z3_loop3

	move.w	#0, (a1)
	move.w	#0, 640(a1)
	move.w	#0, 1280(a1)
	addq.l	#2, a1
	
	addq.l	#2, a0
	dbf		d4, r_dr_z3_loop2
	
	adda.l	#1280, a1
	adda.l	#430, a1
	adda.l	#570, a0
	dbf		d3, r_dr_z3_loop1

r_3_end:
rts





end