export rubrect

TEXT

rubrect:
	move.l	4(sp), d3
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;a0:	Screen
	
	;Register sichern
	movem.l	d3-d7/a0-a1, -(sp)
	
	;Koordinaten testen und eventuell vertauschen (x1<x2, y1<y2)
	;x:
	cmp.l	d0, d2
	bgt		rr_x1_kl_x2
	exg.l	d0, d2				;Registerinhalte vertauschen
rr_x1_kl_x2:
	;y:
	cmp.l	d1, d3
	bgt		rr_y1_kl_y2
	exg.l	d1, d3
rr_y1_kl_y2:

	;x-Differenz-Offset berechnen
	move.l	d2, d4
	sub.l	d0, d4
	add.l	d4, d4
	;d4:	x-Differenz-Offset

	;y-Differenz-Offset berechnen
	move.l	d3, d5
	sub.l	d1, d5
	mulu.l	#2*320, d5
	;d5:	y-Differenz-Offset
	
	;Anfangsadresse berechnen
	move.l	d0, d6
	asl.l	d6
	move.l	d1, d7
	mulu.l	#640, d7
	add.l	d6, d7
	adda.l	d7, a0
	move.l	a0, a1
	;a0/a1:	Anfangsadresse

	;Horizontale Linien zeichnen
rr_h_l_loop:

	;untere Linie
	not.w	(a0,d5.l)
	addq.l	#2, a0
	addq.l	#1, d0
	cmp.l	d2, d0
	bgt		rr_h_l_end

	;obere Linie
	not.w	(a0)+
	addq.l	#1, d0
	cmp.l	d2, d0
	bge		rr_h_l_end

	bra		rr_h_l_loop
rr_h_l_end:

	;Vertikale Linien zeichnen
rr_v_l_loop:

	;rechte Linie
	not.w	(a1,d4.l)
	adda.l	#640, a1
	addq.l	#1, d1
	cmp.l	d3, d1
	bgt		rr_v_l_end

	;linke Linie
	not.w	(a1)
	adda.l	#640, a1
	addq.l	#1, d1
	cmp.l	d3, d1
	bge		rr_v_l_end
	
	bra		rr_v_l_loop
rr_v_l_end:

	;Register wiederherstellen
	movem.l	(sp)+, d3-d7/a0-a1


rts


END