export generatetrp
export generatetrpblk


TEXT


;ROUTINE ERZEUGT TRP-BILDDATEI IM SPEICHER
generatetrp:
	;d0:	X-Auflsung;
	;d1:	Y-Auflsung;
	;a0:	Bildadresse;
	;a1:	Zieladresse;
	
	;Header: 	"TRUP"  ...Kennung des Bildformates
	;			1 Word	...X-Auflsung
	;			1 Word	...Y-Auflsung
	
	move.l	#"TRUP", (a1)+
	move.w	d0, (a1)+
	move.w	d1, (a1)+

	;Bilddaten:	Screenformat
	
	mulu.l	d0, d1
	;d1:	Anz.der Pixel
	
	;Gre des Bildes berechnen (Counter+Header)
	move.l	d1, d2
	lsl.l	#1, d2
	addq.l	#8, d2
	;d2:	Gre des Bildes in Bytes	
	
	;Loopcounter d1
	lsr.l	#1,d1
	subq.l	#1, d1
gen_trp_loop:

	move.l	(a0)+, (a1)+

	dbf		d1, gen_trp_loop
	
	;Resultat: Bildgre
	move.l	d2, d0
rts




;ROUTINE ERZEUGT TRPBLK-BILDDATEI IM SPEICHER
generatetrpblk:
	;a0:	Blockadresse;
	;a1:	Zieladresse;
	
	;Header: 	"TRUP"  ...Kennung des Bildformates
	;			1 Word	...X-Auflsung
	;			1 Word	...Y-Auflsung
	
	move.l	#"TRUP", (a1)+
	clr.l	d0
	move.w	(a0)+, d0
	move.w	d0, (a1)+
	clr.l	d1
	move.w	(a0)+, d1
	move.w	d1, (a1)+

	;Bilddaten:	Screenformat
	
	;Gre des Bildes berechnen (Counter+Header)
	move.l	d1, d2
	mulu.l	d0,d2
	lsl.l	d2
	add.l	#8, d2
	;d2:	Gre des Bildes in Bytes	
	
	move.l	d2,-(sp)
	
	subq.l	#1,d0
	subq.l	#1,d1
gen_trpblk_yloop:
	move.w	d0,d2
gen_trpblk_xloop:
	move.w	(a0)+, (a1)+
	dbf		d2,gen_trpblk_xloop
	dbf		d1,gen_trpblk_yloop
	
	move.l	(sp)+,d2
	
	;Resultat: Bildgre
	move.l	d2, d0
rts




END