export vsetscreen
export delscreen
export sethelpfont
export writexy
export peek
export poke


;ZUM NDERN DER BILDSCHIRMAUFLSUNG
vsetscreen:
	move.w	4(sp), d3
	move.w	d3, -(sp)
	move.w  d2, -(sp)
	move.l	d1, -(sp)
	move.l	d0, -(sp)
	move.w	#5, -(sp);
	trap	#14
	add.l	#14, sp
rts


;ZUM LSCHEN DES BILDSCHIRMES
delscreen:
	;d0: 	Farbe des neuen Hintergrundes
	;a0: 	Bildschirmanfangsadresse
	move.l	#38400, d2
	move.l	d0, d1
	lsl.l	#8, d1
	lsl.l	#8, d1
	add.l	d1, d0
loop1:
	move.l	d0, (a0)+
	dbf		d2, loop1
rts


sethelpfont:
	;a0:	Fontadresse
	;a1:	Fontmapadresse
	move.l	a0, fontadr
	move.l	a1, fontmap
rts


;ZUM AUSGEBEN VON TEXT
;ALS FONT WIRD EIN 32x32 16-F RASTERFONT VERWENDET
;DIE BILDSCHIRMAUFLSUNG BETRGT 640*XXX
writexy:
	movem.l	d0-d7/a0-a6, -(sp)
	move.l	4(sp), a2
	;d0:	x
	;d1:	y
	;a0:	Stringadresse
	;a1:	Bildschirmadresse
	
	;Erste Pixeladresse berechnen
	asl.l	#3, d0
	mulu.l	#320, d1
	asl.l	#4, d1
	add.l	d0, d1
	adda.l	d1, a1
	;a1:	erste Adresse auf Screen
	
	move.l	fontadr, a2
	move.l	fontmap, a5
write_loop:

	;a0:	String
	move.l	a1, a3
	;a3:	Screenadresse
	move.l	a2, a4
	;a4:	Fontadresse
	;a5:	Fontmapadresse
	
	;ASCII-Zeichen ermitteln
	addq.l	#1, a0
	clr.l	d0
	move.b	(a0), d0
	;d0:	ASCII Wert
	
	;Wenn ASCII=0 -> Abbruch (Stringende)
	cmpi.l	#0, d0
	beq		write_end

	;Wenn ASCII='@' -> Abbruch
	cmpi.l	#"@", d0
	beq		write_end

	;Zeichenoffset im Font ermitteln (aus Fontmap)
	move.w	(a5,d0.w*2), d1
	;d1:	Zeichenoffset im Font
	
	REPT 16
	;Zeichen ausgeben
	move.l	0(a4,d1.w), (a3)
	move.l	4(a4,d1.w), 4(a3)
	;move.l	8(a4,d1.w), 8(a3)
	;move.l	12(a4,d1.w), 12(a3)
	adda.l	#160, a4
	adda.l	#320, a3
	ENDM
	
	adda.l	#8, a1
	
	bra		write_loop
	
write_end:

	movem.l	(sp)+, d0-d7/a0-a6
	
rts



peek:
	move.l	(a0), d0
rts

poke:
	move.l	d0, (a0)
rts

	
bss

buf:	ds.w	330


bss

fontadr:	ds.l	1
fontmap:	ds.l	1

end