{UNIT ZUR VERWALTUNG DER BILDSCHIRMAUFLSUNGEN USW.}
UNIT 	EscP_Scr;

INTERFACE

USES	Tos;
		{$L LOTC_VGA.O}				{SCP fr VGA}
		{$L LOTC_RGB.O}				{SCP fr RGB}
		{$L SAVERES2.O}				{THANX TO DYNACORE!}
		{$L SCRADR.O}				{SetNewScrAdr}
		{$L SET_SCP.O}				{Routine zum SCP-Setzen}
VAR		os			:LongInt;		{Supervisor-Zeiger}
		olog		:Pointer;		{alte LogBase}
		ovm			:LongInt;		{alter Videomode}
		ovr			:Array[0..100] OF Byte;
									{alte Videoregister}
		magic_flag	:LongInt;
		
PROCEDURE GoToPicRez(mon:LongInt;scradr:Pointer);
PROCEDURE GoToPrgRez;
PROCEDURE SetNewScrAdr(adr:Pointer);
PROCEDURE Save_Old_Res(ovr:Pointer);
PROCEDURE SetVRes(vx_res:LongInt);
PROCEDURE Set_Allvid(ovr:Pointer);
PROCEDURE SetScrAdr(adr:Pointer);
PROCEDURE SetMagiCFlag(flag:LongInt);

PROCEDURE LoTc_RGB_SCP;
PROCEDURE LoTc_VGA_SCP;

PROCEDURE Set_FalconRes(scp_adr:Pointer);

{fr Modulschnittstelle (schon im Supervisormodus)}
PROCEDURE SetPicRez(mon:LongInt;scradr:Pointer);
PROCEDURE SetPrgRez;

IMPLEMENTATION

{Includefile 'SAVERES2.O'}
PROCEDURE Save_Old_Res(ovr:Pointer);EXTERNAL;
PROCEDURE Set_Allvid(ovr:Pointer);EXTERNAL;

{Includefile 'SCRADR.O'}
PROCEDURE SetScrAdr(adr:Pointer);EXTERNAL;

{Includefile 'LOTC_VGA.O'}
PROCEDURE LoTc_VGA_SCP;EXTERNAL;

{Includefile 'LOTC_RGB.O'}
PROCEDURE LoTc_RGB_SCP;EXTERNAL;

{Includefile 'SET_SCP.O'}
PROCEDURE Set_FalconRes(scp_adr:Pointer);EXTERNAL;
	
{PROZEDUR SETZT NEUE BILDADRESSE (VORHER SUPERVISOR-MODE)}	
PROCEDURE SetNewScrAdr(adr:Pointer);
VAR		os:LongInt;
BEGIN
	os:=Super(NIL);
	SetScrAdr(adr);
	Super(Pointer(os));
END;

PROCEDURE SetVRes(vx_res:LongInt);
VAR		adr:^Word;
BEGIN
	adr:=Pointer($FFFF820E);
	adr^:=vx_res;
END;

{PROZEDUR SCHALTET IN DIE BILDAUFLSUNG UND BILD-SCREENADRESSE UM}
PROCEDURE GoToPicRez(mon:LongInt;scradr:Pointer);
BEGIN
	{alte logische Bildschirmadresse merken}
	olog:=LogBase;
{	Writeln('3a');}
	{alte Videoregister sichern}
	os:=Super(NIL);
{	Writeln('3b');}
	Save_Old_Res(@ovr);
{	Writeln('3c');}
	Super(Pointer(os));
{	Writeln('3d');}
	IF magic_flag=1 THEN VSync;
{	Writeln('3e');}
	os:=Super(NIL);
{	Writeln('3f');}
	SetScrAdr(scradr);
{	Writeln('3g');}
	Super(Pointer(os));
{	Writeln('3h');}
	{neue Werte in die Videohardwareregister schreiben}
	VSync;
{	Writeln('3i');}
	os:=Super(NIL);
{	Writeln('3j');}
	IF mon=2 THEN Set_FalconRes(@LoTc_VGA_SCP) ELSE Set_FalconRes(@LoTc_RGB_SCP);
{	Writeln('3k');}
	Super(Pointer(os));
{	Writeln('3l');}
END;


{FR EPMS: PROZEDUR SCHALTET IN DIE BILDAUFLSUNG UND BILD-SCREENADRESSE UM}
PROCEDURE SetPicRez(mon:LongInt;scradr:Pointer);
BEGIN
	{alte logische Bildschirmadresse merken}
	olog:=LogBase;
	{alte Videoregister sichern}
	Save_Old_Res(@ovr);
	IF magic_flag=1 THEN VSync;
	SetScrAdr(scradr);
	{neue Werte in die Videohardwareregister schreiben}
	VSync;
	IF mon=2 THEN Set_FalconRes(@LoTc_VGA_SCP) ELSE Set_FalconRes(@LoTc_RGB_SCP);
END;



{PROZEDUR SCHALTET IN DIE PROGRAMMAUFLSUNG UND PROGRAMM-SCREENADRESSE UM}
PROCEDURE GoToPrgRez;
BEGIN
	{alte Werte in die Videohardwareregister schreiben}
	VSync;
	{alte Auflsung setzen}
	os:=Super(NIL);
	Set_Allvid(@ovr);
	Super(Pointer(os));
	{alte Screenadresse}
	SetNewScrAdr(olog);
END;


{FR EPMS: PROZEDUR SCHALTET IN DIE PROGRAMMAUFLSUNG UND PROGRAMM-SCREENADRESSE UM}
PROCEDURE SetPrgRez;
BEGIN
	{alte Werte in die Videohardwareregister schreiben}
	VSync;
	{alte Auflsung setzen}
	Set_Allvid(@ovr);
	{alte Screenadresse}
	SetScrAdr(olog);
END;



{ZUM SETZEN DES MAGIC-FLAGS}
PROCEDURE SetMagiCFlag(flag:LongInt);
BEGIN
	magic_flag:=flag;
END;


BEGIN
	magic_flag:=0;
END.