
colormap_generator:
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;a0:	EP structure
	
	movem.l	d0-d3,-(sp)
	
	movea.l	(a0),a1			;get screenadr
	movea.l	192(a0),a2		;adress of GetPalAdr-routine
	movea.l	12(a0),a3
	move.l	(a3),d0			;active screen
	jsr		(a2)
	;a0:	palette adress
	;a1:	screenadr
	
	movem.l	(sp)+,d0-d3
	
	;get x and y-counter and calculate lineoffset
	sub.l	d0,d2
	move.l	#320,d7
	sub.l	d2,d7
	lsl.l	d7
	subq.l	#1,d2
	sub.l	d1,d3
	subq.l	#1,d3
	;d2:	xcounter
	;d3:	ycounter
	;d7:	lineoffset
		
	;get startadress in screen
	mulu.l	#320,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a1
	
	;clear palette
	move.l	a0,-(sp)
	move.w	#128-1,d0
clear_palette:
	clr.l	(a0)+
	dbf		d0,clear_palette
	movea.l	(sp)+,a0
	
readpal_yloop:
	move.l	d2,d1
readpal_xloop:

	;read pixel
	move.w	(a1)+,d0
	move.w  d0,d4
	;d0:	16Bit pixel
	move.w  d0,d5
	and.w   #%11111000000,d5 ;green
	ror.w   #6,d5
	move.w  d0,d6
	and.w   #%1111100000000000,d6 ;red
	rol.w   #5,d6
	and.w   #%11111,d0
	add.w   d6,d5
	add.w   d5,d0
	;d0: brightness
    move.w  d4,(a0,d0.w*2)
	
	dbf		d1,readpal_xloop
	adda.l	d7,a1
	dbf		d3,readpal_yloop
	
readpal_end:
rts