{FONT UND FARBDATEN}
{$L INTERN\HELPFONT.O}
PROCEDURE Helpfont;EXTERNAL;
{$L INTERN\HELPFMAP.O}
PROCEDURE Helpfontmap;EXTERNAL;
{$L INTERN\HELPPAL.O}
PROCEDURE Helppal;EXTERNAL;
{$L PRG.INC\WRITE_XY.O}
PROCEDURE SetHelpFont(font,fontmap:Pointer);EXTERNAL;
PROCEDURE WriteXY(x,y:LongInt;output:String;scradr:Pointer);EXTERNAL;

{PROZEDUR STELLT HILFE DAR}
PROCEDURE Help(helptype:LongInt;helpscreen,origscr:Pointer);
VAR		oldpal		:Array[0..64] OF Byte;
		osup		:LongInt;
		ovr			:Array[0..50] OF Byte;
BEGIN

	{Supervisormodus}
	osup:=Super(NIL);

	{Videohardwareregister sichern}
	Save_Old_Res(@ovr);

	{alte Palette sichern}
	MemCopy(Pointer($FFFF9800),@oldpal,16);
	
	{Hilfe-Font initialisieren (mu eigentlich nur einmal gemacht werden)}
	SetHelpFont(@Helpfont,@Helpfontmap);
		
	{Usermodus}
	Super(Pointer(osup));

	{Screen lschen}
	MemDFast(helpscreen,3200);
		
	{Hilfstext zeichnen}
	CASE helptype OF

	  {Menu}
	  1: BEGIN
		WriteXY(0 ,0 ,'-DRAW FUNCTIONS-@',helpscreen);
		WriteXY(1 ,2 ,'D..DRAW@',helpscreen);
		WriteXY(1 ,3 ,'L..LINE@',helpscreen);
		WriteXY(1 ,4 ,'R..RECTANGLE@',helpscreen);
		WriteXY(1 ,5 ,'C..CIRCLE@',helpscreen);
		WriteXY(1 ,6 ,'P..POLYLINE@',helpscreen);
		WriteXY(1 ,7 ,'B..BOX@',helpscreen);
		WriteXY(1 ,8 ,'F..FILL@',helpscreen);
		WriteXY(1 ,9 ,'Z..ZOOM@',helpscreen);
		WriteXY(1 ,10,'T..TEXT@',helpscreen);
		WriteXY(1 ,11,'X..BLOCK CUT@',helpscreen);
		WriteXY(1 ,12,'V..BLOCK PASTE@',helpscreen);
		
		WriteXY(0 ,14,'-EDITORS-@',helpscreen);
		WriteXY(1 ,16,'S..PALETTE EDITOR@',helpscreen);
	
		WriteXY(19,0 ,'-GENERAL-@',helpscreen);
		WriteXY(20,2 ,'RETURN..SCREEN@',helpscreen);
		WriteXY(20,3 ,'W.......R-T-ZOOM@',helpscreen);
		WriteXY(20,4 ,'^D......CLEAR PIC.@',helpscreen);
		WriteXY(20,5 ,'^V......PASTE PIC.@',helpscreen);
		WriteXY(20,6 ,'^U......CLOSE WIN.@',helpscreen);
		WriteXY(20,7 ,'^O......OPEN FILE@',helpscreen);
		WriteXY(20,8,'^S......SAVE FILE@',helpscreen);
		WriteXY(20,9,'^Q......QUIT@',helpscreen);
		WriteXY(20,10,'HELP....HAHA!@',helpscreen);
		
		WriteXY(19,14,'-FILE FORMATS-@',helpscreen);
		WriteXY(20,16,'XGA..SCREENFORMAT@',helpscreen);
		WriteXY(20,17,'TRU..INDYPAINT@',helpscreen);
		WriteXY(20,18,'TRP..EGGPAINT@',helpscreen);
		WriteXY(20,19,'TGA..TARGA@',helpscreen);
		WriteXY(20,20,'EPP..EP-PALETTE@',helpscreen);
		WriteXY(20,21,'PAL..INDYPALETTE@',helpscreen);
		WriteXY(20,22,'PAL..GEM-PALETTE@',helpscreen);
	
		WriteXY(0 ,25,'              -GREETINGS-@',helpscreen);
		WriteXY(1 ,27,' THERAPY, TCE, CRUOR, ABSENCE, TSCC,@',helpscreen);
		WriteXY(1 ,28,'CHECKPOINT, STAX, REFLEX, INTER, NPG@',helpscreen);
	  END;		
		
	  {Screen}
	  2: BEGIN
		WriteXY(0 ,0 ,'-DRAW FUNCTIONS-@',helpscreen);
		WriteXY(1 ,2 ,'D..DRAW@',helpscreen);
		WriteXY(1 ,3 ,'L..LINE@',helpscreen);
		WriteXY(1 ,4 ,'R..RECTANGLE@',helpscreen);
		WriteXY(1 ,5 ,'C..CIRCLE@',helpscreen);
		WriteXY(1 ,6 ,'P..POLYLINE@',helpscreen);
		WriteXY(1 ,7 ,'B..BOX@',helpscreen);
		WriteXY(1 ,8 ,'F..FILL@',helpscreen);
		WriteXY(1 ,9 ,'Z..ZOOM@',helpscreen);
		WriteXY(1 ,10,'T..TEXT@',helpscreen);
		WriteXY(1 ,11,'X..BLOCK CUT@',helpscreen);
		WriteXY(1 ,12,'V..BLOCK PASTE@',helpscreen);

		WriteXY(0 ,14,'-EDITORS-@',helpscreen);
		WriteXY(1 ,16,'S..PALETTE EDITOR@',helpscreen);
	
		WriteXY(19,0 ,'-GENERAL-@',helpscreen);
		WriteXY(20,2 ,'ALT.....MOVE VIEW@',helpscreen);
		WriteXY(20,3 ,'RETURN..MENU@',helpscreen);
		WriteXY(20,4 ,'W.......R-T-ZOOM@',helpscreen);
		WriteXY(20,5 ,'^D......CLEAR SCR.@',helpscreen);
		WriteXY(20,6 ,'SPACE...COLORS@',helpscreen);
		WriteXY(20,7 ,'7,4.....MODIFY RED@',helpscreen);
		WriteXY(20,8 ,'8,5.....MODIFY GREEN@',helpscreen);
		WriteXY(20,9 ,'9,6.....MODIFY BLUE@',helpscreen);
		WriteXY(20,10,'ESC.....FAST BLK CUT@',helpscreen);
		WriteXY(20,11,'G.......PICK COLOR@',helpscreen);
		WriteXY(20,12,'F-KEYS..ZOOM MAGNIFY@',helpscreen);
		WriteXY(20,13,'UNDO....UNDO@',helpscreen);
		WriteXY(20,14,'LSHIFT..COORDINATES@',helpscreen);
		WriteXY(20,15,'RSHIFT..TOOLBOX@',helpscreen);
		WriteXY(20,16,'*.......SWITCH PAL.@',helpscreen);
		WriteXY(20,17,',.......PREV. COLOR@',helpscreen);
		WriteXY(20,18,'........NEXT COLOR@',helpscreen);
		WriteXY(20,19,'-.......COL.RESTORE@',helpscreen);
		WriteXY(20,20,'(,).....SNAPGRID@',helpscreen);
		
		WriteXY(0 ,22,'       -ADDITIONAL INFORMATIONS-@',helpscreen);
		WriteXY(1 ,24,'THE 256-COLOR PALETTE IS DIVIDED INTO@',helpscreen);
		WriteXY(1 ,25,'TWO 128-COLOR PALETTES (*).@',helpscreen);
		WriteXY(1 ,26,'USE CURSORKEYS TO SELECT A NEW TOOL@',helpscreen);
		WriteXY(1 ,27,'WITH THE TOOLBOX (RSHIFT).@',helpscreen);
		WriteXY(1 ,28,'PRESSING THE R.MOUSEBUTTON ON SCREEN-@',helpscreen);
		WriteXY(1 ,29,'BOTTOM HAS THE SAME EFFECT AS (SPACE).@',helpscreen);
	  END;	
	
	  {Palettened.}
	  3: BEGIN
		WriteXY(0 ,0 ,'-PALETTE FUNCTIONS-@',helpscreen);
		WriteXY(1 ,2 ,',.......PREVIOUS COLOR@',helpscreen);
		WriteXY(1 ,3 ,'........NEXT COLOR@',helpscreen);
		WriteXY(1 ,4 ,'*.......SWITCH 128-COLOR PALETTES@',helpscreen);
		WriteXY(1 ,5 ,'7,4.....MODIFY RED-VALUE@',helpscreen);
		WriteXY(1 ,6 ,'8,5.....MODIFY GREEN-VALUE@',helpscreen);
		WriteXY(1 ,7 ,'9,6.....MODIFY BLUE-VALUE@',helpscreen);
		WriteXY(1 ,8 ,'UNDO....UNDO@',helpscreen);
		WriteXY(1 ,9 ,'LSHIFT..COLORCOPY (LEFT MOUSEBUTTON)@',helpscreen);
		
		WriteXY(0 ,12,'-ORIGINAL WINDOW-@',helpscreen);
		WriteXY(1 ,14,'L.MOUSEBUTTON...MOVE PICTURE@',helpscreen);
		WriteXY(1 ,15,'R.MOUSEBUTTON...PICK COLOR@',helpscreen);
		
		WriteXY(0 ,18,'-WATER COLOR PALETTE WINDOW-@',helpscreen);
		WriteXY(1 ,20,'L.MOUSEBUTTON...EDIT (ADDITIVE SHADING)@',helpscreen);
		WriteXY(1 ,21,'R.MOUSEBUTTON...PICK COLOR@',helpscreen);
		
		WriteXY(0 ,24,'-GENERATE COLORRANGES-@',helpscreen);
		WriteXY(1 ,26,'1. SELECT THE STARTCOLOR@',helpscreen);
		WriteXY(1 ,27,'2. SELECT THE ENDCOLOR WITH THE RIGHT@',helpscreen);
		WriteXY(1 ,28,'   MOUSEBUTTON@',helpscreen); 
		
	  END;
	  
	  {Neo Screen}
	  4: BEGIN
		WriteXY(0 ,0 ,'-DRAW FUNCTIONS-@',helpscreen);
		WriteXY(1 ,2 ,'D..DRAW@',helpscreen);
		WriteXY(1 ,3 ,'L..LINE@',helpscreen);
		WriteXY(1 ,4 ,'R..RECTANGLE@',helpscreen);
		WriteXY(1 ,5 ,'C..CIRCLE@',helpscreen);
		WriteXY(1 ,6 ,'P..POLYLINE@',helpscreen);
		WriteXY(1 ,7 ,'B..BOX@',helpscreen);
		WriteXY(1 ,8 ,'F..FILL@',helpscreen);

		WriteXY(19,0 ,'-GENERAL-@',helpscreen);
		WriteXY(20,2 ,'RETURN..BACK@',helpscreen);
		WriteXY(20,3,'ESC.....BACK@',helpscreen);
		WriteXY(20,4 ,'^D......CLEAR PIC.@',helpscreen);
		WriteXY(20,5 ,'7,4.....MODIFY RED@',helpscreen);
		WriteXY(20,6 ,'8,5.....MODIFY GREEN@',helpscreen);
		WriteXY(20,7 ,'9,6.....MODIFY BLUE@',helpscreen);
		WriteXY(20,8,'CURSOR..ZOOMAREA@',helpscreen);
		WriteXY(20,9,'F-KEYS..ZOOM MAGNIFY@',helpscreen);
		WriteXY(20,10,'UNDO....UNDO@',helpscreen);
		WriteXY(20,11,'*.......SWITCH PAL.@',helpscreen);
		WriteXY(20,12,',.......PREV. COLOR@',helpscreen);
		WriteXY(20,13,'........NEXT COLOR@',helpscreen);
		WriteXY(20,14,'-.......COL.RESTORE@',helpscreen);
		WriteXY(20,15,'G.......PICK COLOR@',helpscreen);
	  	
		WriteXY(1 ,27,'          -THIS SCREEN IS-        @',helpscreen);
		WriteXY(1 ,28,'   -DEDICATED TO QUESTOR OF INTER-@',helpscreen);
	  
		WriteXY(0, 17,'                -HINT-             @',helpscreen);
		WriteXY(1, 19,'      USE LEFT+RIGHT MOUSEBUTTON.  @',helpscreen);
	  END;

  	{Degas Screen}
	  5: BEGIN
		WriteXY(0 ,0 ,'-GENERAL-@',helpscreen);
		WriteXY(1 ,2 ,'7,4.....MODIFY RED@',helpscreen);
		WriteXY(1 ,3 ,'8,5.....MODIFY GREEN@',helpscreen);
		WriteXY(1 ,4 ,'9,6.....MODIFY BLUE@',helpscreen);
		WriteXY(1 ,5 ,'CURSOR..ZOOMAREA@',helpscreen);
		WriteXY(1 ,6 ,'F-KEYS..ZOOM MAGNIFY@',helpscreen);
		WriteXY(1 ,7 ,'UNDO....UNDO@',helpscreen);
		WriteXY(1 ,8 ,'*.......SWITCH PAL.@',helpscreen);
		WriteXY(1 ,9 ,',.......PREV. COLOR@',helpscreen);
		WriteXY(1 ,10,'........NEXT COLOR@',helpscreen);
		WriteXY(1 ,11,'-.......COL.RESTORE@',helpscreen);
	  	
		WriteXY(0 ,13,'-ORIGINAL FIELD-@',helpscreen);
		WriteXY(1 ,15,'LEFT MOUSEBUTTON....ZOOM AREA@',helpscreen);
		WriteXY(1 ,16,'RIGHT MOUSEBUTTON...LEAVE ZOOM@',helpscreen);
		
		WriteXY(0 ,18,'-EDIT FIELD-@',helpscreen);
		WriteXY(1 ,20,'LEFT MOUSEBUTTON....EDIT@',helpscreen);
		WriteXY(1 ,21,'RIGHT MOUSEBUTTON...PICK COLOR@',helpscreen);
		WriteXY(1 ,22,'SPACE...............ZOOM AREA@',helpscreen);
			  
		WriteXY(0 ,24,'-PALETTE FIELD-@',helpscreen);
		WriteXY(1 ,26,'LEFT MOUSEBUTTON....CHOOSE COLOR@',helpscreen);
	  END;
	END;


	{Supervisor}
	osup:=Super(NIL);

	{neue Palette setzen}
	MemCopy(@Helppal,Pointer($FFFF9800),16);

	VSync;

	{Screenadresse}	
	SetScrAdr(helpscreen);
	
	{Helpauflsung}
	IF mon=2 THEN Set_Help_VGA ELSE Set_Help_RGB;
	
	{User}
	Super(Pointer(osup));

	{Tastaturpuffer lschen (ja ich wei..)}
	WHILE PressedKey DO Cnecin;
	
	{Warten bis Taste gedrckt wird}
	REPEAT UNTIL PressedKey;
	
	{Tastaturpuffer wieder leeren (buh!)}
	WHILE PressedKey DO Cnecin;
	
	{Supervisor}
	osup:=Super(NIL);
	
	{Orginalauflsung}
	VSync;Set_AllVid(@ovr);
	
	{Orginalscreenadresse}
	IF helptype=1 THEN SetScrAdr(logbase) ELSE SetScrAdr(origscr);

	{Orginalpalette}
	MemCopy(@oldpal,Pointer($FFFF9800),16);
	
	{Usermodus}
	Super(Pointer(osup));
END;