
PROCEDURE Pal_Edit;
CONST	ANZ_PE_B 	= 11;
		RED			= 1;
		GREEN		= 2;
		BLUE		= 3;
		PALET		= 4;
		ORGP		= 5;
		MIX			= 6;
		RED_B		= 7;
		GREEN_B		= 8;
		BLUE_B		= 9;
		WHITE_B		= 10;
		BLACK_B		= 11;
VAR		but			:Array[1..ANZ_PE_B] OF RECORD
						x1,y1,x2,y2,state:LongInt;
						datadr:Pointer; 
					 END;
		r,g,b		:LongInt;
		i			:LongInt;
		mx,my		:LongInt;
		opx,opy		:LongInt;
		actmixcol	:LongInt;
		actbut		:LongInt;
		newcol		:LongInt;
		actms		:LongInt;
		fh			:Integer;
		key			:Char;
		a			:pointer;
	
	{PROZEDUR SETZT DIE SCREEN-ELEMENT-POSITIONEN}
	PROCEDURE SetButPos;
	BEGIN
		{Rot-Setter}
		WITH but[RED] DO BEGIN
			x1:=255;y1:=155;x2:=265;y2:=220;
		END;
		{Grn-Setter}
		WITH but[GREEN] DO BEGIN
			x1:=275;y1:=155;x2:=285;y2:=220;
		END;
		{Blau-Setter}
		WITH but[BLUE] DO BEGIN
			x1:=295;y1:=155;x2:=305;y2:=220;
		END;
		{Palette}
		WITH but[PALET] DO BEGIN
			x1:=5;y1:=200;x2:=217;y2:=223;
		END;
		{Orginal-Bild}
		WITH but[ORGP] DO BEGIN
			x1:=5;y1:=10;x2:=106;y2:=110;
		END;
		{Mischpalette}
		WITH but[MIX] DO BEGIN
			x1:=215;y1:=10;x2:=315;y2:=110;
		END;
		{Mix-Rot}
		WITH but[RED_B] DO BEGIN
			x1:=220;y1:=115;x2:=x1+16;y2:=y1+16;datadr:=@RedButton;state:=1;
		END;
		{Mix-Grn}
		WITH but[GREEN_B] DO BEGIN
			x1:=236;y1:=115;x2:=x1+16;y2:=y1+16;datadr:=@GreenButton;state:=0;
		END;
		{Mix-Blau}
		WITH but[BLUE_B] DO BEGIN
			x1:=252;y1:=115;x2:=x1+16;y2:=y1+16;datadr:=@BlueButton;state:=0;
		END;
		{Mix-Wei}
		WITH but[WHITE_B] DO BEGIN
			x1:=268;y1:=115;x2:=x1+16;y2:=y1+16;datadr:=@WhiteButton;state:=0;
		END;
		{Mix-Schwarz}
		WITH but[BLACK_B] DO BEGIN
			x1:=284;y1:=115;x2:=x1+16;y2:=y1+16;datadr:=@BlackButton;state:=0;
		END;
	END;
	
	{FUNKTION ZUM ERMITTELN DES BUTTONS AN DER POSITION P(X;Y)}
	FUNCTION WhichB(x,y:LongInt):LongInt;
	VAR		i:LongInt;
	BEGIN
		{Default-Wert}
		WhichB:=0;
		FOR i:=1 TO ANZ_PE_B DO BEGIN
			IF (x>but[i].x1) AND (y>but[i].y1) AND (x<but[i].x2) AND (y<but[i].y2) THEN WhichB:=i;
		END;
	END;
	
	{PROZEDUR SETZT DIE RGB-REGLER NEU}
	PROCEDURE SetRGBSetter;
	BEGIN
		Vsync;
		Hide_Mouse;
		Num_Output(257,149,r,2,0,zoomscr);Line3(255,219-r,264,219-r,-1,zoomscr);
		Num_Output(277,149,g,2,0,zoomscr);Line3(275,219-g,284,219-g,-1,zoomscr);
		Num_Output(297,149,b,2,0,zoomscr);Line3(295,219-b,304,219-b,-1,zoomscr);
		r:=Get_R(actcol);
		g:=Get_G(actcol);
		b:=Get_B(actcol);
		Num_Output(257,149,r,2,0,zoomscr);Line3(255,219-r,264,219-r,-1,zoomscr);
		Num_Output(277,149,g,2,0,zoomscr);Line3(275,219-g,284,219-g,-1,zoomscr);
		Num_Output(297,149,b,2,0,zoomscr);Line3(295,219-b,304,219-b,-1,zoomscr);
		Show_Mouse;
	END;
	
	{PROZEDUR AKTUALISIERT PALETTE}
	PROCEDURE TakeNewRGB;	
	BEGIN
		actcol:=newcol;
		{RGB-Regler aktualisieren}
		SetRGBSetter;
		SetNewRGB(par.actpcn,actcol,paladr);
		{Aktuelle Farbe neben Palette zeichnen}
	  	DrawPalActCol(actcol,zoomscr);
	   	{Palette aktualisieren}
	   	VSync;
	   	Hide_Mouse;
	   	DrawPalette(zoomscr,paladr);
	   	Show_Mouse;
	   	{MarkPalCol(65535,actcol,zoomscr);}
	END;
	
	{PROZEDUR ERZEUGT FARBVERLAUF}
	PROCEDURE MakeRange(anf,ende:LongInt);
	VAR	a,anz		:LongInt;
		ra,ga,ba	:LongInt;		{Anfangs-RGB-Werte}
		re,ge,be	:LongInt;		{End-RGB-Werte}
		rd,gd,bd	:LongInt;		{Differenz der Anfangs- und Endwerte}
		rm,gm,bm	:Real;			{Anstiege der Farbfunktionen}
		anfcol		:LongInt;
		endcol		:LongInt;
		newcol		:LongInt;
	BEGIN
		{eventuell Anfangs- und Zielfarbe vertauschen}
		IF anf>ende THEN BEGIN
			a:=anf;anf:=ende;ende:=a;
		END;
		{Anzahl der zu verndernden Farben}
		anz:=ende-anf;
		{Anfangs- und Endfarbe bestimmen}
		anfcol:=SetColor(anf,paladr);
		endcol:=SetColor(ende,paladr);
		{anfcol:=0;endcol:=0;}
		{RGB-Werte der Anfangsfarbe}
		ra:=Get_R(anfcol)	;ga:=Get_G(anfcol)	;ba:=Get_B(anfcol);
		{RGB-Werte der Endfarbe}
		re:=Get_R(endcol)	;ge:=Get_G(endcol)	;be:=Get_B(endcol);
		{Differenzen}
		rd:=re-ra			;gd:=ge-ga			;bd:=be-ba;
		{Anstiege der Farbfunktionen}
		rm:=rd/anz			;gm:=gd/anz			;bm:=bd/anz;
		{Erzeugen des Verlaufes	}
		IF anz>1 THEN FOR a:=anf+1 TO ende-1 DO BEGIN 
			newcol:=SetColor(a,paladr);
			newcol:=Set_R(Round((a-anf)*rm+ra),newcol);
			newcol:=Set_G(Round((a-anf)*gm+ga),newcol);
			newcol:=Set_B(Round((a-anf)*bm+ba),newcol);
			SetNewRGB(a,newcol,paladr);
		END;
		{Palette aktualisieren}
		Hide_Mouse;
	   	DrawPalette(zoomscr,paladr);
		Show_Mouse;
	END;
	
	{PROZEDUR ZUM KOPIEREN DER AKTUELLEN PALETTE IN DEN UNDO-PUFFER}
	PROCEDURE PalToUndo;
	BEGIN
		MemCopy(pic[par.actscr].paladr,buffer,128);
	END;


BEGIN
  {Palettenadresse setzen}
  IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
			   ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
  SetButPos;
  WITH par DO BEGIN
	
  	actcol:=SetColor(actpcn,paladr);
  	
  	opx:=0;opy:=0;
  	actms:=0;
  	actmixcol:=RED_B;
  	r:=Get_R(actcol);
  	g:=Get_G(actcol);
  	b:=Get_B(actcol);
	MemClear(zoomscr,38400);
	
	px:=5;py:=200;
	{Palette}
	NormBox(0,px,py,px+192+20,py+20+3,zoomscr);Draw_3D_Rect(px,py,px+192+20,py+20+3,zoomscr);
	{Orginalbild}
	NormBox(0,5,10,106,110,zoomscr);Draw_3D_Rect(5,10,106,110,zoomscr);
	WITH pic[actscr] DO DrawPEOrgPic(opx,opy,rez_x,adr,zoomscr);
	{Spektrum}
	NormBox(0,111,10,210,110,zoomscr);Draw_3D_Rect(111,10,210,110,zoomscr);
	{Mischpalette}
	NormBox(0,215,10,315,110,zoomscr);Draw_3D_Rect(215,10,315,110,zoomscr);
	{Buttons unter der Mischpalette}
	FOR i:=RED_B TO BLACK_B DO WITH but[i] DO
		DrawButton(x1,y1,state,datadr,zoomscr);
	{RGB-Schieber}
	NormBox(0,250,145,310,223,zoomscr);Draw_3D_Rect(250,145,310,223,zoomscr);
	{Rot}
	NormBox(22528,255,155,265,220,zoomscr);Draw_3D_Rect(255,155,265,220,zoomscr);
	Num_Output(257,149,r,2,0,zoomscr);Line3(255,219-r,264,219-r,-1,zoomscr);
	{Grn}
	NormBox(480,275,155,285,220,zoomscr);Draw_3D_Rect(275,155,285,220,zoomscr);
	Num_Output(277,149,g,2,0,zoomscr);Line3(275,219-g,284,219-g,-1,zoomscr);
	{Blau}
	NormBox(10,295,155,305,220,zoomscr);Draw_3D_Rect(295,155,305,220,zoomscr);
	Num_Output(297,149,b,2,0,zoomscr);Line3(295,219-b,304,219-b,-1,zoomscr);
	{Farbbox}
	NormBox(0,222,200,245,223,zoomscr);Draw_3D_Rect(222,200,245,223,zoomscr);
	SetRGBSetter;
	
	{Palette zeichnen}
	Hide_Mouse;
	DrawPalette(zoomscr,paladr);
	DrawPalActCol(actcol,zoomscr);
	MarkPalCol(65525,actpcn,zoomscr);
	
	{Palette in UNDO-Puffer sichern}
	PalToUndo;
	
	{Maus initialisieren}
	Hide_Mouse;
	SetNewScrAdr(zoomscr);
	Hide_Mouse;
	SetMouseScreenAdr(zoomscr);
	SetActPoint(7,7);
	SetMouseGrid(1,1);
	TakeCursor(mousecurs[actmc]);
	
	{Tastaturpuffer lschen}
	WHILE PressedKey DO BEGIN
		keycode:=Crawcin;
		key:=Char(keycode);
	END;
	key:=#255;keycode:=0;
	
	Show_Mouse;
	REPEAT
		mx:=MousePosX;my:=MousePosY;
		actbut:=WhichB(mx,my);
		{GotoXY(10,1);Writeln(actbut,'  ');}
		{Wenn sich die Maus auf den RGB-Reglern befindet...}
		IF (actbut>0) AND (actbut<4) THEN BEGIN
			IF newcol=0 THEN BEGIN
				{Vertikalcursor einschalten}
				TakeCursor(@Vert01Dat);
				Show_Mouse;
				{MouseRedraw;}
				actms:=actbut;
			END;
			{Aktuellen Farbwert fr Farb-Prewiev speichern}
			newcol:=actcol;
			{Farb-Prewiev berechnen}
			CASE actbut OF
				1:	newcol:=Set_R(63-(my-220),newcol);
				2:	newcol:=Set_G(63-(my-220),newcol);
				3:	newcol:=Set_B(63-(my-220),newcol);
			END;
			{GotoXY(1,1);Writeln(Get_R(newcol));
			GotoXY(1,2);Writeln(Get_G(newcol));
			GotoXY(1,3);Writeln(Get_B(newcol));}
			{Farb-Prewiev zeichnen}
			NormBox(newcol,225,203,243,221,zoomscr);
		END;
		{Wenn sich die Maus auf dem Orginalfeld befindet...}
		IF actbut=ORGP THEN BEGIN
			IF actms<>ORGP THEN BEGIN
				TakeCursor(mousecurs[actmc]);
				Show_Mouse;
				{MouseRedraw;}actms:=ORGP;
			END;
			IF GetPixel(mx,my,320,zoomscr)<>newcol THEN BEGIN
				newcol:=GetPixel(MousePosX,MousePosY,320,zoomscr);
				{Farb-Prewiev zeichnen}
				VSync;NormBox(newcol,225,203,243,221,zoomscr);
			END;
		END;
		{Wenn sich die Maus auf der Mischpalette befindet...}
		IF (actbut=MIX) THEN BEGIN
			IF actms<>MIX THEN BEGIN
				TakeCursor(@Quad01Dat);
				Show_Mouse;
				{MouseRedraw;}actms:=MIX;
			END;
			IF GetPixel(mx,my,320,zoomscr)<>newcol THEN BEGIN
				newcol:=GetPixel(MousePosX,MousePosY,320,zoomscr);
				{Farb-Prewiev zeichnen}
				VSync;NormBox(newcol,225,203,243,221,zoomscr);
			END;
		END;
		{Wenn sich die Maus nicht auf einem Button befindet...}
		{Farbprewiew lschen}
		IF actbut<>actms THEN BEGIN 
			TakeCursor(mousecurs[actmc]);
			{MouseRedraw;}actms:=actbut;
			Hide_Mouse;
			NormBox(0,225,203,243,221,zoomscr);
			Show_Mouse;
			newcol:=0;
		END;

		{Tastaturereignisse abfragen}
		keycode:=0;key:=#255;
		WHILE PressedKey DO BEGIN
			keycode:=Crawcin;
			key:=Char(keycode);
		END;
		IF keycode<>0 THEN BEGIN		
			VSync;
			Hide_Mouse;
			{Wenn Undo gedrckt -> alte Palette wiederherstellen}
			IF keycode=6356992 THEN BEGIN
				{UNDO-Puffer mit Palettendaten vertauschen..}
				MemFlip(buffer,pic[par.actscr].paladr,128);
				{Bildschirm aktualisieren}
				newcol:=SetColor(actpcn,paladr);
				TakeNewRGB;
			{Ansonsten andere Tasten prfen...}
			END;
			{Wenn Help gedrckt -> Helpscreen}
			IF keycode=6422528 THEN Help(3,Pointer(Longint(buffer)+1024),zoomscr);
			CASE key OF
				{Eine Farbe in der Palette weiter}
			    '.': BEGIN
			  	  MarkPalCol(0,actpcn,zoomscr);
			  	  Inc(actpcn);
			  	  IF actpcn>127 THEN actpcn:=0;
			      MarkPalCol(65535,actpcn,zoomscr);
			      DrawPalActCol(actcol,zoomscr);
			    END;
			    {Eine Farbe in der Palette zurck}
			    ',': BEGIN
			  	  MarkPalCol(0,actpcn,zoomscr);
			  	  Dec(actpcn);
			  	  IF actpcn<0 THEN actpcn:=127;
			      MarkPalCol(65535,actpcn,zoomscr);
		      	  DrawPalActCol(actcol,zoomscr);
			    END;
			    {Farbe der Palette wiederherstellen}
			    '-': BEGIN
			      actcol:=SetColor(actpcn,paladr);
				  Hide_Mouse;DrawPalActCol(actcol,zoomscr);Show_Mouse;
			    END;
			    {Paletten umschalten}
			    '*': BEGIN
				  IF palflag=0 THEN palflag:=1 ELSE palflag:=0;
				  {Palettenadresse setzen}
				  IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
							   ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
				  actcol:=SetColor(par.actpcn,paladr);
				  DrawPalette(zoomscr,paladr);
  				  DrawPalActCol(actcol,zoomscr);
			      SetRGBSetter;
			    END;
			    {RGB-Modifikation per Zehner-Tastatur}
			    {$I FKT.INC\RGB_MODI.I}
			END;
			{RGB-Regler aktualisieren}
			IF (key=',') OR (key='.') OR (key='-') OR (key='*') THEN BEGIN
				actcol:=SetColor(actpcn,paladr);
				SetRGBSetter;
			END ELSE 
			{Bei RGB-Modifikation -> Aktualisierungen}
			IF key<>' ' THEN BEGIN
				newcol:=actcol;
				TakeNewRGB;
			END;
			
			Show_Mouse;
		END;

		{linke Maustaste}
		IF mb=1 THEN BEGIN
			{neuen Farbwert bernehmen}
			IF (actbut>=RED) AND (actbut<=BLUE) AND (actcol<>newcol) THEN BEGIN
				PalToUndo;
				TakeNewRGB;
			END;
			{neue Farbe aus der Palette whlen oder mit l.Shift Farbe kopieren}
			IF actbut=PALET THEN BEGIN
				{Hide_Mouse;}
				{in Palette -> neue Farbe aus Palette whlen oder Farbe kopieren}
				IF (MousePosX>(px-2)) AND (MousePosY>(py-2)) AND (MousePosX<(px+215)) AND (MousePosY<(py+25)) THEN BEGIN
					{Wenn linke Shifttaste gedrckt -> Farbe kopieren}
					IF (KbShift(-1) AND 2) <> 0 THEN BEGIN
						{angeklickte Farbe ermitteln}
						blond:=Trunc((MousePosX-px)/6);
				 		IF blond>31 THEN blond:=31;
				 		IF blond<0 THEN blond:=0;
				 		blond:=blond+Trunc((MousePosY-py)/6)*32;
						IF blond>127 THEN Dec(blond,32);
						IF blond<0 THEN blond:=0;
						{blond: angeklickter Paletteneintrag}
						IF actpcn<>blond THEN BEGIN
							{Neuen RGB-Palettenwert setzen}
							SetNewRGB(blond,actcol,paladr);
							{Palette aktualisieren}
							VSync;
							Hide_Mouse;
	   						DrawPalette(zoomscr,paladr);
							Show_Mouse
						END;
					{ansonsten aktuelle Farbe whlen}
					END ELSE BEGIN
						Show_Mouse;
						{angeklickte Farbe ermitteln}
						blond:=Trunc((MousePosX-px)/6);
				 		IF blond>31 THEN blond:=31;
				 		IF blond<0 THEN blond:=0;
				 		blond:=blond+Trunc((MousePosY-py)/6)*32;
						IF blond>127 THEN Dec(blond,32);
						IF blond<0 THEN blond:=0;
						IF actpcn<>blond THEN BEGIN
				 			Hide_Mouse;
							MarkPalCol(0,actpcn,zoomscr);
				 			actpcn:=blond;
							{neue Farbe markieren}
							MarkPalCol(65535,actpcn,zoomscr);
				 			actcol:=SetColor(actpcn,paladr);
				 			{RGB-Regler aktualisieren}
				 			SetRGBSetter;
				 			{Aktuelle Farbe neben Palette zeichnen}
				    		Hide_Mouse;
				    		DrawPalActCol(actcol,zoomscr);
				 			Show_Mouse;
				 		END;
					END;
				END; 
			    Show_Mouse;
			END;
			{neuen Orginalbereich whlen}
			IF actbut=ORGP THEN WITH pic[actscr] DO BEGIN
				Hide_Mouse;
				mx:=MousePosX;
				my:=MousePosY;
				SetMousePos(opx,opy);
				SetMouseRange(rez_x-100,rez_y-99);
				REPEAT
					opx:=MousePosX;
					opy:=MousePosY;
					DrawPEOrgPic(opx,opy,rez_x,adr,zoomscr);
				UNTIL mb=0;
				SetMouseRange(320,240);
				SetMousePos(mx,my);
				Show_Mouse;
			END;
			{Mischpalette editieren}
			IF (actbut=MIX) THEN BEGIN
			  IF (MousePosX>but[MIX].x1+10) AND  
			     (MousePosY>but[MIX].y1+10) AND
			     (MousePosX<but[MIX].x2-10) AND
		    	 (MousePosY<but[MIX].y2-10) 
			  THEN BEGIN
				Hide_Mouse;
				mx:=0;my:=0;
				REPEAT
				  IF (mx<>MousePosX) OR (my<>MousePosY) THEN BEGIN
					mx:=MousePosX;my:=MousePosY;
					IF MX<but[MIX].x1+10 THEN BEGIN
						mx:=but[MIX].x1+10;
						SetMousePos(mx,my);
					END;
					IF MY<but[MIX].y1+10 THEN BEGIN
						my:=but[MIX].y1+10;
						SetMousePos(mx,my);
					END;
					IF MX>but[MIX].x2-10 THEN BEGIN
						mx:=but[MIX].x2-10;
						SetMousePos(mx,my);
					END;
					IF MY>but[MIX].y2-10 THEN BEGIN
						my:=but[MIX].y2-10;
						SetMousePos(mx,my);
			  		END;
			  		CASE actmixcol OF
					  RED_B: Draw_L_Red(MX,MY,zoomscr);
					  GREEN_B: Draw_L_Green(MX,MY,zoomscr);
					  BLUE_B: Draw_L_Blue(MX,MY,zoomscr);
					  WHITE_B: BEGIN
					  	Draw_L_Red(mx,my,zoomscr);
					  	Draw_L_Green(mx,my,zoomscr);
					  	Draw_L_Green(mx,my,zoomscr);
						Draw_L_Blue(mx,my,zoomscr);
					  END;
					  BLACK_B: Draw_L_Black(mx,my,zoomscr);
					END;
					{mx:=MousePosX;my:=MousePosY;}
					{IF actmixcol=GREEN_B THEN Delay(1) ELSE Delay(4);}
				  	Delay(1);
				  END;
				UNTIL (mb=0);{ OR (MousePosX<but[MIX].x1+7)
							 OR (MousePosY<but[MIX].y1+7)
							 OR (MousePosX>but[MIX].x2-7)
							 OR (MousePosY>but[MIX].y2-7);}
				Show_Mouse;
			  END;
			END;
			{Maus auf Farbauswahl-Knpfen fr Mischpalette...}
			IF (actbut>=RED_B) AND (actbut<=BLACK_B) AND (actbut<>actmixcol) THEN BEGIN
				Hide_Mouse;
				WITH but[actbut] DO DrawButton(x1,y1,1,datadr,zoomscr);
				WITH but[actmixcol] DO DrawButton(x1,y1,0,datadr,zoomscr);
				Show_Mouse;
				{Neue aktuelle Lasurfarbe} 
				actmixcol:=actbut;
			END;	 
		END;
		
		{rechte Maustaste}
		IF mb=2 THEN BEGIN 
			CASE actbut OF
				{neue Farbe aus Orginalbild grabben}
				ORGP: 	TakeNewRGB;
				{neue Farbe aus Mischpalette grabben}
				MIX:	TakeNewRGB;
				{Farbverlauf in der Palette erzeugen}
				PALET:	IF  (MousePosX>(px-2)) AND 
				  (MousePosY>(py-2)) AND 
				  (MousePosX<(px+215)) AND 
				  (MousePosY<(py+25)) THEN BEGIN
					{Palette in Undo-Puffer kopieren}
					PalToUndo;
					blond:=Trunc((MousePosX-px)/6);
			 		IF blond>31 THEN blond:=31;
			 		IF blond<0 THEN blond:=0;
			 		blond:=blond+Trunc((MousePosY-py)/6)*32;
					IF blond>127 THEN Dec(blond,32);
					IF blond<0 THEN blond:=0;
					IF actpcn<>blond THEN MakeRange(actpcn,blond);
					REPEAT UNTIL mb=0;
				END;
			END;
		END;

	UNTIL (key=' ') OR (key=#13) OR ((mb=2) AND (actbut=0));
	{Tastaturpuffer lschen}
	WHILE PressedKey DO BEGIN
		keycode:=Crawcin;
		key:=Char(keycode);
	END;
	key:=#255;keycode:=0;
	REPEAT UNTIL mb=0;
	IF par.acttool=BLKPUT THEN MemCFast(scr,buffer,3200);
	{blkflag:=0;}
	SetActPoint(7,7);
	TakeCursor(mousecurs[1]);
	SetMouseScreenAdr(scr);
	Hide_Mouse;
	SetNewScrAdr(scr);
  END;
END;
