{$L PRG.INC\TOOL_SEL.O}		

{PROZEDUREN ZUM SICHERN BZW. WIEDERHERSTELLEN DES BILDHINTERGRUNDES}
PROCEDURE TS_Save_BG(y:LongInt;scradr,bufadr:Pointer);EXTERNAL;
PROCEDURE TS_Restore_BG(y:LongInt;scradr,bufadr:Pointer);EXTERNAL;

PROCEDURE Tool_Select(gx,gy:LongInt;scradr:Pointer);
VAR		but		:Array[1..12] OF RECORD
			x,y		:LongInt;	{relative Buttonpositionen}
			state	:LongInt;	{Buttonstati}
			dat		:Pointer;	{Buttondatenadressen}
		END;
		cx,cy	:Integer;		{x- und y-Position des virtuellen Cursors}
		cnt		:Integer;		{Zhler}
		obn,bn	:Integer;		{Buttonnummer (Hilfsvariable)}
		omx,omy	:Integer;
BEGIN
	{Koordinaten anpassen (zentrierte Darstellung)}
	gx:=gx-24;
	IF gx<0 THEN gx:=0;
	IF gx>270 THEN gx:=270;
	gy:=gy-16;
	IF gy<0 THEN gy:=0;
	IF gy>205 THEN gy:=205;
	
	{alte Mausposition merken (lokale Valiablen!)}
	omx:=MousePosX;
	omy:=MousePosY;

	{Hintergrund sichern}
	TS_Save_BG(gy,scr,zoomscr);
	{Buttons initialisieren}
	FOR cnt:=1 TO 12 DO but[cnt].state:=0;
	but[par.acttool].state:=1;
	obn:=par.acttool;
	WITH but[1]  DO BEGIN x:=0; y:=0; dat:=@B_Draw_Dat;END;
	WITH but[2]  DO BEGIN x:=16;y:=0; dat:=@B_Line_Dat;END;
	WITH but[3]  DO BEGIN x:=32;y:=0; dat:=@B_Rect_Dat;END;
	WITH but[4]  DO BEGIN x:=0; y:=8; dat:=@B_Circle_Dat;END;
	WITH but[5]  DO BEGIN x:=16;y:=8; dat:=@B_Fill_Dat;END;
	WITH but[6]  DO BEGIN x:=32;y:=8; dat:=@B_Poly_Dat;END;
	WITH but[7]  DO BEGIN x:=0; y:=16;dat:=@B_Box_Dat;END;
	WITH but[8]  DO BEGIN x:=16;y:=16;dat:=@B_Zoom_Dat;END;
	WITH but[9]  DO BEGIN x:=32;y:=16;dat:=@B_Cut_Dat;END;
	WITH but[10] DO BEGIN x:=0; y:=24;dat:=@B_Block_Dat;END;
	WITH but[11] DO BEGIN x:=16;y:=24;dat:=@B_Text_Dat;END;
	WITH but[12] DO BEGIN x:=32;y:=24;dat:=@B_Palett_Dat;END;
	{Buttons zeichnen}
	FOR cnt:=1 TO 12 DO WITH but[cnt] DO DrawButton(but[cnt].x+gx,but[cnt].y+gy,state,dat,scradr);
	{virtuelle Cursorpositionen setzen}
	cy:=(par.acttool-1) div 3;
	cx:=par.acttool - (3*cy) -1;
	REPEAT
		
		{Tastendrcke abfangen...}
		key:=#255;
		keycode:=0;
		WHILE PressedKey DO BEGIN
			keycode:=Crawcin;
			key:=Char(keycode);
		END;
		{IF 	(keycode=4915252) OR (keycode=5046326) OR (keycode=4718648) OR (keycode=5242930) THEN BEGIN}
		IF (Byte(keycode)=50) OR (Byte(keycode)=52) OR (Byte(keycode)=54) OR (Byte(keycode)=56) THEN BEGIN
			{alten Button deselektieren}
			bn:=3*cy+cx+1;but[bn].state:=0;
			DrawButton(but[bn].x+gx,but[bn].y+gy,but[bn].state,but[bn].dat,scradr);
			{neuen Button setzen}
			{IF keycode=4915252 THEN Dec(cx);}
			{IF keycode=5046326 THEN Inc(cx);}
			{IF keycode=4718648 THEN Dec(cy);}
			{IF keycode=5242930 THEN Inc(cy);}
			{}IF Byte(keycode)=52 THEN Dec(cx);
			{}IF Byte(keycode)=54 THEN Inc(cx);
			{}IF Byte(keycode)=56 THEN Dec(cy);
			{}IF Byte(keycode)=50 THEN Inc(cy);
			
			{Buttonnummer ermitteln und zeichnen}
			IF cx<0 THEN cx:=2;
			IF cy<0 THEN cy:=3;
			IF cx>2 THEN cx:=0;
			IF cy>3 THEN cy:=0;
			bn:=3*cy+cx+1;
			but[bn].state:=1;
			DrawButton(but[bn].x+gx,but[bn].y+gy,but[bn].state,but[bn].dat,scradr);
		END;
		
		{Wenn Maus bewegt -> Bereichswahlrechteck}
		IF (omx<>MousePosX) OR (omy<>MousePosY) THEN BEGIN
			{Hintergrund wiederherstellen}
			TS_Restore_BG(gy,scr,zoomscr);
			REPEAT
				omx:=MousePosX;omy:=MousePosY;
				FOR cnt:=0 TO 5 DO BEGIN
					gx:=MousePosX-24;
					IF gx<0 THEN gx:=0;
					IF gx>270 THEN gx:=270;
					gy:=MousePosY-16;
					IF gy<0 THEN gy:=0;
					IF gy>205 THEN gy:=205;
					{Gummirechteck}
					RubRect(gx,gy,gx+3*16,gy+4*8,scr);
					VSync;
					RubRect(gx,gy,gx+3*16,gy+4*8,scr);
				END;
			UNTIL (omx=MousePosX) AND (omy=MousePosY);
			{neuen Hintergrund sichern}
			TS_Save_BG(gy,scr,zoomscr);
			{Buttons neu zeichnen}	
			FOR cnt:=1 TO 12 DO WITH but[cnt] DO DrawButton(but[cnt].x+gx,but[cnt].y+gy,state,dat,scradr);
		END;
	
	UNTIL ((KbShift(-1) AND 1) = 0);
	IF obn<>bn THEN BEGIN
		keycode:=111;
		CASE bn OF
			1: key:='D';
			2: key:='L';
			3: key:='R';
			4: key:='C';
			5: key:='F';
			6: key:='P';
			7: key:='B';
			8: key:='Z';
			9: key:=#27;
			10:key:='V';
			11:key:='T';
			12:key:='S';
		END;
	END;
	{Bild wieder restaurieren}
	TS_Restore_BG(gy,scr,zoomscr);
	MemCopy(scr,zoomscr,40*160);
END;

