{FUNKTION ERMITTELT DIE ADRESSE EINES RSC-OBJ-TREES}
FUNCTION GetRSCAdr(re_gtype,re_gindex:Integer):AESTreePtr;
BEGIN
	{Wenn RSC-Daten mitteln RSRC_Load geladen wurden...}
	IF RSC_INC=0 THEN BEGIN
		RSRC_GAddr(re_gtype,re_gindex,Pointer(obj_tree));
		GetRSCAdr:=obj_tree;
	{Wenn RSC-Daten zum Programm gelinkt werden...}
	END{ ELSE BEGIN
		obj_tree:=GetResource(rsc_pool,re_gindex);
		GetRSCAdr:=obj_tree;
	END};
END;


{FUNKTION ZUM ERMITTELN EINES OBJEKTSTATUS}
FUNCTION Get_Obj_State(tree:AESTreePtr;obj:Integer):Integer;
BEGIN
	Get_Obj_State:=tree^[obj].ob_state;
END;


{PROZEDUR ZUM SETZEN EINES OBJEKTSTATUS}
PROCEDURE Set_Obj_State(tree:AESTreePtr;obj,status:Integer);
BEGIN
	tree^[obj].ob_state:=status;
END;


PROCEDURE MoveObjects(winnum,nx,ny:Integer);
VAR		cnt,cnt2	:Integer;
BEGIN
	{bei normalen Fenstern...}
	IF winnum<>PANEL THEN BEGIN
		obj_tree:=getrscadr(R_TREE,win[winnum].dialog);
		cnt:=0;
		REPEAT
			obj_tree^[cnt].ob_x:=nx;
			obj_tree^[cnt].ob_y:=ny;
			cnt:=obj_tree^[cnt].ob_next;
		UNTIL cnt=-1;
	{beim Panelfenster alle Dialoge veraendern}
	END ELSE BEGIN
		FOR cnt2:=1 TO 11 DO BEGIN
			obj_tree:=GetRSCAdr(R_TREE,pandialog[cnt2]);
			cnt:=0;
			REPEAT
				obj_tree^[cnt].ob_x:=nx;
				obj_tree^[cnt].ob_y:=ny;
				cnt:=obj_tree^[cnt].ob_next;
			UNTIL cnt=-1;
		END;
	END;
	
END;



{PROCEDURE HIDES AN OBJECT}
PROCEDURE Hide_Obj(obj:Integer);
BEGIN
	IF (obj_tree^[obj].ob_flags AND HIDETREE)=0 THEN Inc(obj_tree^[obj].ob_flags,HIDETREE);
END;


{PROCEDURE UNHIDES AN OBJECT}
PROCEDURE Unhide_Obj(obj:Integer);
BEGIN
	IF (obj_tree^[obj].ob_flags AND HIDETREE)<>0 THEN Dec(obj_tree^[obj].ob_flags,HIDETREE);
END;


{PROCEDURE DRAWS AN OBJECT}
PROCEDURE DrawObj(obj_tree:AESTreePtr;obj:Integer);
VAR		x,y,w,h	:Integer;
BEGIN
	Objc_Offset(obj_tree,obj,x,y);
	w:=obj_tree^[obj].ob_width;
	h:=obj_tree^[obj].ob_height;
	Objc_Draw(obj_tree,obj,MAX_DEPTH,x-1,y-1,w+2,h+2);
END;

