{ERMITTELT EINGESTELLTEN DATEITYP}
FUNCTION GetFileType:Integer;
VAR	x,y,w,h:Integer;
BEGIN
	GetFileType:=-1;
	{Auswahldialog}
	GetRSCAdr(R_TREE,FORMATE);
	Form_Center(obj_tree,x,y,w,h);
	Form_Dial(FMD_START,x,y,w,h,x,y,w,h);
	Objc_Draw(obj_tree,0,30,x,y,w,h);
	dummy:=Form_Do(obj_tree,0);
	Form_Dial(FMD_FINISH,x,y,w,h,x,y,w,h);
	Set_Obj_State(obj_tree,dummy,NORMAL);
	{Wenn Abbruch angeklickt...-1 als Rckgabewert}
	IF dummy=17 THEN GetFileType:=-1 
	{ansonsten Filetyp ermitteln...}
	ELSE BEGIN
		{Wenn Bild angeklickt...}
		IF Get_Obj_State(obj_tree,FILE_PIC)=SELECTED THEN BEGIN
			IF Get_Obj_State(obj_tree,FILE_PIC_XGA)=SELECTED THEN GetFileType:=XGA;
			IF Get_Obj_State(obj_tree,FILE_PIC_TRP)=SELECTED THEN GetFileType:=TRP;
			IF Get_Obj_State(obj_tree,FILE_PIC_TRU)=SELECTED THEN GetFileType:=TRU;
		END;
		{Wenn Block angeklickt...}
		IF Get_Obj_State(obj_tree,FILE_BLOCK)=SELECTED THEN BEGIN
			IF Get_Obj_State(obj_tree,FILE_BLK_TRP)=SELECTED THEN GetFileType:=TRPBLK;
			IF Get_Obj_State(obj_tree,FILE_BLK_TRU)=SELECTED THEN GetFileType:=TRUBLK;
		END;
		{Wenn Palette angeklickt...}
		IF Get_Obj_State(obj_tree,FILE_PAL)=SELECTED THEN BEGIN
			IF Get_Obj_State(obj_tree,FILE_PAL_EPP)=SELECTED THEN GetFileType:=EPP;
			IF Get_Obj_State(obj_tree,FILE_PAL_INDY)=SELECTED THEN GetFileType:=PAL;
			IF Get_Obj_State(obj_tree,FILE_PAL_GEM)=SELECTED THEN GetFileType:=GEMPAL;
		END;
	END;
END;


FUNCTION GenFName(filetyp:LongInt;oldname:String):String;
VAR	fdir,fname,fext	:String;
BEGIN
	FSplit(oldname,fdir,fname,fext);
	CASE filetyp OF
		XGA:	GenFName:=fname+'.XGA';
		TRU:	GenFName:=fname+'.TRU';
		TRP:	GenFName:=fname+'.TRP';
		TGA:	GenFName:=fname+'.TGA';
		TRUBLK:	GenFName:=fname+'.TRU';
		TRPBLK:	GenFName:=fname+'.TRP';
		EPP:	GenFName:=fname+'.EPP';
		PAL:	GenFName:=fname+'.PAL';
		GEMPAL:	GenFName:=fname+'.PAL';
	END;
END;


{SICHERN ALS...}
PROCEDURE Save_As;
VAR	result		:Integer;
	pfd,nam,ext	:String;
	nam_ext		:String;
BEGIN
	dummy:=GetFileType;
	Wait_Win;
	IF dummy<>-1 THEN BEGIN
	
		{Bild...}
		IF (dummy=XGA) OR (dummy=TRP) OR (dummy=TRU) THEN BEGIN
			Wind_Update(BEG_UPDATE);
			nam_ext:=GenFName(dummy,pic[par.actscr].name);
			Fsel_ExInput(pic[par.actscr].pfad,nam_ext,result,'Bild speichern');
			Wind_Update(END_UPDATE);
			Wait_Win;
			IF result=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				SaveFile(dummy,pic[par.actscr].pfad,nam_ext);
				Graf_Mouse(ARROW,NIL);
				pic[par.actscr].flag:=1;
			END;
			WITH pic[par.actscr] DO BEGIN
				FSplit(nam_ext,pfd,nam,ext);
				name:=nam;		
			END;
		END;
	
		{Block...}
		IF ((dummy=TRPBLK) OR (dummy=TRUBLK)) AND (blkflag=1) THEN BEGIN
			Wind_Update(BEG_UPDATE);
			blkname:=GenFName(dummy,blkname);
			Fsel_ExInput(blkpfad,blkname,result,'Block speichern');
			Wind_Update(END_UPDATE);
			Wait_Win;
			IF result=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				SaveFile(dummy,blkpfad,blkname);
				Graf_Mouse(ARROW,NIL);
				blkfflag:=1;
			END;
		END;	

	
		{Palette...}
		IF (palsaveflag=PALSAVE_ALWAYS) THEN WITH pic[par.actscr] DO BEGIN
			{Wenn Palettenname schon vorhanden...einfach sichern}
			IF palflag=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				palname:=GenFName(EPP,palname);
				SaveFile(EPP,palpfad,palname);
				Graf_Mouse(ARROW,NIL);
			END ELSE dummy:=EPP;
		END;
		IF (palsaveflag=PALSAVE_ASK) OR
			(dummy=EPP) OR (dummy=PAL) OR (dummy=GEMPAL) THEN WITH pic[par.actscr] DO BEGIN

			IF (dummy<>EPP) AND (dummy<>PAL) AND (dummy<>GEMPAL) THEN dummy:=EPP;
	
			{File auswhlen..}
			Wind_Update(BEG_UPDATE);
			palname:=GenFName(dummy,palname);
			Fsel_ExInput(palpfad,palname,result,'Palette speichern');
			Wind_Update(END_UPDATE);
			Wait_Win;
			IF result=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				SaveFile(dummy,palpfad,palname);
				Graf_Mouse(ARROW,NIL);
				palflag:=1;
			END;
		END;
		
	END;
END;


{SICHERN}
PROCEDURE Save;
VAR	result		:Integer;
	nam,pfd,ext	:String;
	nam_ext		:String;
BEGIN 
	dummy:=GetFileType;
	Wait_Win;
	IF dummy<>-1 THEN BEGIN
	
		{Bild...}
		IF (dummy=XGA) OR (dummy=TRP) OR (dummy=TRU) THEN BEGIN
			{Wenn Bildname schon vorhanden...sofort abspeichern}
			IF pic[par.actscr].flag=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				nam_ext:=GenFName(dummy,pic[par.actscr].name);
				SaveFile(dummy,pic[par.actscr].pfad,nam_ext);
				Graf_Mouse(ARROW,NIL);
			END
			{ansonsten erst Datei auswhlen und dann sichern}
			ELSE BEGIN
				Wind_Update(BEG_UPDATE);
				nam_ext:=GenFName(dummy,pic[par.actscr].name);
				Fsel_ExInput(pic[par.actscr].pfad,nam_ext,result,'Bild speichern');
				Wind_Update(END_UPDATE);
				Wait_Win;
				IF result=1 THEN BEGIN
					Graf_Mouse(BUSYBEE,NIL);
					SaveFile(dummy,pic[par.actscr].pfad,nam_ext);
					Graf_Mouse(ARROW,NIL);
					pic[par.actscr].flag:=1;
				END;
				{WITH pic[par.actscr] DO BEGIN
					FSplit(name,pfd,nam,ext);
					name:=nam;		
				END;}
			END;
		END;
		
		{Block...}
		IF ((dummy=TRPBLK) OR (dummy=TRUBLK)) THEN BEGIN
			{Wenn Block vorhanden...}
			IF blkflag=1 THEN BEGIN
				{Wenn Block-Filename schon vorhanden...einfach abspeichern}
				IF blkfflag=1 THEN BEGIN
					Graf_Mouse(BUSYBEE,NIL);
					blkname:=GenFName(dummy,blkname);
					SaveFile(dummy,blkpfad,blkname);
					Graf_Mouse(ARROW,NIL);
				END
				{ansonsten erst Dateiauswahlbox aufrufen}
				ELSE BEGIN
					Wind_Update(BEG_UPDATE);
					blkname:=GenFName(dummy,blkname);
					Fsel_ExInput(blkpfad,blkname,result,'Block speichern');
					Wind_Update(END_UPDATE);
					Wait_Win;
					IF result=1 THEN BEGIN
						Graf_Mouse(BUSYBEE,NIL);
						SaveFile(dummy,blkpfad,blkname);
						Graf_Mouse(ARROW,NIL);
						blkfflag:=1;
					END;
				END;
			END
			{Wenn kein Block vorhanden...}
			ELSE Form_Alert(1,BLKALERT);
		END;

		IF (palsaveflag<>PALSAVE_NEVER) AND ((dummy<>EPP) AND (dummy<>PAL) AND (dummy<>GEMPAL)) THEN dummy:=EPP;
	
		{Palette...}
		IF (palsaveflag=PALSAVE_ALWAYS) OR (dummy=EPP) OR (dummy=PAL) OR (dummy=GEMPAL) THEN WITH pic[par.actscr] DO BEGIN
			{Wenn Palettenname schon vorhanden...einfach sichern}
			IF palflag=1 THEN BEGIN
				Graf_Mouse(BUSYBEE,NIL);
				palname:=GenFName(dummy,palname);
				SaveFile(dummy,palpfad,palname);
				Graf_Mouse(ARROW,NIL);
			END;
		END;
		IF (palsaveflag=PALSAVE_ALWAYS) OR (palsaveflag=PALSAVE_ASK) OR
			(dummy=EPP) OR (dummy=PAL) OR (dummy=GEMPAL) THEN WITH pic[par.actscr] DO BEGIN
			{erst File auswhlen..}
			 IF palflag=0 THEN BEGIN
				Wind_Update(BEG_UPDATE);
				palname:=GenFName(dummy,palname);
				Fsel_ExInput(palpfad,palname,result,'Palette speichern');
				Wind_Update(END_UPDATE);
				Wait_Win;
				IF result=1 THEN BEGIN
					Graf_Mouse(BUSYBEE,NIL);
					SaveFile(dummy,palpfad,palname);
					Graf_Mouse(ARROW,NIL);
					palflag:=1;
				END;
			END;
		END;
	END;
END;





