;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM AUSSCHNEIDEN VON PIXELBLCKEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


export blk_cut			;Kopiert Teil eines Bildes in Blockbuffer
export blk_getw			;Liefert die Breite des Blockes
export blk_geth			;Liefert die Hhe des Blockes

TEXT

blk_cut:
	move.l	4(sp), d3
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;a0:	Quellbild
	;a1:	Ziel: Blockbuffer
	
	;Hhe und Breite ausrechnen (P2 - P1)
	;Breite:
	move.l	d2, d4
	sub.l	d0, d4
	addq.l	#1, d4
	;d4:	Breite
	;Hhe:
	move.l	d3, d5
	sub.l	d1, d5
	addq.l	#1, d5
	;d5:	Hhe

	;Breite und Hhe in den Speicher schreiben
	move.w	d4, (a1)+
	move.w	d5, (a1)+
	
	;Adresse von P1 bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset
	
	;Bildteil in Blockbuffer kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_cut_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_cut_x_loop:
	move.w	(a0)+, (a1)+
	dbf		d3, blk_cut_x_loop
	adda.l	d0, a0
	dbf		d5, blk_cut_y_loop
rts

blk_getw:
	;a0:	Blockadresse
	move.w	(a0), d0
	;d0:	Breite des Blockes
rts

blk_geth:
	;a0:	Blockadresse
	addq.l	#2, a0
	move.w	(a0), d0
	;d0:	Hhe des Blockes
rts


END