;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM BEHANDELN VON BLCKEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export blked_paste
export blked_flip


TEXT

;FGT EINEN BLOCK NORMAL IN EIN BILD EIN
blked_paste:
	;d0:	x-Position	(linke obere Ecke des Blockes)
	;d1:	y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse bestimmen
	adda.l	d1, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_put_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_put_x_loop:
	move.w	(a0)+, (a1)+
	dbf		d3, blk_put_x_loop
	adda.l	d0, a1
	dbf		d5, blk_put_y_loop
rts



;VERTAUSCHT BLOCK UND BILDDATEN (GLEICHE GRSSE)
blked_flip:
	;d0:	x-Position	(linke obere Ecke des Blockes)
	;d1:	y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse bestimmen
	adda.l	d1, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_flip_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_flip_x_loop:
	move.w	(a0), d1
	move.w  (a1), (a0)+
	move.w	d1, (a1)+
	dbf		d3, blk_flip_x_loop
	adda.l	d0, a1
	dbf		d5, blk_flip_y_loop
rts




END