;Norman Feske										24.02.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM HORIZONTALEN SPIEGELN EINES BILDAUSSCHNITTES

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export horizmirr		;Spiegelt Bildbereich

globl  x_rez			;..mu im Hauptprogramm festgelegt sein

TEXT

;ROUTINE ZUM SPIEGELN EINES BILDBEREICHES
horizmirr:
	move.l	4(sp), d3
	;d0:	x1
	;d1:	y1
	;d2:	x2 (mu grer als x1 sein)
	;d3:	y2 (mu grer als y1 sein)
	;a0:	Screenadresse
	
	;Breite berechnen
	sub.l	d0, d2
	;d2:	Breite -1
	
	;Hhe berechnen
	sub.l	d1, d3
	;d3:	Hhe -1
	
	;erste Pixeladresse berechnen
	move.l	a0, a1
	lsl.l	d0
	lsl.l	d1
	mulu.l	x_rez, d1
	add.l	d0, d1
	adda.l	d1, a1
	;a1: erste Pixeladresse
	
	;Line-Offset berechnen
	move.l	x_rez, d6
	move.l	d6, d7
	lsl.l	d7
	sub.l	d2, d6
	subq.l	#1, d6
	lsl.l	d6
	sub.l	d6, d7
	;d6:	Lineoffset
	;d7:	Rest (x_rez - Lineoffset)
	
	;y-Loop mit der Hhe (d3) als Zhler
hm_y_loop:


	
	;xs_loop mit der Breite -1 als Zhler (sichern der Pixel)
	move.l	d2, d4		;Breite-1
	move.l	a1, a2
	lea		buf, a3
	adda.l	d7, a2
hm_xs_loop:
	;Pixel verkehrtherum in Buffer kopieren
	move.w	-(a2), (a3)+
	dbf		d4, hm_xs_loop

	;xp_loop mit der Breite -1 als Zhler (setzen der Pixel)
	move.l	d2, d4		;Breite-1
	lea		buf, a3
hm_xp_loop:
	;Pixel in anderer Reihenfolge in Screen kopieren
	move.w	(a3)+, (a1)+
	dbf		d4, hm_xp_loop
	
	

	;Lineoffset addieren
	adda.l	d6, a1

	dbf		d3, hm_y_loop

rts
;ENDE DER SPIEGELROUTINE


BSS

buf:	ds.w	1000

END