;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM WIEDERHERSTELLEN EINES BILDES NACH EINER BLOCKOP.

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


export blk_restore_bg

TEXT

blk_restore_bg:
	move.l	4(sp), a2
	;d0:	alter x-Wert des Blockes
	;d1:	alter y-Wert
	;a0:	Blockadresse
	;a1:	Screenadresse
	;a2:	Bildspeicheradresse

	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der alten Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse der alten Position im Screen bestimmen
	adda.l	d1, a1
	
	;Adresse der alten Position im Bildspeicher bestimmen
	adda.l	d1, a2
		
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Orginal in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_r_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_r_x_loop:
	move.w	(a2)+, (a1)+
	dbf		d3, blk_r_x_loop
	adda.l	d0, a1
	adda.l	d0, a2
	dbf		d5, blk_r_y_loop

rts



END