;Norman Feske										24.02.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM VERTIKALEN SPIEGELN EINES BILDAUSSCHNITTES

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export vertmirr			;Spiegelt Bildbereich

globl  x_rez			;..mu im Hauptprogramm festgelegt sein

TEXT

;ROUTINE ZUM SPIEGELN EINES BILDBEREICHES
vertmirr:
	move.l	4(sp), d3
	;d0:	x1
	;d1:	y1
	;d2:	x2 (mu grer als x1 sein)
	;d3:	y2 (mu grer als y1 sein)
	;a0:	Screenadresse
	
	;Breite berechnen
	sub.l	d0, d2
	;d2:	Breite -1
	
	;Hhe berechnen
	sub.l	d1, d3
	;d3:	Hhe -1
	
	;erste Pixeladresse berechnen
	move.l	a0, a1
	lsl.l	d0
	lsl.l	d1
	mulu.l	x_rez, d1
	add.l	d0, d1
	adda.l	d1, a1
	;a1: erste Pixeladresse
	
	;Offset berechnen
	move.l	x_rez, d7
	mulu.l	d3, d7
	add.l	x_rez, d7
	lsl.l	d7
	move.l	x_rez, d6
	lsl.l	d6
	;d6:	Line_Offset
	;d7:	Gesamtoffset
	
	;x-Loop mit der Breite (d2) als Zhler
vm_x_loop:


	
	;ys_loop mit der Hhe -1 als Zhler (sichern der Pixel)
	move.l	d3, d4		;Hhe-1
	move.l	a1, a2
	lea		buf, a3
	adda.l	d7, a2
vm_ys_loop:
	;Pixel verkehrtherum in Buffer kopieren
	suba.l	d6, a2
	move.w	(a2), (a3)+
	dbf		d4, vm_ys_loop

	;yp_loop mit der Hhe -1 als Zhler (setzen der Pixel)
	move.l	d3, d4		;Hhe-1
	move.l	a1, a2
	lea		buf, a3
vm_yp_loop:
	;Pixel in anderer Reihenfolge in Screen kopieren
	move.w	(a3)+, (a2)
	adda.l	#640, a2
	dbf		d4, vm_yp_loop
	
	

	;nchste Spalte
	addq.l	#2, a1

	dbf		d2, vm_x_loop

rts
;ENDE DER SPIEGELROUTINE


BSS

buf:	ds.w	1000

END