;Norman Feske										09.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ZEICHNEN EINES AUSGEFLLTEN RECHTECKES

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


export normbox
export drawbox

INCLUDE "NEWPIXEL.INC"


;ZEICHNET EINE NORMALE BOX AUF DEN BILDSCHIRM
normbox:
	;d0:	Farbe
	;d1:	x1
	;d2:	y1
	;4(sp):	x2
	;8(sp)	y2
	;a0:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d4
	
	;1. X KOORDINATEN TESTEN
	cmp.l	d1, d3
	bgt		x_all_right
	exg		d1, d3
x_all_right:
	
	;2. Y KOORDINATEN TESTEN
	cmp.l	d2, d4
	bgt		y_all_right
	exg		d2, d4
y_all_right:

	;3. BOX ZEICHNEN
	move.l	d3, d5
	sub.l	d1, d5					;dx
	move.l	d4, d6
	sub.l	d2, d6					;dy
	;Anfangsadresse errechnen
	move.l	d2, d7
	mulu.w	#640, d7
	lsl.l	d1
	add.l	d1, d7
	adda.l	d7, a0					;abs. Adr. d. l. o. Ecke
	
y_box_loop:

	movem.l	d5/a0, -(sp)

x_box_loop:
	
	move.w	d0, (a0)+

	dbf		d5, x_box_loop


	movem.l	(sp)+, d5/a0
	adda.l	#640, a0

	dbf		d6, y_box_loop

rts


;ZEICHNET EINE BOX UNTER BEACHTUNG DER ZEICHENMODI AUF DEN BILDSCHIRM
drawbox:
	move.l	4(sp), d3
	move.l	8(sp), d4
	move.l	12(sp), mode
	;d0:	Farbe
	;d1:	x1
	;d2:	y1
	;d3:	x2
	;d4:	y2
	;mode:	Zeichenmodus
	;a0:	Bildschirmadresse

	;REGISTER SICHERN
	movem.l	d4-d7/a3-a6, -(sp)
	move.l	d0, d7	

	;X-KOORDINATEN TESTEN UND EVNTL. VERTAUSCHEN
	cmp.l	d1, d3
	bgt		b_x_ok
	exg.l	d1, d3
b_x_ok:

	;Y-KOORDINATEN TESTEN UND EVNTL. VERTAUSCHEN
	cmp.l	d2, d4
	bgt		b_y_ok
	exg.l	d2, d4
b_y_ok:

	;d1,d2 ... Koordinaten der linken, oberen Ecke der Box
	
	;BREITE BERECHNEN
	sub.l	d1, d3
	;d3: 	Breite der Box - 1
	
	;HHE BERECHNEN
	sub.l	d2, d4
	;d4:	Hhe der Box - 1

	;ZEICHENSCHLEIFE
	;hhe - 1 als y-counter
b_y_loop:

	;Breite - 1 als x-counter
	move.l	d3,	d5
	
	;X-Koordinate der l.o.Ecke als Anfangswert fr die x-loop
	move.l	d1, d6
	;d6:	X-Koordinate der l.o. Ecke

b_x_loop:

	;Punkt zeichnen
	;movem.l	d1-d4/a0, -(sp)
	setpix	d6, d2, d7, mode, a0
	;movem.l	(sp)+, d1-d4/a0
	
	;nchstes Pixel
	addq.l	#1, d6
	
	dbf		d5, b_x_loop
	
	;nchste Zeile
	addq.l	#1, d2
	
	dbf		d4, b_y_loop
	
	;REGISTER WIEDERHERSTELLEN
	movem.l	(sp)+, d4-d7/a3-a6
	
rts


bss

mode:	ds.l	1
