;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ZEICHNEN EINES 16X8 PIXEL GROSSEN BUTTONS

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export drawbutton

TEXT

;ZEICHNET 16x8-PIXEL GROSSEN BUTTON AUF DEN BILDSCHIRM
drawbutton:
	;d0:	x
	;d1:	y
	;d2:	Buttonstatus (0..nicht gedrckt, 1..gedrckt)
	;a0:	Buttondatenadresse
	;a1:	Screenadresse
	
	;Zieladress-Offset berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	adda.l	d1, a1
	;a1:	Zieladresse (Screen+Positionsoffset)
	
	;Buttonadresse ist abhngig vom Status
	;(256-Bytes ungedrckter Button / 256-Bytes gedrckter Button)
	cmpi.l	#0, d2
	beq		buttonadr_ok
	adda.l	#256, a0
buttonadr_ok:
	;a0:	Quelladresse

	;Button auf Bildschirm kopieren
	move.l	#7, d0
drawbut_loop1:
	move.l	#15, d1
drawbut_loop2:
	cmpi.w	#0, (a0)
	beq		black_pix
	move.w	(a0), (a1)				;Word-weises kopieren
black_pix:
	addq.l	#2, a0
	addq.l	#2, a1
	dbf		d1, drawbut_loop2
	adda.l	#608, a1
	dbf		d0, drawbut_loop1
rts
	
END