export rotation

TEXT

rotation:
	move.l	4(sp), a2
	move.l	8(sp), a3
	;d0:	Winkel
	;a0:	Sintab
	;a1:	Costab
	;a2:	Quellbild
	;a3:	Zielbild
	
	;push registers
	movem.l	d0-d7/a0-a6, -(sp)
	
	;get cos and sin
	move.l	d0, d2
	move.l	(a0,d2.l*4), d0		;sinus (nich putt machen...fr spter)
	move.l	(a1,d2.l*4), d1		;cosin

	;Anfangspixel berechnen (x=-160+1 ; y=-120+1)
	;umgestellte Rotationsformeln:
	;x=y'sina + x'cosa
	;y=y'cosa - x'sina
	
	move.l	#-160, d2			;x'
	move.l	#-120, d3			;y'
	
	;erstes x berechnen (so richtig mit Rotation und so....)
	move.l	d2, d4
	muls.l	d1, d4				;x'cosa
	move.l	d3, d5
	muls.l	d0, d5				;y'sina
	add.l	d5, d4
	movea.l	d4, a4				
	;a4:	x=y'sina + x'cosa
	
	;asl.l	d0
	;asl.l	d1
	
	;erstes y berechnen
	muls.l	d0, d2				;x'sina
	muls.l	d1, d3				;y'cosa
	sub.l	d2, d3
	movea.l	d3, a5
	;a5:	y=y'cosa - x'sina
	
	;y-loop
	move.l	#240-1, d2
rot_y_loop:

	;x und y wiederherstellen
	move.l	a4, d4
	move.l	a5, d5

	;x-loop
	move.l	#320-1, d3
rot_x_loop:

	;d4:	x
	;d5:	y
	
	;Bildschirmkoordinaten berechnen, testen und evntl. Pixel zeichnen
	move.l	d4, d6
	asr.l	#8, d6
	add.l	#160, d6		;x
	move.l	d5, d7
	asr.l	#8, d7
	add.l	#120, d7		;y
	clr.l	a6				;drawflag	(0..draw)
	;testen...
	cmpi.l	#0, d6			;x<0 ?
	bge		rot_x_ge_0
	addq.l	#1, a6			;drawflag++
rot_x_ge_0:
	cmpi.l	#0, d7			;y<0 ?
	bge		rot_y_ge_0
	addq.l	#1, a6			;drawflag++
rot_y_ge_0:
	cmpi.l	#320, d6		;x>319 ?
	blt		rot_x_lt_320
	addq.l	#1, a6			;drawflag++
rot_x_lt_320:
	cmpi.l	#240, d7		;y>239 ?
	blt		rot_y_lt_240
	addq.l	#1, a6			;drawflag++
rot_y_lt_240:
	
	;Wenn a6 immer noch 0 ist, kann gezeichnet werden (doll, was?)
	;Nu berechnen woh ma de Bildadresse
	clr.l	a0
	tst.l	a6
	bne		rot_black_pixel
	mulu.l	#320, d7		;y*lineoffset + x
	add.l	d6, d7
	move.w	(a2, d7.l*2), a0
rot_black_pixel:
	move.w	a0, (a3)+
	
	;x' um 1 erhhen... x=x+cosa ; y=y-sina
	add.l	d1, d4
	sub.l	d0, d5

	dbf		d3, rot_x_loop

	;y um 1 erhhen... x=x+sina ; y=y+cosa
	adda.l	d0, a4
	adda.l	d1, a5

	dbf		d2, rot_y_loop

	;pull registers
	movem.l	(sp)+, d0-d7/a0-a6

rts