;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ZEICHNEN EINER LINIE

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export line3

line3:
	move.l	4(sp), d3
	move.l	8(sp), d4
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;d4:	Farbe
	;a0:	Bildschirmadresse
	
	;PARAMETER SICHERN
	movea.l	d0, a1
	movea.l	d1, a2
	movea.l	d2, a3
	movea.l	d3, a4
	move.l	d4, col
	movea.l	a0, a5
	
	;FALLUNTERSCHEIDUNG DER X-WERTE
	cmp.l	d0, d2
	bgt		x2_groesser
	beq		x_gleich
	blt		x1_groesser
	bra		line_end
	
	;FALLUNTERSCHEIDUNG DER Y-WERTE
x2_groesser:
	cmp.l	d1, d3
	bgt		x2_y2_groesser
	beq		y_gleich	
	blt		x2_y1_groesser
	bra		line_end
	
x1_groesser:
	cmp.l	d1, d3
	blt		x1_y1_groesser
	beq		y_gleich
	bgt		x1_y2_groesser
	bra		line_end
	
	
	;******************************************************
	;*********        FALL: X2>X1 UND Y2>Y1     ***********
	;******************************************************

x2_y2_groesser:
	
	;BESTIMMEN DER DX UND DY WERTE
	move.l	d2, d6
	sub.l	d0, d6
	;d6:	dx-Wert
	move.l	d3, d7
	sub.l	d1, d7
		
	;FALLUNTERSCHEIDUNG DX>DY ODER DX<DY
	cmp.l	d6, d7
	blt		x2_y2_dx_groesser
	beq		x2_y2_d_gleich
	bgt		x2_y2_dy_groesser
	bra		line_end
	
x2_y2_dx_groesser:
	;ERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	erste Adresse
	move.l	d6, d2			;dx sichern
	move.l	d6, d5
	lsr.l	#2, d5			;Anfangswert
	
x2_y2_dx_loop:

	;PIXEL SETZEN UND X-POSITION IM SPEICHER UM 1 ERHHEN
	bsr		make_color
	move.w	d4, (a0)+
	
	add.l	d7, d5			;Zhler um dy erhhen
	cmp.l	d2, d5			;Prfe auf bertrag
	ble		x2_y2_dx_ok
	
	;WENN BERTRAG AUFGETRETEN
	sub.l	d6, d5			;bertrag als Startwert
	addq.l	#1, d5			;!!!
	subq.l	#1, d7			;dy um 1 erniedrigen
	adda.l	#640, a0		;y-Position erhhen
	
x2_y2_dx_ok:
	dbf		d6, x2_y2_dx_loop	
	bra		line_end
	
	
	
	
x2_y2_dy_groesser:
	;ERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	erste Adresse
	move.l	d7, d2			;dy sichern
	move.l	d7, d5
	lsr.l	#2, d5				;Anfangswert

x2_y2_dy_loop:

	;PIXEL SETZEN UND Y-POSITION IM SPEICHER UM 1 ERHHEN
	bsr		make_color
	move.w	d4, (a0)
	adda.l	#640, a0
	
	add.l	d6, d5			;Zhler um dx erhhen
	cmp.l	d2, d5			;Prfe auf bertrag
	ble		x2_y2_dy_ok
	
	;WENN BERTRAG AUFGETRETEN
	sub.l	d7, d5			;bertrag als Startwert
	addq.l	#1, d5			;!!!
	subq.l	#1, d6			;dx um 1 erniedrigen
	addq.l	#2, a0			;x-Position erhhen
	
x2_y2_dy_ok:
	dbf		d7, x2_y2_dy_loop	
	bra		line_end
	
	
x2_y2_d_gleich:
	;ERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	erste Adresse

x2_y2_d_loop:
	bsr		make_color
	move.w	d4, (a0)
	adda.l	#642, a0
	dbf		d6, x2_y2_d_loop	
	
	bra		line_end
	
	
	;******************************************************
	;*********        FALL: X2>X1 UND Y2<Y1     ***********
	;******************************************************

x2_y1_groesser:
	
	;BESTIMMEN DER DX UND DY WERTE
	move.l	d2, d6
	sub.l	d0, d6
	;d6:	dx-Wert
	move.l	d1, d7
	sub.l	d3, d7
	;d7:	dy-Wert
		
	;FALLUNTERSCHEIDUNG DX>DY ODER DX<DY
	cmp.l	d6, d7
	blt		x2_y1_dx_groesser
	beq		x2_y1_d_gleich
	bgt		x2_y1_dy_groesser
	bra		line_end
	
x2_y1_dx_groesser:
	;UNTERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	unterste Adresse
	move.l	d6, d2			;dx sichern
	move.l	d6, d5
	lsr.l	#2,d5				;Anfangswert


x2_y1_dx_loop:

	;PIXEL SETZEN UND X-POSITION IM SPEICHER UM 1 ERHHEN
	bsr		make_color
	move.w	d4, (a0)+
	
	add.l	d7, d5			;Zhler um dy erhhen
	cmp.l	d2, d5			;Prfe auf bertrag
	ble		x2_y1_dx_ok
	
	;WENN BERTRAG AUFGETRETEN
	sub.l	d6, d5			;bertrag als Startwert
	addq.l	#1, d5			;!!!
	subq.l	#1, d7			;dy um 1 hochzhlen
	suba.l	#640, a0		;y-Position erhhen
	
x2_y1_dx_ok:
	dbf		d6, x2_y1_dx_loop	
	bra		line_end
	
	

x2_y1_dy_groesser:
	;ERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	erste Adresse
	move.l	d7, d2			;dy sichern
	move.l	d7, d5
	lsr.l	#2,d5				;Anfangswert

x2_y1_dy_loop:

	;PIXEL SETZEN UND Y-POSITION IM SPEICHER UM 1 ERHHEN
	bsr		make_color
	move.w	d4, (a0)
	suba.l	#640, a0
	
	add.l	d6, d5			;Zhler um dx erhhen
	cmp.l	d2, d5			;Prfe auf bertrag
	ble		x2_y1_dy_ok
	
	;WENN BERTRAG AUFGETRETEN
	sub.l	d7, d5			;bertrag als Startwert
	addq.l	#1, d5			;!!!
	subq.l	#1, d6			;dx um 1 erniedrigen
	addq.l	#2, a0			;x-Position erhhen
	
x2_y1_dy_ok:
	dbf		d7, x2_y1_dy_loop	
	bra		line_end


x2_y1_d_gleich:
	
	;ERSTE PUNKTADRESSE ERRECHNEN
	move.l	d1, d5
	mulu.l	#640, d5		;y*640 -> y-Position
	adda.l	d5, a0
	move.l	d0, d5
	lsl.l	d5				;x*2 -> bei word-Pixellnge x-Position
	adda.l	d5, a0
	;a0:	erste Adresse
	
x2_y1_d_loop:
	bsr		make_color
	move.w	d4, (a0)
	suba.l	#638, a0
	dbf		d6, x2_y1_d_loop
	
	bra		line_end
	
	
	
	
	;******************************************************
	;*********        FALL: X2<X1 UND Y2<Y1     ***********
	;******************************************************

x1_y1_groesser:
	
	;PUNKTE TAUSCHEN
	exg.l	d0, d2
	exg.l	d1, d3
	
	bra		x2_y2_groesser
	
	
	
	
	;******************************************************
	;*********        FALL: X2<X1 UND Y2>Y1     ***********
	;******************************************************

x1_y2_groesser:
	
	;PUNKTE TAUSCHEN
	exg.l	d0, d2
	exg.l	d1, d3
	
	bra		x2_y1_groesser
	
	
	
	
	;******************************************************
	;*********        FALL: X2=X1 UND Y2<>Y1    ***********
	;******************************************************
	
x_gleich:

	;Y-WERTE ANPASSEN
	cmp.l	d1, d3
	bge		y2_groesser
	exg.l	d1, d3			;Y-Koordinaten tauschen
y2_groesser:

	;DY-ERRECHNEN
	move.l	d3, d5
	sub.l	d1, d5			;dy-Wert
	
	;ANFANGSADRESSE ERRECHNEN
	mulu.l	#640, d1		;640*y1 -> y-Position im Speicher
	lsl.l	d0				;2*x1	-> x-Position als Offset
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Anfangsadresse
	
	;VERTIKALE LINIE ZEICHNEN
y_loop:
	bsr		make_color
	move.w	d4, (a0)
	adda.l	#640, a0
	dbf		d5, y_loop	

	bra		line_end
	
	
	;******************************************************
	;*********        FALL: X2<>X1 UND Y2=Y1    ***********
	;******************************************************
	
y_gleich:

	;X-WERTE ANPASSEN
	cmp.l	d0, d2
	bge		x1_kleiner
	exg.l	d0, d2			;x-Koordinaten tauschen
x1_kleiner:

	;DX-ERRECHNEN
	move.l	d2, d5
	sub.l	d0, d5			;dx-Wert
	
	;ANFANGSADRESSE ERRECHNEN
	mulu.l	#640, d1		;640*y1 -> y-Position im Speicher
	lsl.l	d0				;2*x1	-> x-Position als Offset
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Anfangsadresse
	
	;HORIZONTALE LINIE ZEICHNEN
x_loop:
	bsr		make_color
	move.w	d4, (a0)+
	dbf		d5, x_loop	

	bra		line_end
	
	
	
	
	
	
	
line_end:
	
	;EVENTUELL ANFANGS- UND ENDPUNKT SETZEN
	move.l	a1, d0
	move.l	a2, d1
	mulu.l	#640, d1
	lsl.l	d0
	add.l	d0, d1
	move.l	a5, a0
	adda.l	d1, a0
	bsr		make_color
	cmp.w	(a0), d4
	beq		p_beg_ok
	move.w	d4, (a0)
p_beg_ok:

	move.l	a3, d1
	move.l	a4, d0
	mulu.l	#640, d0
	lsl.l	d1
	add.l	d0, d1
	move.l	a5, a0
	adda.l	d1, a0
	bsr		make_color
	cmp.w	(a0), d4
	beq		p_end_ok
;	move.w	d4, (a0)
p_end_ok:
	
rts		

;BEI FARBWERT -1 -> NEGATIVER HINTERGRUNDFARBWERT
make_color:
	;a0:	Bildpunktadresse
	;d4:	ursprnglicher Farbwert, dann Ergebnis-Farbwert
	move.l	col, d4
	cmp.l	#-1, col
	bne		no_new_color
	move.l	#65535, d4
	sub.w	(a0), d4
no_new_color:
rts

bss

col:	ds.l	1

end