export magiccheck


magiccheck:

	;set return value (no cookie jar installed)
	move.l	#2, d0
	
	;get cookie jar pointer
	movea.l	#$5A0, a0
	cmpi.l	#0, (a0)			;cookie jar installed?
	beq		magiccheck_end
	
	movea.l	(a0), a1
	;a1:	cookie jar pointer
	
	;set return value (magic not installed)
	clr.l	d0
	
	;search...
mc_loop:

	cmpi.l	#'MagX', (a1)		;magic installed ?
	beq		magiccheck_ok
	
	cmpi.l	#0, (a1)			;no cookies left ?
	beq		magiccheck_end
	
	addq.l	#8, a1

	bra		mc_loop

magiccheck_ok:

	;set return value (magic installed)
	move.l	#1, d0

magiccheck_end:

	;d0:	return: 0...No MagiC installed
	;				1...MagiC installed
	;				2...No cookie jar installed
	
rts