;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM KOPIEREN VON SPEICHERBEREICHEN

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export memcfast


;Diese Routine kopiert Speicherblcke relativ schnell.
;Ein Speicherblock besteht aus 48 Bytes.


TEXT

memcfast:
	;d0:	Anzahl der zu kopierenden Speicherblcke
	;a0:	Quelladresse
	;a1:	Zieladresse
	
	movem.l	d0-d7/a0-a6, -(sp)
	
	;Anzahl der zu kopierenden Blcke = Schleifenzhler
	subq.l	#1, d0

	;Kopierschleife
mcf_loop:
	
	;Es werden 48 Bytes auf einmal kopiert.
	movem.l	(a0)+, d1-d7/a2-a6
	movem.l	d1-d7/a2-a6, (a1)
	adda.l	#48, a1

	dbf		d0, mcf_loop

	movem.l	(sp)+, d0-d7/a0-a6

rts



END