;Norman Feske										08.02.96
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM KOPIEREN VON SPEICHERBEREICHEN

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export memdfast


;Diese Routine lscht Speicherblcke relativ schnell.
;Ein Speicherblock besteht aus 48 Bytes.


TEXT

memdfast:
	;d0:	Anzahl der zu lschenden Speicherblcke
	;a0:	Anfangsadresse
	
	movem.l	d0-d7/a0-a6, -(sp)
	
	;Endadresse des letzten Speicherblockes als Startwert
	move.l	d0, d1
	mulu.l	#48, d1
	adda.l	d1, a0
	
	;Register d1-d7 und a2-a6 lschen
	clr.l	d1
	move.l	d1, d2
	move.l	d1, d3
	move.l	d1, d4
	move.l	d1, d5
	move.l	d1, d6
	move.l	d1, d7
	movea.l	d1, a2
	move.l	a2, a3
	move.l	a3, a4
	move.l	a4, a5
	move.l	a5, a6
	
	
	
	;Anzahl der zu kopierenden Blcke = Schleifenzhler
	subq.l	#1, d0

	;Lschschleife
mdf_loop:
	
	;Es werden 48 Bytes auf einmal gelscht.
	movem.l	d1-d7/a2-a6, -(a0)

	dbf		d0, mdf_loop

	movem.l	(sp)+, d0-d7/a0-a6

rts



END