;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM ZEICHNEN EINES VIERECKES

;sie kann mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export rectang

INCLUDE "PSH_MKRO.INC"
INCLUDE "XOR_MKRO.INC"

TEXT

rectang:
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;4(sp)	y2
	;8(sp):	Farbe
	;a0:	Bildschirmadresse
	move.l	4(sp), d3
	move.l	8(sp), d4

	;Vertikale Linien zeichnen
	cmp.l	d1, d3
	bgt		y2_groesser
	exg.l	d1, d3
y2_groesser:
	cmp.l	d1, d3
	beq		no_v_l

	movem.l	d0-d3, -(sp)
	sub.l	d1, d3
v_l_loop:

	addq.l	#1, d1
	bsr		r_pix
	exg.l	d2, d0
	bsr		r_pix
	exg.l	d2, d0
	subq.l	#1, d3
	cmpi.l	#1, d3
	ble		v_l_end
	bra		v_l_loop
v_l_end:
	movem.l (sp)+, d0-d3
no_v_l:

	;Horizontale Linien zeichnen
	cmp.l	d0, d2
	bgt		x2_groesser
	exg.l	d0, d2
x2_groesser:
	cmp.l	d0, d2
	beq		no_h_l

	movem.l	d0-d3, -(sp)
	sub.l	d0, d2
h_l_loop:
	
	bsr		r_pix
	exg.l	d3, d1
	bsr		r_pix
	exg.l	d3, d1
	addq.l	#1, d0
	
	dbf		d2, h_l_loop
	movem.l (sp)+, d0-d3
no_h_l:
	
rts

;ZUM ZEICHNEN EINES PIXELS
r_pix:
	;d0:	x
	;d1:	y
	;d4:	color
	;a0:	screen
	movem.l	d0-d4/a0, -(sp)
	
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	cmpi.l	#-1, d4
	bgt		no_xor_r
	MAKE_XOR a0, d4
no_xor_r:
	move.w	d4, (a0)
	
	movem.l	(sp)+, d0-d4/a0
rts

END