export rotation

TEXT

rotation:
	move.l	4(sp), a2
	move.l	8(sp), a3
	;d0:	Winkel
	;a0:	Sintab
	;a1:	Costab
	;a2:	Quellbild
	;a3:	Zielbild
	
	;push registers
	movem.l	d0-d7/a0-a6, -(sp)
	
	;get cos and sin
	move.l	(a0,d0.l*4), d3		;sinus
	move.l	(a1,d0.l*4), d4		;cosin
	
	;y-loop
	move.l	#240-1, d1
	move.l	#-120+1, a5
rot_y_loop:

	;x-loop
	move.l	#320-1, d2
	move.l	#-160+1, a6
rot_x_loop:

	;clear "nodraw"-flag
	clr.l	a4

	;calculate x-position in original picture
	move.l	a6, d6
	;d6:	rel.x'-position
	move.l	a5, d5
	;d5:	rel.y'-position
	;x=y'sina + x'cosa
	muls.l	d3, d5			;sin
	muls.l	d4, d6			;cos
	add.l	d5, d6
	add.l	#4*128, d6		;wg.Divisionsrest
	asr.l	#8, d6
	add.l	#160, d6
	;d6:	x position in original picture
	;Test:
	bgt		x_gr_0
	addq.l	#1, a4
x_gr_0:
	cmpi.l	#320, d6
	blt		x_low_320
	addq.l	#1, a4
x_low_320:

	;calculate y-position in original picture
	move.l	a6, d5
	;d5:	rel. x'-position
	move.l	a5, d7
	;d7:	rel. y'-position
	;y=y'cosa - x'sina
	muls.l	d4, d7			;cos
	muls.l	d3, d5			;sin
	sub.l	d5, d7
	add.l	#4*128, d7		;wg.Divisionsrest
	asr.l	#8, d7
	add.l	#120, d7
	;d7:	y position in original picture
	;test:
	bge		y_gr_0
	addq.l	#1, a4
y_gr_0:
	cmpi.l	#240, d7
	blt		y_low_200
	addq.l	#1, a4
y_low_200:
	
	;set pixel (d5: color)
	clr.w	d5
	tst.l	a4
	bne		black
	;calculate adress offset
	mulu.l	#320, d7
	add.l	d6, d7
	move.w	(a2, d7.l*2), d5
black:
	
	move.w	d5, (a3)+

	;next x-position
	addq.l	#1, a6


	dbf		d2, rot_x_loop

	;next y-position
	addq.l	#1, a5

	dbf		d1, rot_y_loop

	;pull registers
	movem.l	(sp)+, d0-d7/a0-a6

rts