export drawchar
export clrchar

TEXT

;ROUTINE ZUM ZEICHNEN EINES BUCHSTABENS
drawchar:
	;d0:	x
	;d1:	y
	;d2:	Char
	;a0:	Font
	;a1:	Screen
	;4(sp): Farbe
	
	move.l	4(sp), d4
	
	;Adresse berechnen
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d1, d0
	adda.l	d0, a1
	;a1:	Adresse des Zeichens auf dem Screen
	
	;Adresse des Zeichens im Font ermitteln
	divu.w	#80, d2
	;d2:	Loword: Zeile
	;d2:	Hiword:	Spalte

	clr.l	d0
	move.w	d2, d0
	lsl.l	#4, d0			;Zeichenhhe: 16
	mulu.w	#80, d0			;Tabellenbreite: 80
	
	swap	d2
	add.w	d2, d0
	adda.l	d0, a0
	;a0:	Zeichenadresse
	
	;Zeichen in Screen kopieren
	move.l	#15, d2
dc_loopy:
	move.b	(a0), d0		;d0: Pixel der 1 Zeichenzeile
	clr.l	d1
	move.l	#7, d3
dc_loopx:
	btst	d3, d0
	beq		dc_no_pix
	move.w	d4, (a1,d1.l*2)
dc_no_pix:
	addq.l	#1, d1
	dbf		d3, dc_loopx
	;nchste Zeile
	adda.l	#80, a0			;Zeichen
	adda.l	#640, a1		;Screen
	dbf		d2, dc_loopy
rts


;ROUTINE ZUM LSCHEN EINES BUCHSTABENS
clrchar:
	;d0:	x
	;d1:	y
	;d2:	width of the picture
	;a0:	Orginalbild
	;a1: 	Screen
	
	;Adresse berechnen
	move.l	d1,d3
	mulu.w	d2,d3
	add.l	d0,d3
	lsl.l	d3
	adda.l	d3,a0
	mulu.w	#320,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a1
	;a0:	Adresse des Zeichens auf dem Orginalbild
	;a1:	Adresse des Zeichens auf dem Screen
	
	lsl.l	d2

	;alte Pixel in Screen kopieren
	move.l	#15, d4
cc_loopy:

	move.l	#7, d3
cc_loopx:
	move.w	(a0,d3.l*2), (a1,d3.l*2)
	dbf		d3, cc_loopx
	
	;nchste Zeile
	adda.l	d2, a0		;Orginalbild
	adda.l	#640, a1		;Screen

	dbf		d4, cc_loopy
rts



END